<?php

namespace App\Http\Controllers;

use Illuminate\Http\Request;

use App\Http\Requests;
use App\Http\Controllers\Controller;
use JWTAuth;
use Tymon\JWTAuth\Exceptions\JWTException;
use Response;
use App\Models\User;
use Auth;
class AuthenticateController extends Controller
{
    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */

    public function getAuthenticatedUser()
    {
        try {

            if (! $user = JWTAuth::parseToken()->authenticate()) {
                return response()->json(['user_not_found'], 404);
            }

        } catch (Tymon\JWTAuth\Exceptions\TokenExpiredException $e) {

            return response()->json(['token_expired'], $e->getStatusCode());

        } catch (Tymon\JWTAuth\Exceptions\TokenInvalidException $e) {

            return response()->json(['token_invalid'], $e->getStatusCode());

        } catch (Tymon\JWTAuth\Exceptions\JWTException $e) {

            return response()->json(['token_absent'], $e->getStatusCode());

        }

        // the token is valid and we have found the user via the sub claim
        $role=\DB::table('roles')
                ->where('id', $user->role_id)
                ->first();
       return  response::json(['reponse' =>'success','user'=>$user,'role'=>$role->slug]);
    }

    public function authenticate(Request $request){
       $data = json_decode($request->getContent());
       if(isset($data->email)) 
        $credentials['email'] = $data->email;
       if(isset($data->token_for_business))
        $credentials['token_for_business'] = $data->token_for_business;

        $credentials['password'] = $data->password;

        try {
            // verify the credentials and create a token for the user
            if (! $token = JWTAuth::attempt($credentials)) {
                return response()->json(['reponse' => 'invalid_credential'], 401);
            }
        } catch (JWTException $e) {
            // something went wrong
            return response()->json(['reponse' => 'could_not_create_token'], 500);
        }
    
        $user = Auth::user();
        $role=\DB::table('roles')
                ->where('id', $user->role_id)
                ->first();

        if($user->confirmed){
        // if no errors are encountered we can return a JWT
        return  response::json(['reponse' =>'success','token' =>$token,'user'=>$user,'role'=>$role->slug]);
        }
        else{
            return response()->json(['reponse' => 'account_not_active']);
        }
    }
    public function Register(Request $request){
         $data = json_decode($request->getContent());
         $find= \DB::table('users')
                ->where('email', $data->email)
                ->first();
                if(empty($find)){
                    $find1= \DB::table('users')
                ->where('username', $data->username)
                ->first();
                if(empty($find1)){
                    if(!empty($data->picture)) $avatar=$data->picture;
                    else $avatar="img/avatar/avatar3.png";
                    $user=new User();
                    $user->username=$data->username;
                    $user->email=$data->email;
                    $user->password=bcrypt($data->password);
                    $user->confirmed = true;
                    $user->avatar = $avatar;
                    $user->cellphone =$data->phone;
                    $user->facebook_id =$data->userID;
                    $user->token_for_business =$data->token_for_business;
                    $user->device_id =$data->device_id;
                    $role_user = \DB::table('roles')
                    ->where('slug', 'user')->first();
                    $user->role_id = $role_user->id;
                    $user->seen = 'true';
                    $user->save();
                    //return  response::json(['result' =>'success']);
                    $credentials['email'] = $data->email;
                    $credentials['password'] = $data->password;
                    $token = JWTAuth::attempt($credentials);
                    return  response::json(['result' =>'success','token' =>$token,'user'=>$user]);

                } else return  response::json(['result' =>'username']);
                } return  response::json(['result' =>'email']); 
    }

    public function forgotPassword(Request $request){
         $data = json_decode($request->getContent());
         $find= \DB::table('users')
                ->where('email', $data->email)
                ->first();
                if(empty($find)) return  response::json(['reponse' =>'email']);

                    $find1= \DB::table('users')
                ->where('email', $data->email)
                ->where('confirmation_code', $data->code)
                ->first();
                if(empty($find1)) return  response::json(['reponse' =>'bad_code']);

                \DB::table('users')
                ->where('email', $data->email)
                ->update([
                    'confirmation_code' =>null,
                    'password' =>bcrypt($data->password)
                ]);

                    $credentials['email'] = $data->email;
                    $credentials['password'] = $data->password;
                    $token = JWTAuth::attempt($credentials);
                    return  response::json(['reponse' =>'success','token' =>$token,'user'=>$find]);

                
    }

}
