<?php

namespace App\Http\Controllers;

//use Illuminate\Http\Request;

use GuzzleHttp\Client;
use Dompdf\FrameDecorator\NullFrameDecorator;
use Input;
use Response;
use Request;
use Illuminate\Support\Facades\Auth;
use JWTAuth;
use Tymon\JWTAuth\Exceptions\JWTException;
use DB;
use Carbon\Carbon;
use Mail;
use PushNotification;
use Facebook;
use Facebook\Helpers\FacebookRedirectLoginHelper;
use Facebook\FacebookSDKException;
use Facebook\Authentication\OAuth2Client;
use Snowfire\Beautymail\Beautymail;


use Codebird\Codebird;


//use Illuminate\Http\Request;

use App\Http\Requests;


use Session;


use JWTAuthException;

use Illuminate\Support\Facades\Redis;
use DateTime;

use Notifiable;

use Berkayk\OneSignal\OneSignalFacade;

use Spatie\PdfToText\Pdf;



class ConsultantController extends Controller
{

    //permet de save un consultant
    public function postConsultant($token){
        $request = Request::instance();
        $data = json_decode($request->getContent());

        //je vérifie le token
        $check = \DB::table('users')
            ->where('remember_token','=',$token)
            ->first();

        if(empty($check)){
            return response()->json(['user_not_found' => true], 401);
        }    

        $user_id = $check->id;

        $liste_CV = $data->liste_CV;        //contient le tableau JSON des CVs du consultant. Format liste_CV = [{"CV":"string"},{"CV":"string"},{...}]
        $statut_id = $data->statut_id;
        $disponibilite_id = $data->disponibilite_id;
        $recommandation_id = $data->recommandation_id;
        $recommandation_name = $data->recommandation_name;
        $nom = $data->nom;
        $prenom = $data->prenom;
        $dateNaissance = $data->dateNaissance;      //format aaaa-mm-jj
        $sexe = $data->sexe;        //format sexe = M ou F
        $pays = $data->pays;
        $ville = $data->ville;
        $niveau_formation_id = $data->niveau_formation_id;
        $liste_profil = $data->liste_profil;        //contient le tableau JSON des profils du consultant. Format liste_profile = [{"profil_id":value},{"profil_id":value},{...}]
        $date1ereExperiencePro = $data->date1ereExperiencePro;      //format aaaa-mm-jj
        $date1ereExperienceEnTantQueConsultant = $data->date1ereExperienceEnTantQueConsultant;      //format aaaa-mm-jj
        $liste_experience_geographique = $data->liste_experience_geographique;      //contient le tableau JSON d'expériences géographique du consultant. Format liste_experience_geographique = [{"experience_geographique_id":value},{"experience_geographique_id":value},{...}]
        $experienceAvecCooperationAllemande = $data->experienceAvecCooperationAllemande;    // 0 pour non et 1 pour oui
        $experienceAvecLesNationsUnies = $data->experienceAvecLesNationsUnies;          //0 pour non et 1 pour oui
        $experienceAvecLesAutresPartenaires = $data->experienceAvecLesAutresPartenaires;          //0 pour non et 1 pour oui
        $liste_domaine_expertise = $data->liste_domaine_expertise;      //contient le tableau JSON des domaines d'expertise du consultant. Format liste_domaine_expertise = [{"domaine_id":value, "nbre_consultation":value},{"domaine_id":value, "nbre_consultation":value},{...}]
        $adresse = $data->adresse;
        $liste_telephone = $data->liste_telephone;      //contient le tableau JSON des téléphones du consultant. Format liste_telephone = [{"telephone":value},{"telephone":value},{...}]
        $liste_courriel = $data->liste_courriel;        //contient le tableau JSON des emails du consultant. Format liste_courriel = [{"email":value},{"email":value},{...}]

        $type = "consultant";   //type = consultant ou cabinet_bureau_etude ou ong_association

        $created_at = Carbon::now();
        $updated_at = Carbon::now();

        //dd(sizeof($liste_experience_geographique));

        //if((sizeof($liste_CV) == 0) || $statut_id == NULL || $disponibilite_id == NULL || $recommandation_id == NULL || $nom == NULL
        //    || $prenom == NULL || $dateNaissance == NULL || $sexe == NULL || $pays == NULL || $ville == NULL || $niveau_formation_id == NULL
        //    || (sizeof($liste_profil) == 0) || $date1ereExperiencePro == NULL || $date1ereExperienceEnTantQueConsultant == NULL
        //    || (sizeof($liste_experience_geographique) == 0) || /*$experienceAvecCooperationAllemande == NULL || $experienceAvecLesNationsUnies == NULL
        //    ||*/ (sizeof($liste_domaine_expertise) == 0) || $adresse == NULL || (sizeof($liste_telephone) == 0) || (sizeof($liste_courriel) == 0)){

        //    return response()->json(['message' => 'error', 'remplir_tous_les_champs' => true, 'statut_id_not_exist' => false, 'disponibilite_id_not_exist' => false,
        //                             'recommandation_id_not_exist' => false, 'niveau_formation_id_not_exist' => false, 'profil_id_not_exist' => false,
        //                             'experience_geographique_id_not_exist' => false, 'domaine_id_not_exist' => false], 400);

        //}

        //on vérifie si le statut_id existe dans la table statut
        if($statut_id != NULL){
            $check = \DB::table('statut')
                ->where('id','=',$statut_id)
                ->first();

            if(empty($check)){
                return response()->json(['message' => 'error', 'remplir_tous_les_champs' => false, 'statut_id_not_exist' => true, 'disponibilite_id_not_exist' => false,
                                        'recommandation_id_not_exist' => false, 'niveau_formation_id_not_exist' => false, 'profil_id_not_exist' => false,
                                        'experience_geographique_id_not_exist' => false, 'domaine_id_not_exist' => false], 400);
            }
        }
    

        //on vérifie si disponibilite_id existe dans la table disponibilite
        if($disponibilite_id != NULL){
            $check = \DB::table('disponibilite')
                ->where('id','=',$disponibilite_id)
                ->first();

            if(empty($check)){
                return response()->json(['message' => 'error', 'remplir_tous_les_champs' => false, 'statut_id_not_exist' => false, 'disponibilite_id_not_exist' => true,
                                        'recommandation_id_not_exist' => false, 'niveau_formation_id_not_exist' => false, 'profil_id_not_exist' => false,
                                        'experience_geographique_id_not_exist' => false, 'domaine_id_not_exist' => false], 400);
            }
        }
        

        //on vérifie si recommandation_id existe dans la table recommandation
        $check = \DB::table('recommandation')
            ->where('id','=',$recommandation_id)
            ->first();

        if(empty($check)){
            /*return response()->json(['message' => 'error', 'remplir_tous_les_champs' => false, 'statut_id_not_exist' => false, 'disponibilite_id_not_exist' => false,
                                     'recommandation_id_not_exist' => true, 'niveau_formation_id_not_exist' => false, 'profil_id_not_exist' => false,
                                     'experience_geographique_id_not_exist' => false, 'domaine_id_not_exist' => false], 400);*/
            
            //I check if recommandation_name already exist
            $check_recommandation = \DB::table('recommandation')
                ->where('intitule','=',$recommandation_name)
                ->first();

            if(empty($check_recommandation)){
                \DB::table('recommandation')
                    ->insert([
                        [
                            'intitule' => $recommandation_name,
                            'description' => $recommandation_name,
                            'created_at' => Carbon::now(),
                            'updated_at' => Carbon::now()
                        ]
                    ]);

                $recommandation_id = DB::getPdo()->lastInsertId();

            }
            else{
                $recommandation_id = $check_recommandation->id;
            }

        }

        //on vérifie si niveau_formation_id existe dans la table niveau_formation
        if($niveau_formation_id != NULL){
            $check = \DB::table('niveau_formation')
                ->where('id','=',$niveau_formation_id)
                ->first();

            if(empty($check)){
                return response()->json(['message' => 'error', 'remplir_tous_les_champs' => false, 'statut_id_not_exist' => false, 'disponibilite_id_not_exist' => false,
                                        'recommandation_id_not_exist' => false, 'niveau_formation_id_not_exist' => true, 'profil_id_not_exist' => false,
                                        'experience_geographique_id_not_exist' => false, 'domaine_id_not_exist' => false], 400);
            }
        }
        

        //on vérifie si profil_id existe dans la table profil
        if(sizeof($liste_profil) != 0){
            for($i=0; $i<sizeof($liste_profil); $i++){
                $profil_id = $liste_profil[$i]->profil_id;

                $check = \DB::table('profil')
                    ->where('id','=',$profil_id)
                    ->first();
                if(empty($check)){
                    return response()->json(['message' => 'error', 'remplir_tous_les_champs' => false, 'statut_id_not_exist' => false, 'disponibilite_id_not_exist' => false,
                                             'recommandation_id_not_exist' => false, 'niveau_formation_id_not_exist' => false, 'profil_id_not_exist' => true,
                                             'experience_geographique_id_not_exist' => false, 'domaine_id_not_exist' => false], 400);
                }
            }
        }

        //on vérifie si experience_geographique_id existe dans la table experience_geographique
        if(sizeof($liste_experience_geographique) != 0){
            for($i=0; $i<sizeof($liste_experience_geographique); $i++){
                $experience_geographique_id = $liste_experience_geographique[$i]->experience_geographique_id;

                $check = \DB::table('experience_geographique')
                    ->where('id','=',$experience_geographique_id)
                    ->first();
                if(empty($check)){
                    return response()->json(['message' => 'error', 'remplir_tous_les_champs' => false, 'statut_id_not_exist' => false, 'disponibilite_id_not_exist' => false,
                                             'recommandation_id_not_exist' => false, 'niveau_formation_id_not_exist' => false, 'profil_id_not_exist' => false,
                                             'experience_geographique_id_not_exist' => true, 'domaine_id_not_exist' => false], 400);
                }
            }
        }

        //on vérifie si domaine_id existe dans la table domaines
        if(sizeof($liste_domaine_expertise) != 0){
            for($i=0; $i<sizeof($liste_domaine_expertise); $i++){
                $domaine_id = $liste_domaine_expertise[$i]->domaine_id;

                $check = \DB::table('domaines')
                    ->where('id','=',$domaine_id)
                    ->first();
                if(empty($check)){
                    return response()->json(['message' => 'error', 'remplir_tous_les_champs' => false, 'statut_id_not_exist' => false, 'disponibilite_id_not_exist' => false,
                                             'recommandation_id_not_exist' => false, 'niveau_formation_id_not_exist' => false, 'profil_id_not_exist' => false,
                                             'experience_geographique_id_not_exist' => false, 'domaine_id_not_exist' => true], 400);
                }
            }
        }

        //je calcule une fois l'âge du consultant
        //obtention de l'année à partir de la date de naissance
        $annee_tableau = explode("-", $dateNaissance);
        $annee_dateNaissance = (int) $annee_tableau[0];

        //obtention de l'année courante
        //$annee_courante = Carbon::now();
        $annee_courante = date('Y');
        $annee_courante = (int) $annee_courante;

        $age = $annee_courante - $annee_dateNaissance; 

        //je calcule le nbre année d'expérience pro
        $annee_tableau = explode("-", $date1ereExperiencePro);
        $annee_experience_pro = (int) $annee_tableau[0];

        //obtention de l'année courante
        //$annee_courante = Carbon::now();
        $annee_courante = date('Y');
        $annee_courante = (int) $annee_courante;

        $nbre_annee_experience_pro = $annee_courante - $annee_experience_pro; 

        //j'enregistre d'abord les infos principales de la table consultant
        \DB::table('consultant')
            ->insert([
                [
                    'user_id' => $user_id,
                    'statut_id' => $statut_id,
                    'disponibilite_id' => $disponibilite_id,
                    'recommandation_id' => $recommandation_id,
                    'nom' => $nom,
                    'prenom' => $prenom,
                    'dateNaissance' => $dateNaissance,
                    'age' => $age,
                    'sexe' => $sexe,
                    'pays' => $pays,
                    'ville' => $ville,
                    'niveau_formation_id' => $niveau_formation_id,
                    'date1ereExperiencePro' => $date1ereExperiencePro,
                    'nbre_annee_experience_pro' => $nbre_annee_experience_pro,
                    'date1ereExperienceEnTantQueConsultant' => $date1ereExperienceEnTantQueConsultant,
                    'experienceAvecCooperationAllemande' => $experienceAvecCooperationAllemande,
                    'experienceAvecLesNationsUnies' => $experienceAvecLesNationsUnies,
                    'experienceAvecLesAutresPartenaires' => $experienceAvecLesAutresPartenaires,
                    'adresse' => $adresse,
                    'created_at' => Carbon::now(),
                    'updated_at' => Carbon::now()
                ]
            ]);

        //maintenant je récupère le user_id pour pouvoir save les autres infos CVs, profils, experience_geographique, domaines, contacts et courriels
        $user = \DB::table('consultant')
            ->where('user_id','=',$user_id)
            ->where('statut_id','=',$statut_id)
            ->where('disponibilite_id','=',$disponibilite_id)
            ->where('recommandation_id','=',$recommandation_id)
            ->where('nom','=',$nom)
            ->where('prenom','=',$prenom)
            ->where('dateNaissance','=',$dateNaissance)
            ->where('age','=',$age)
            ->where('sexe','=',$sexe)
            ->where('pays','=',$pays)
            ->where('ville','=',$ville)
            ->where('niveau_formation_id','=',$niveau_formation_id)
            ->where('date1ereExperiencePro','=',$date1ereExperiencePro)
            ->where('nbre_annee_experience_pro','=',$nbre_annee_experience_pro)
            ->where('date1ereExperienceEnTantQueConsultant','=',$date1ereExperienceEnTantQueConsultant)
            ->where('experienceAvecCooperationAllemande','=',$experienceAvecCooperationAllemande)
            ->where('experienceAvecLesNationsUnies','=',$experienceAvecLesNationsUnies)
            ->where('experienceAvecLesAutresPartenaires','=',$experienceAvecLesAutresPartenaires)
            ->where('adresse','=',$adresse)
            ->first();

        if(!empty($user)){
            $user_id = $user->id;
            $ref_user = 'Consultant_'.str_random(10).$user_id;

            //j'update ref_user dans la table consultant
            \DB::table('consultant')
                ->where('id','=',$user_id)
                ->update([
                    'ref_user' => $ref_user
                ]);


            //j'enregistre d'abord les CVs du consultant
            //define('UPLOAD_DIR','/home/mooevents/public_html/img/uploads/');
            //define('UPLOAD_DIR','/Applications/MAMP/htdocs/giz_frontend/public/img/uploads/CVs/');
            //define('UPLOAD_DIR','/home/apivisavis/public_html/giz/img/uploads/CVs/');
            define('UPLOAD_DIR','/usr/www/users/amberm/public/img/uploads/CVs/');

            if($liste_CV != ""){
                if(sizeof($liste_CV) != 0){
                    for($i=0; $i<sizeof($liste_CV); $i++){
    
                        $ref_cv = str_random(4);
    
                        $pdf = $liste_CV[$i]->CV;
                        $data = base64_decode($pdf);
                        //$nom = uniqid() . '.pdf';
                        $name = 'CV_'.$nom.'_'.$prenom.'_'.'Ref_'.$ref_cv. '.pdf';
                        $file = UPLOAD_DIR . $name;
                        $chemin='img/uploads/CVs/'.$name ;
                        file_put_contents($file, $data);        //pour upload le fichier dans le dossier du chemin UPLOAD_DIR
    
                        //extraction du contenu du cv et stockage
                        $text = (new Pdf())
                            ->setPdf($file)
                            ->text();
    
                        \DB::table('cv_users')
                            ->insert([
                                [
                                    'cv' => $chemin,
                                    'cv_en_base_64' => $pdf,
                                    'ref_user' => $ref_user,
                                    'ref_cv' => $ref_cv,
                                    'contenu_cv' => $text,
                                    'created_at' => Carbon::now(),
                                    'updated_at' => Carbon::now()
                                ]
                            ]);
                    }
                }
            }
            

            //j'enregistre les profils du consultant
            if(sizeof($liste_profil) != 0){
                for($i=0; $i<sizeof($liste_profil); $i++){
                    $profil_id = $liste_profil[$i]->profil_id;

                    \DB::table('profil_users')
                        ->insert([
                            [
                                'profil_id' => $profil_id,
                                'ref_user' => $ref_user,
                                'type' => $type,
                                'created_at' => Carbon::now(),
                                'updated_at' => Carbon::now()
                            ]
                        ]);
                }
            }

            //j'enregistre les expériences géographiques du consultant
            if(sizeof($liste_experience_geographique) != 0){
                for($i=0; $i<sizeof($liste_experience_geographique); $i++){
                    $experience_geographique_id = $liste_experience_geographique[$i]->experience_geographique_id;

                    \DB::table('experience_geographique_users')
                        ->insert([
                            [
                                'experience_geographique_id' => $experience_geographique_id,
                                'ref_user' => $ref_user,
                                'type' => $type,
                                'created_at' => Carbon::now(),
                                'updated_at' => Carbon::now()
                            ]
                        ]);
                }
            }

            //j'enregistre les domaines d'expertise et professionnels du consultant
            if(sizeof($liste_domaine_expertise) != 0){
                for($i=0; $i<sizeof($liste_domaine_expertise); $i++){
                    $domaine_id = $liste_domaine_expertise[$i]->domaine_id;
                    $nbre_consultation = $liste_domaine_expertise[$i]->nbre_consultation;

                    \DB::table('domaine_expertise_users')
                        ->insert([
                            [
                                'domaine_id' => $domaine_id,
                                'nbre_consultation' => $nbre_consultation,
                                'ref_user' => $ref_user,
                                'type' => $type,
                                'created_at' => Carbon::now(),
                                'updated_at' => Carbon::now()
                            ]
                        ]);
                }
            }

            //j'enregistre les téléphones du consultant
            if(sizeof($liste_telephone) != 0){
                for($i=0; $i<sizeof($liste_telephone); $i++){
                    $telephone = $liste_telephone[$i]->telephone;

                    \DB::table('contact_users')
                        ->insert([
                            [
                                'telephone' => $telephone,
                                'ref_user' => $ref_user,
                                'type' => $type,
                                'created_at' => Carbon::now(),
                                'updated_at' => Carbon::now()
                            ]
                        ]);
                }
            }

            //j'enregistre les courriels (emails) du consultant
            if(sizeof($liste_courriel) != 0){
                for($i=0; $i<sizeof($liste_courriel); $i++){
                    $email = $liste_courriel[$i]->email;

                    \DB::table('courriel_users')
                        ->insert([
                            [
                                'email' => $email,
                                'ref_user' => $ref_user,
                                'type' => $type,
                                'created_at' => Carbon::now(),
                                'updated_at' => Carbon::now()
                            ]
                        ]);
                }
            }

        }

        return response()->json(['message' => 'success']);
    }


        //permet de renvoyer la liste de tous les consultants
public function getConsultant(){
    
    //je select les données à partir de l'offset $num_id
    $consultants = \DB::table('consultant')
    ->join('users','users.id','=','consultant.user_id')
    //->join('roles','roles.id','=','users.role_id')
    ->select('consultant.id','consultant.ref_user','consultant.statut_id','consultant.disponibilite_id',
             'consultant.recommandation_id','consultant.nom','consultant.prenom','consultant.dateNaissance',
             'consultant.age','consultant.sexe','consultant.pays','consultant.ville','consultant.niveau_formation_id',
             'consultant.date1ereExperiencePro','consultant.nbre_annee_experience_pro','consultant.date1ereExperienceEnTantQueConsultant',
             'consultant.experienceAvecCooperationAllemande','consultant.experienceAvecLesNationsUnies',
             'consultant.experienceAvecLesAutresPartenaires','consultant.adresse','consultant.created_at',
             'consultant.updated_at','users.id as user_id_ajouter_par','users.username','users.phone','users.email')
    ->orderBy('created_at','asc')
    ->get();


    $liste = array();

    if(!empty($consultants)){
    foreach($consultants as $data){
        $ajouter_par = \DB::table('users')
            ->join('roles','roles.id','=','users.role_id')
            ->where('users.id','=',$data->user_id_ajouter_par)
            ->first();

        $ref_user = $data->ref_user;
        $consultant_id = $data->id;
        $statut_id = $data->statut_id; 
        $disponibilite_id = $data->disponibilite_id; 
        $recommandation_id = $data->recommandation_id; 
        $nom = $data->nom; 
        $prenom = $data->prenom; 
        $dateNaissance = $data->dateNaissance; 

        //obtention de l'année à partir de la date de naissance
        $annee_tableau = explode("-", $dateNaissance);
        $annee_dateNaissance = (int) $annee_tableau[0];

        //obtention de l'année courante
        //$annee_courante = Carbon::now();
        $annee_courante = date('Y');
        $annee_courante = (int) $annee_courante;

        $age = $annee_courante - $annee_dateNaissance; 

        //dd($annee_dateNaissance,$annee_courante,$age);

        $sexe = $data->sexe; 
        $pays = $data->pays; 
        $ville = $data->ville; 
        $niveau_formation_id = $data->niveau_formation_id; 
        $date1ereExperiencePro = $data->date1ereExperiencePro; 

        //obtention de l'année à partir de date1ereExperiencePro
        $annee_tableau = explode("-", $date1ereExperiencePro);
        $annee_date1ereExperiencePro = (int) $annee_tableau[0];

        $nbre_annee_d_experience = $annee_courante - $annee_date1ereExperiencePro; 

        $date1ereExperienceEnTantQueConsultant = $data->date1ereExperienceEnTantQueConsultant; 
        $experienceAvecCooperationAllemande = $data->experienceAvecCooperationAllemande; 
        $experienceAvecLesNationsUnies = $data->experienceAvecLesNationsUnies;
        $experienceAvecLesAutresPartenaires = $data->experienceAvecLesAutresPartenaires;

        $adresse = $data->adresse; 
        $created_at = $data->created_at; 
        $updated_at = $data->updated_at; 

        $statut = \DB::table('statut')
            ->where('id','=',$statut_id)
            ->first();

        $disponibilite = \DB::table('disponibilite')
            ->where('id','=',$disponibilite_id)
            ->first();

        $recommandation = \DB::table('recommandation')
            ->where('id','=',$recommandation_id)
            ->first();

        $niveau_formation = \DB::table('niveau_formation')
            ->where('id','=',$niveau_formation_id)
            ->first();

        $cv_users = \DB::table('cv_users')
            ->where('ref_user','=',$ref_user)
            ->get();

        $profil_users = \DB::table('profil_users')
            ->join('profil','profil.id','=','profil_users.profil_id')
            ->where('profil_users.ref_user','=',$ref_user)
            ->get();

        $experience_geographique_users = \DB::table('experience_geographique_users')
            ->join('experience_geographique','experience_geographique.id','=','experience_geographique_users.experience_geographique_id')
            ->where('experience_geographique_users.ref_user','=',$ref_user)
            ->get();

        $domaine_expertise_users = \DB::table('domaine_expertise_users')
            ->join('domaines','domaines.id','=','domaine_expertise_users.domaine_id')
            ->where('domaine_expertise_users.ref_user','=',$ref_user)
            ->get();

        $contact_users = \DB::table('contact_users')
            ->where('ref_user','=',$ref_user)
            ->get();

        $courriel_users = \DB::table('courriel_users')
            ->where('ref_user','=',$ref_user)
            ->get();

        $tmp ["ajouter_par"] = $ajouter_par;
        $tmp ["consultant_id"] = $consultant_id;
        $tmp ["statut"] = $statut;
        $tmp ["disponibilite"] = $disponibilite;
        $tmp ["recommandation"] = $recommandation;
        $tmp ["nom"] = $nom;
        $tmp ["prenom"] = $prenom;
        $tmp ["dateNaissance"] = $dateNaissance;
        $tmp ["age"] = $age;
        $tmp ["sexe"] = $sexe; 
        $tmp ["pays"] = $pays;
        $tmp ["ville"] = $ville;
        $tmp ["niveau_formation"] = $niveau_formation;
        $tmp ["date1ereExperiencePro"] = $date1ereExperiencePro;
        $tmp ["nbre_annee_d_experience"] = $nbre_annee_d_experience;
        $tmp ["date1ereExperienceEnTantQueConsultant"] = $date1ereExperienceEnTantQueConsultant;
        $tmp ["experienceAvecCooperationAllemande"] = $experienceAvecCooperationAllemande;
        $tmp ["experienceAvecLesNationsUnies"] = $experienceAvecLesNationsUnies;
        $tmp ["experienceAvecLesAutresPartenaires"] = $experienceAvecLesAutresPartenaires;
        $tmp ["adresse"] = $adresse;
        $tmp ["cv_users"] = $cv_users;
        $tmp ["profil_users"] = $profil_users;
        $tmp ["experience_geographique_users"] = $experience_geographique_users;
        $tmp ["domaine_expertise_users"] = $domaine_expertise_users;
        $tmp ["contact_users"] = $contact_users;
        $tmp ["courriel_users"] = $courriel_users;
        $tmp ["created_at"] = $created_at;
        $tmp ["updated_at"] = $updated_at;

        array_push($liste,$tmp ) ;

    }
}
  
   
    return response()->json(['message' => 'success', 'Liste_consultant' => $liste]);
    

}


    //permet de renvoyer la liste des consultants à partir d'un numéro de page
    public function getConsultantByPage($num_page,$nbre_donnees_par_page){
        $donnees_par_page = $nbre_donnees_par_page;

        $entrees = \DB::table('consultant')
            ->orderBy('created_at','asc')
            ->count();

        $nbre_pages = ceil($entrees/$donnees_par_page);     //total_page

        //je contrôle si le numéro de la page est compris dans l'intervalle 1 <= $page_num <= $nbre_pages
        if($num_page >= 1 AND $num_page <= $nbre_pages){
            for($i = 1; $i<=$nbre_pages; $i++){
                if($num_page == $i){ //alors on calcule à partir de l'id que ça doit renvoyer
                    if($num_page == 1){
                        $num_id = 0;
                    }
                    else{
                        $num_id = ($num_page - 1) * $donnees_par_page;
                    }

                    //je select les données à partir de l'offset $num_id
                    /*$consultants = \DB::table('consultant')
                            ->orderBy('created_at','asc')
                            ->offset($num_id)    //numéro de la ligne en BD à partir duquel la selection va se faire
                            ->limit($donnees_par_page)
                            ->get();
                            */


                    $consultants = \DB::table('consultant')
                        ->join('users','users.id','=','consultant.user_id')
                        //->join('roles','roles.id','=','users.role_id')
                        ->select('consultant.id','consultant.ref_user','consultant.statut_id','consultant.disponibilite_id',
                                 'consultant.recommandation_id','consultant.nom','consultant.prenom','consultant.dateNaissance',
                                 'consultant.age','consultant.sexe','consultant.pays','consultant.ville','consultant.niveau_formation_id',
                                 'consultant.date1ereExperiencePro','consultant.date1ereExperienceEnTantQueConsultant',
                                 'consultant.experienceAvecCooperationAllemande','consultant.experienceAvecLesNationsUnies',
                                 'consultant.experienceAvecLesAutresPartenaires','consultant.adresse','consultant.created_at',
                                 'consultant.updated_at','users.id as user_id_ajouter_par','users.username','users.phone','users.email')
                        ->orderBy('created_at','asc')
                        ->offset($num_id)    //numéro de la ligne en BD à partir duquel la selection va se faire
                        ->limit($donnees_par_page)
                        ->get();        


                    $liste = array();

                    if(!empty($consultants)){
                        foreach($consultants as $data){
                            $ajouter_par = \DB::table('users')
                                ->join('roles','roles.id','=','users.role_id')
                                ->where('users.id','=',$data->user_id_ajouter_par)
                                ->first();

                            $ref_user = $data->ref_user;
                            $statut_id = $data->statut_id; 
                            $disponibilite_id = $data->disponibilite_id; 
                            $recommandation_id = $data->recommandation_id; 
                            $nom = $data->nom; 
                            $prenom = $data->prenom; 
                            $dateNaissance = $data->dateNaissance; 

                            //obtention de l'année à partir de la date de naissance
                            $annee_tableau = explode("-", $dateNaissance);
                            $annee_dateNaissance = (int) $annee_tableau[0];

                            //obtention de l'année courante
                            //$annee_courante = Carbon::now();
                            $annee_courante = date('Y');
                            $annee_courante = (int) $annee_courante;

                            $age = $annee_courante - $annee_dateNaissance; 

                            //dd($annee_dateNaissance,$annee_courante,$age);

                            $sexe = $data->sexe; 
                            $pays = $data->pays; 
                            $ville = $data->ville; 
                            $niveau_formation_id = $data->niveau_formation_id; 
                            $date1ereExperiencePro = $data->date1ereExperiencePro; 

                            //obtention de l'année à partir de date1ereExperiencePro
                            $annee_tableau = explode("-", $date1ereExperiencePro);
                            $annee_date1ereExperiencePro = (int) $annee_tableau[0];

                            $nbre_annee_d_experience = $annee_courante - $annee_date1ereExperiencePro; 

                            $date1ereExperienceEnTantQueConsultant = $data->date1ereExperienceEnTantQueConsultant; 
                            $experienceAvecCooperationAllemande = $data->experienceAvecCooperationAllemande; 
                            $experienceAvecLesNationsUnies = $data->experienceAvecLesNationsUnies;
                            $experienceAvecLesAutresPartenaires = $data->experienceAvecLesAutresPartenaires; 
                            $adresse = $data->adresse; 
                            $created_at = $data->created_at; 
                            $updated_at = $data->updated_at; 

                            $statut = \DB::table('statut')
                                ->where('id','=',$statut_id)
                                ->first();

                            $disponibilite = \DB::table('disponibilite')
                                ->where('id','=',$disponibilite_id)
                                ->first();

                            $recommandation = \DB::table('recommandation')
                                ->where('id','=',$recommandation_id)
                                ->first();

                            $niveau_formation = \DB::table('niveau_formation')
                                ->where('id','=',$niveau_formation_id)
                                ->first();

                            $cv_users = \DB::table('cv_users')
                                ->where('ref_user','=',$ref_user)
                                ->get();

                            $profil_users = \DB::table('profil_users')
                                ->join('profil','profil.id','=','profil_users.profil_id')
                                ->where('profil_users.ref_user','=',$ref_user)
                                ->get();

                            $experience_geographique_users = \DB::table('experience_geographique_users')
                                ->join('experience_geographique','experience_geographique.id','=','experience_geographique_users.experience_geographique_id')
                                ->where('experience_geographique_users.ref_user','=',$ref_user)
                                ->get();

                            $domaine_expertise_users = \DB::table('domaine_expertise_users')
                                ->join('domaines','domaines.id','=','domaine_expertise_users.domaine_id')
                                ->where('domaine_expertise_users.ref_user','=',$ref_user)
                                ->get();

                            $contact_users = \DB::table('contact_users')
                                ->where('ref_user','=',$ref_user)
                                ->get();

                            $courriel_users = \DB::table('courriel_users')
                                ->where('ref_user','=',$ref_user)
                                ->get();

                            $tmp ["ajouter_par"] = $ajouter_par;
                            $tmp ["statut"] = $statut;
                            $tmp ["disponibilite"] = $disponibilite;
                            $tmp ["recommandation"] = $recommandation;
                            $tmp ["nom"] = $nom;
                            $tmp ["prenom"] = $prenom;
                            $tmp ["dateNaissance"] = $dateNaissance;
                            $tmp ["age"] = $age;
                            $tmp ["sexe"] = $sexe; 
                            $tmp ["pays"] = $pays;
                            $tmp ["ville"] = $ville;
                            $tmp ["niveau_formation"] = $niveau_formation;
                            $tmp ["date1ereExperiencePro"] = $date1ereExperiencePro;
                            $tmp ["nbre_annee_d_experience"] = $nbre_annee_d_experience;
                            $tmp ["date1ereExperienceEnTantQueConsultant"] = $date1ereExperienceEnTantQueConsultant;
                            $tmp ["experienceAvecCooperationAllemande"] = $experienceAvecCooperationAllemande;
                            $tmp ["experienceAvecLesNationsUnies"] = $experienceAvecLesNationsUnies;
                            $tmp ["experienceAvecLesAutresPartenaires"] = $experienceAvecLesAutresPartenaires;
                            $tmp ["adresse"] = $adresse;
                            $tmp ["cv_users"] = $cv_users;
                            $tmp ["profil_users"] = $profil_users;
                            $tmp ["experience_geographique_users"] = $experience_geographique_users;
                            $tmp ["domaine_expertise_users"] = $domaine_expertise_users;
                            $tmp ["contact_users"] = $contact_users;
                            $tmp ["courriel_users"] = $courriel_users;
                            $tmp ["created_at"] = $created_at;
                            $tmp ["updated_at"] = $updated_at;

                            array_push($liste,$tmp ) ;

                        }
                    }

                }
            }

            return response()->json(['message' => 'success', 'current_page' => $num_page, 'nbre_consultant' => $entrees, 'total_page' => $nbre_pages, 'consultants' => $liste]);
        }
        else{
            return response()->json(['message' => 'error', 'page_not_exist' => true], 400);
        }

    }


    //permet de get les domaines d'intervention, les profils et les niveaux de formation en comptant les consultants dans chaque sous catégorie
    public function getInfoSidebar(){
        //domaines d'expertise et professionnel
        $domaine_interventions = \DB::table('domaines')
            ->get();

         $liste_domaine_expertise = array();   

        if(!empty($domaine_interventions)){
            foreach($domaine_interventions as $domaine){
                $domaine_id = $domaine->id;

                //pour chaque domaine, je compte les consultants du domaine
                $nbre_consultant = \DB::table('domaine_expertise_users')
                        ->where('domaine_id','=',$domaine_id)
                        ->where('type','=','consultant')
                        ->count();

                $tmp ["domaine"] = $domaine;
                $tmp ["nbre_consultant"] = $nbre_consultant;

                array_push($liste_domaine_expertise,$tmp ) ;       
            }

        }

        //profil
        $profils = \DB::table('profil')
            ->get();

        $liste_profil = array();

        if(!empty($profils)){
            foreach($profils as $profil){
                $profil_id = $profil->id;

                //pour chaque profil, je compte les consultants ayant ce profil
                $nbre_consultant = \DB::table('profil_users')
                        ->where('profil_id','=',$profil_id)
                        ->where('type','=','consultant')
                        ->count();

                $tmp1 ["profil"] = $profil;
                $tmp1 ["nbre_consultant"] = $nbre_consultant;

                array_push($liste_profil,$tmp1 ) ;       
            }

        }

        //niveau de formation
        $niveaux_formation = \DB::table('niveau_formation')
            ->get();

        $liste_niveau_formation = array();
        
        if(!empty($niveaux_formation)){
            foreach($niveaux_formation as $niveau_formation){
                $niveau_formation_id = $niveau_formation->id;

                //pour chaque niveau de formation, je compte les consultants ayant ce niveau de formation
                $nbre_consultant = \DB::table('consultant')
                        ->where('niveau_formation_id','=',$niveau_formation_id)
                        ->count();

                $tmp2 ["niveau_formation"] = $niveau_formation;
                $tmp2 ["nbre_consultant"] = $nbre_consultant;

                array_push($liste_niveau_formation,$tmp2 ) ;       
            }

        }

        //je prends tous les ages sans doublon
        $consultants =  \DB::table('consultant')
            ->select('age')
            ->distinct()
            ->get();

        $liste_age_consultant = array();
        if(!empty($consultants)){
            foreach($consultants as $c){
                $age = $c->age;

                //pour chaque age sans doublon, je compte les consultants ayant cet âge
                $nbre_consultant = \DB::table('consultant')
                        ->where('age','=',$age)
                        ->count();    

                $tmp3 ["age"] = $age;
                $tmp3 ["nbre_consultant"] = $nbre_consultant;

                array_push($liste_age_consultant ,$tmp3 ) ;       
            }

        }


        //expérience géographique
        $experiences_geographiques = \DB::table('experience_geographique')
            ->get();

        $liste_experience_geographique = array();
        
        if(!empty($experiences_geographiques)){
            foreach($experiences_geographiques as $exp){
                $experience_geographique_id = $exp->id;

                //pour chaque niveau de formation, je compte les consultants ayant ce niveau de formation
                $nbre_consultant = \DB::table('experience_geographique_users')
                        ->where('experience_geographique_id','=',$experience_geographique_id)
                        ->where('type','=','consultant')
                        ->count();

                $tmp4 ["experience_geographique"] = $exp;
                $tmp4 ["nbre_consultant"] = $nbre_consultant;

                array_push($liste_experience_geographique,$tmp4 ) ;       
            }

        }


        //je prends tous les nbre_annee_experience_pro sans doublon
        $consultants =  \DB::table('consultant')
            ->select('nbre_annee_experience_pro')
            ->distinct()
            ->get();

        $liste_annee_experience_pro_consultant = array();
        if(!empty($consultants)){
            foreach($consultants as $c){
                $nbre_annee_experience_pro = $c->nbre_annee_experience_pro;

                //pour chaque nbre_annee_experience_pro sans doublon, je compte les consultants ayant ce nbre_annee_experience_pro
                $nbre_consultant = \DB::table('consultant')
                        ->where('nbre_annee_experience_pro','=',$nbre_annee_experience_pro)
                        ->count();    

                $tmp5 ["nbre_annee_d_experience"] = $nbre_annee_experience_pro;
                $tmp5 ["nbre_consultant"] = $nbre_consultant;

                array_push($liste_annee_experience_pro_consultant ,$tmp5 ) ;       
            }

        }
        
        //statut
        $statuts = \DB::table('statut')
            ->get();

        $liste_statut = array();
        
        if(!empty($statuts)){
            foreach($statuts as $statut){
                $statut_id = $statut->id;

                //pour chaque statut, je compte les consultants ayant ce statut
                $nbre_consultant = \DB::table('consultant')
                        ->where('statut_id','=',$statut_id)
                        ->count();

                $tmp6 ["statut"] = $statut;
                $tmp6 ["nbre_consultant"] = $nbre_consultant;

                array_push($liste_statut,$tmp6 ) ;       
            }

        }
        
        //genre
        $liste_genre = array();
        
        $nbre_consultant_homme = \DB::table('consultant')
            ->where('sexe','=','M')
            ->count();
        
        $nbre_consultant_femme = \DB::table('consultant')
            ->where('sexe','=','F')
            ->count();    

        $tmp7 ["hommes"] = $nbre_consultant_homme;
        $tmp7 ["femmes"] = $nbre_consultant_femme;

        array_push($liste_genre,$tmp7 ) ;       
            



        return response()->json(['message' => 'success', 'liste_domaine_expertise' => $liste_domaine_expertise,
                                 'liste_profil' => $liste_profil, 'liste_niveau_formation' => $liste_niveau_formation,
                                 'liste_age_consultant ' => $liste_age_consultant, 'liste_experience_geographique' => $liste_experience_geographique, 
                                 'liste_annee_experience_pro_consultant' => $liste_annee_experience_pro_consultant,
                                 'liste_statut' => $liste_statut, 'liste_genre' => $liste_genre]);


    }




    //permet d'exporter dans un dossier zip tous les cv des consultants d'une page
    public function exportZipFile(){
        $request = Request::instance();
        $data = json_decode($request->getContent());

        $liste_CV = $data->liste_CV;        //contient le tableau JSON des chemins des CVs des consultants de la page. Format liste_CV = [{"CV":"string"},{"CV":"string"},{...}]

        $files = array();

        if(sizeof($liste_CV) != 0){
            for($i=0; $i<sizeof($liste_CV); $i++){
                $files[$i] = public_path($liste_CV[$i]->CV);
            }

                  //  dd($files);

            \Zipper::make('/home/montaxi/Bureau/Consultants_'.Carbon::now().'.zip'/*public_path('test.zip')*/)->add($files)->close();
            return response()->download('/home/montaxi/Bureau/Consultants_'.Carbon::now().'.zip'/*public_path('test.zip')*/);

        }

        return response()->json(['message' => 'error', 'liste_CV_is_empty' => true], 400);
    }


    //fonction qui convertit un pdf en texte et renvoie un champ contenant tout le texte du pdf
    public function pdfToText(){
        $text = (new Pdf())
                ->setPdf('/home/montaxi/Bureau/CV_Maurelle_Winnie.pdf')
                ->text();

        $haystack = 'how are you';
        
        $needle = 'Bamendjou';

        $string_en_minuscule = strtolower($needle);
        $string_en_majuscule = strtoupper($needle);
        $premier_caractere_en_majuscule = ucfirst($needle);
        
        //vérifie si $text contient le mot $needle
        //cas de test avec tous les caractères en minuscule
        if (strpos($text,$string_en_minuscule) !== false) {
            echo "$haystack contains $needle";
            return response()->json(['message' => '$text contains $string_en_minuscule', 'Text' => $text]); 
        }

        //cas test avec tous les caractères en majuscule
        if (strpos($text,$string_en_majuscule) !== false) {
            echo "$haystack contains $needle";
            return response()->json(['message' => '$text contains $string_en_majuscule', 'Text' => $text]); 
        }

        //cas test où le premier caractère est en majuscule
        if (strpos($text,$premier_caractere_en_majuscule) !== false) {
            echo "$haystack contains $needle";
            return response()->json(['message' => '$text contains $premier_caractere_en_majuscule', 'Text' => $text]); 
        }

        return response()->json(['message' => 'success', 'Text' => $text]);        


    }



    //permet de renvoyer les statistiques des consultants en genre sur les CVs et par domaine d'intervention
    public function getStatistique(){
        $total_consultant = \DB::table('consultant')
            ->count();

        $total_consultant_pour_tous_les_domaines = 0;

        //domaines d'expertise et professionnel
        $domaine_interventions = \DB::table('domaines')
            ->get();

        if(!empty($domaine_interventions)){
            foreach($domaine_interventions as $domaine){
                $domaine_id = $domaine->id;

                //pour chaque domaine, je compte les consultants du domaine
                $nbre_consultant = \DB::table('domaine_expertise_users')
                        ->where('domaine_id','=',$domaine_id)
                        ->where('type','=','consultant')
                        ->count();

                $total_consultant_pour_tous_les_domaines += $nbre_consultant;

                }
        }

         $liste_domaine_expertise = array();
         $total_nbre_hommes_par_domaines_expertise = 0;
         $total_nbre_femmes_par_domaines_expertise = 0;
         $total_consultants_par_domaines_expertise = 0;   

        if(!empty($domaine_interventions)){
            foreach($domaine_interventions as $domaine){
                $domaine_id = $domaine->id;

                //pour chaque domaine, je compte les consultants du domaine
                $nbre_consultant = \DB::table('domaine_expertise_users')
                        ->where('domaine_id','=',$domaine_id)
                        ->where('type','=','consultant')
                        ->count();

                //nombre d'hommes        
                $nbre_hommes = \DB::table('domaine_expertise_users')
                        ->join('consultant','consultant.ref_user','=','domaine_expertise_users.ref_user')
                        ->where('domaine_expertise_users.domaine_id','=',$domaine_id)
                        ->where('consultant.sexe','=','M')
                        ->count();

                //nombre de femmes
                $nbre_femmes = \DB::table('domaine_expertise_users')
                        ->join('consultant','consultant.ref_user','=','domaine_expertise_users.ref_user')
                        ->where('domaine_expertise_users.domaine_id','=',$domaine_id)
                        ->where('consultant.sexe','=','F')
                        ->count();                

                $tmp ["domaine"] = $domaine;
                $tmp ["nbre_hommes"] = $nbre_hommes;
                $tmp ["nbre_femmes"] = $nbre_femmes;
                $tmp ["nbre_consultant"] = $nbre_consultant;
                $tmp ["pourcentage"] = ($nbre_consultant / $total_consultant_pour_tous_les_domaines) * 100;

                array_push($liste_domaine_expertise,$tmp ) ;

                $total_nbre_hommes_par_domaines_expertise += $nbre_hommes;
                $total_nbre_femmes_par_domaines_expertise += $nbre_femmes;       
            }

        }

        $total_consultants_par_domaines_expertise = $total_nbre_hommes_par_domaines_expertise + $total_nbre_femmes_par_domaines_expertise;

        //nbre de consultant par genre
        $nbre_consultant_hommes = \DB::table('consultant')
                    ->where('sexe','=','M')
                    ->count(); 

        $nbre_consultant_femmes = \DB::table('consultant')
                    ->where('sexe','=','F')
                    ->count();  

        $pourcentage_hommes = ($nbre_consultant_hommes / $total_consultant) * 100;
        
        $pourcentage_femmes = ($nbre_consultant_femmes / $total_consultant) * 100; 

        $nbre_consultant_par_genre = array();  

        $tmp1 ["nbre_consultant_hommes"] = $nbre_consultant_hommes;
        $tmp1 ["nbre_consultant_femmes"] = $nbre_consultant_femmes;
        $tmp1 ["total_consultant"] = $nbre_consultant_hommes + $nbre_consultant_femmes;
        $tmp1 ["pourcentage_hommes"] = $pourcentage_hommes;
        $tmp1 ["pourcentage_femmes"] = $pourcentage_femmes;
        $tmp1 ["total_pourcentage"] =  $pourcentage_hommes + $pourcentage_femmes;

        array_push($nbre_consultant_par_genre,$tmp1 ) ;  



        return response()->json(['message' => 'success', 'nbre_consultant_par_genre' => $nbre_consultant_par_genre, 
                                 'liste_domaine_expertise_par_genre' => $liste_domaine_expertise,
                                 'total_nbre_hommes_par_domaines_expertise' => $total_nbre_hommes_par_domaines_expertise,
                                 'total_nbre_femmes_par_domaines_expertise' => $total_nbre_femmes_par_domaines_expertise,
                                 'total_consultants_par_domaines_expertise' => $total_consultants_par_domaines_expertise]);

    }





        //permet d'update un consultant
    public function updateConsultant($consultant_id,$token){
        $request = Request::instance();
        $data = json_decode($request->getContent());

        //je vérifie si consultant_id existe bien en BD
        $check_consultant = \DB::table('consultant')
            ->where('id','=',$consultant_id)
            ->first();

        if(empty($check_consultant)){
            return response()->json(['user_not_found' => false, 'consultant_id_not_exist' => true], 401);
        }    

        //je vérifie le token
        $check = \DB::table('users')
            ->where('remember_token','=',$token)
            ->first();

        if(empty($check)){
            return response()->json(['user_not_found' => true, 'consultant_id_not_exist' => false], 401);
        }    

        $user_id = $check->id;

        $liste_CV = $data->liste_CV;        //contient le tableau JSON des CVs du consultant. Format liste_CV = [{"CV":"string"},{"CV":"string"},{...}]
        $statut_id = $data->statut_id;
        $disponibilite_id = $data->disponibilite_id;
        $recommandation_id = $data->recommandation_id;
        $recommandation_name = $data->recommandation_name;
        $nom = $data->nom;
        $prenom = $data->prenom;
        $dateNaissance = $data->dateNaissance;      //format aaaa-mm-jj
        $sexe = $data->sexe;        //format sexe = M ou F
        $pays = $data->pays;
        $ville = $data->ville;
        $niveau_formation_id = $data->niveau_formation_id;
        $liste_profil = $data->liste_profil;        //contient le tableau JSON des profils du consultant. Format liste_profile = [{"profil_id":value},{"profil_id":value},{...}]
        $date1ereExperiencePro = $data->date1ereExperiencePro;      //format aaaa-mm-jj
        $date1ereExperienceEnTantQueConsultant = $data->date1ereExperienceEnTantQueConsultant;      //format aaaa-mm-jj
        $liste_experience_geographique = $data->liste_experience_geographique;      //contient le tableau JSON d'expériences géographique du consultant. Format liste_experience_geographique = [{"experience_geographique_id":value},{"experience_geographique_id":value},{...}]
        $experienceAvecCooperationAllemande = $data->experienceAvecCooperationAllemande;    // 0 pour non et 1 pour oui
        $experienceAvecLesNationsUnies = $data->experienceAvecLesNationsUnies;          //0 pour non et 1 pour oui
        $experienceAvecLesAutresPartenaires = $data->experienceAvecLesAutresPartenaires;          //0 pour non et 1 pour oui
        $liste_domaine_expertise = $data->liste_domaine_expertise;      //contient le tableau JSON des domaines d'expertise du consultant. Format liste_domaine_expertise = [{"domaine_id":value, "nbre_consultation":value},{"domaine_id":value, "nbre_consultation":value},{...}]
        $adresse = $data->adresse;
        $liste_telephone = $data->liste_telephone;      //contient le tableau JSON des téléphones du consultant. Format liste_telephone = [{"telephone":value},{"telephone":value},{...}]
        $liste_courriel = $data->liste_courriel;        //contient le tableau JSON des emails du consultant. Format liste_courriel = [{"email":value},{"email":value},{...}]

        $type = "consultant";   //type = consultant ou cabinet_bureau_etude ou ong_association

        $created_at = Carbon::now();
        $updated_at = Carbon::now();

        //dd(sizeof($liste_experience_geographique));

        //if((sizeof($liste_CV) == 0) || $statut_id == NULL || $disponibilite_id == NULL || $recommandation_id == NULL || $nom == NULL
        //    || $prenom == NULL || $dateNaissance == NULL || $sexe == NULL || $pays == NULL || $ville == NULL || $niveau_formation_id == NULL
        //    || (sizeof($liste_profil) == 0) || $date1ereExperiencePro == NULL || $date1ereExperienceEnTantQueConsultant == NULL
        //    || (sizeof($liste_experience_geographique) == 0) || /*$experienceAvecCooperationAllemande == NULL || $experienceAvecLesNationsUnies == NULL
        //    ||*/ (sizeof($liste_domaine_expertise) == 0) || $adresse == NULL || (sizeof($liste_telephone) == 0) || (sizeof($liste_courriel) == 0)){

        //    return response()->json(['message' => 'error', 'remplir_tous_les_champs' => true, 'statut_id_not_exist' => false, 'disponibilite_id_not_exist' => false,
        //                            'recommandation_id_not_exist' => false, 'niveau_formation_id_not_exist' => false, 'profil_id_not_exist' => false,
        //                             'experience_geographique_id_not_exist' => false, 'domaine_id_not_exist' => false], 400);

        //}

        //on vérifie si le statut_id existe dans la table statut
        if($statut_id != NULL){
            $check = \DB::table('statut')
                ->where('id','=',$statut_id)
                ->first();

            if(empty($check)){
                return response()->json(['message' => 'error', 'remplir_tous_les_champs' => false, 'statut_id_not_exist' => true, 'disponibilite_id_not_exist' => false,
                                        'recommandation_id_not_exist' => false, 'niveau_formation_id_not_exist' => false, 'profil_id_not_exist' => false,
                                        'experience_geographique_id_not_exist' => false, 'domaine_id_not_exist' => false], 400);
            }
        }
        
        //on vérifie si disponibilite_id existe dans la table disponibilite
        if($disponibilite_id != NULL){
            $check = \DB::table('disponibilite')
                ->where('id','=',$disponibilite_id)
                ->first();

            if(empty($check)){
                return response()->json(['message' => 'error', 'remplir_tous_les_champs' => false, 'statut_id_not_exist' => false, 'disponibilite_id_not_exist' => true,
                                        'recommandation_id_not_exist' => false, 'niveau_formation_id_not_exist' => false, 'profil_id_not_exist' => false,
                                        'experience_geographique_id_not_exist' => false, 'domaine_id_not_exist' => false], 400);
            }
        }

        //on vérifie si recommandation_id existe dans la table recommandation
        $check = \DB::table('recommandation')
            ->where('id','=',$recommandation_id)
            ->first();

        if(empty($check)){
            /*return response()->json(['message' => 'error', 'remplir_tous_les_champs' => false, 'statut_id_not_exist' => false, 'disponibilite_id_not_exist' => false,
                                     'recommandation_id_not_exist' => true, 'niveau_formation_id_not_exist' => false, 'profil_id_not_exist' => false,
                                     'experience_geographique_id_not_exist' => false, 'domaine_id_not_exist' => false], 400);*/
            
            //I check if recommandation_name already exist
            $check_recommandation = \DB::table('recommandation')
                ->where('intitule','=',$recommandation_name)
                ->first();

            if(empty($check_recommandation)){
                \DB::table('recommandation')
                    ->insert([
                        [
                            'intitule' => $recommandation_name,
                            'description' => $recommandation_name,
                            'created_at' => Carbon::now(),
                            'updated_at' => Carbon::now()
                        ]
                    ]);

                $recommandation_id = DB::getPdo()->lastInsertId();
                
            }
            else{
                $recommandation_id = $check_recommandation->id;
            }

        }

        //on vérifie si niveau_formation_id existe dans la table niveau_formation
        if($niveau_formation_id != NULL){
            $check = \DB::table('niveau_formation')
                ->where('id','=',$niveau_formation_id)
                ->first();

            if(empty($check)){
                return response()->json(['message' => 'error', 'remplir_tous_les_champs' => false, 'statut_id_not_exist' => false, 'disponibilite_id_not_exist' => false,
                                        'recommandation_id_not_exist' => false, 'niveau_formation_id_not_exist' => true, 'profil_id_not_exist' => false,
                                        'experience_geographique_id_not_exist' => false, 'domaine_id_not_exist' => false], 400);
            }
        }
        
        //on vérifie si profil_id existe dans la table profil
        if(sizeof($liste_profil) != 0){
            for($i=0; $i<sizeof($liste_profil); $i++){
                $profil_id = $liste_profil[$i]->profil_id;

                $check = \DB::table('profil')
                    ->where('id','=',$profil_id)
                    ->first();
                if(empty($check)){
                    return response()->json(['message' => 'error', 'remplir_tous_les_champs' => false, 'statut_id_not_exist' => false, 'disponibilite_id_not_exist' => false,
                                             'recommandation_id_not_exist' => false, 'niveau_formation_id_not_exist' => false, 'profil_id_not_exist' => true,
                                             'experience_geographique_id_not_exist' => false, 'domaine_id_not_exist' => false], 400);
                }
            }
        }

        //on vérifie si experience_geographique_id existe dans la table experience_geographique
        if(sizeof($liste_experience_geographique) != 0){
            for($i=0; $i<sizeof($liste_experience_geographique); $i++){
                $experience_geographique_id = $liste_experience_geographique[$i]->experience_geographique_id;

                $check = \DB::table('experience_geographique')
                    ->where('id','=',$experience_geographique_id)
                    ->first();
                if(empty($check)){
                    return response()->json(['message' => 'error', 'remplir_tous_les_champs' => false, 'statut_id_not_exist' => false, 'disponibilite_id_not_exist' => false,
                                             'recommandation_id_not_exist' => false, 'niveau_formation_id_not_exist' => false, 'profil_id_not_exist' => false,
                                             'experience_geographique_id_not_exist' => true, 'domaine_id_not_exist' => false], 400);
                }
            }
        }

        //on vérifie si domaine_id existe dans la table domaines
        if(sizeof($liste_domaine_expertise) != 0){
            for($i=0; $i<sizeof($liste_domaine_expertise); $i++){
                $domaine_id = $liste_domaine_expertise[$i]->domaine_id;

                $check = \DB::table('domaines')
                    ->where('id','=',$domaine_id)
                    ->first();
                if(empty($check)){
                    return response()->json(['message' => 'error', 'remplir_tous_les_champs' => false, 'statut_id_not_exist' => false, 'disponibilite_id_not_exist' => false,
                                             'recommandation_id_not_exist' => false, 'niveau_formation_id_not_exist' => false, 'profil_id_not_exist' => false,
                                             'experience_geographique_id_not_exist' => false, 'domaine_id_not_exist' => true], 400);
                }
            }
        }

        //je calcule une fois l'âge du consultant
        //obtention de l'année à partir de la date de naissance
        $annee_tableau = explode("-", $dateNaissance);
        $annee_dateNaissance = (int) $annee_tableau[0];

        //obtention de l'année courante
        //$annee_courante = Carbon::now();
        $annee_courante = date('Y');
        $annee_courante = (int) $annee_courante;

        $age = $annee_courante - $annee_dateNaissance; 

        //je calcule le nbre année d'expérience pro
        $annee_tableau = explode("-", $date1ereExperiencePro);
        $annee_experience_pro = (int) $annee_tableau[0];

        //obtention de l'année courante
        //$annee_courante = Carbon::now();
        $annee_courante = date('Y');
        $annee_courante = (int) $annee_courante;

        $nbre_annee_experience_pro = $annee_courante - $annee_experience_pro; 

        //j'enregistre d'abord les infos principales de la table consultant
        /*
        \DB::table('consultant')
            ->insert([
                [
                    'user_id' => $user_id,
                    'statut_id' => $statut_id,
                    'disponibilite_id' => $disponibilite_id,
                    'recommandation_id' => $recommandation_id,
                    'nom' => $nom,
                    'prenom' => $prenom,
                    'dateNaissance' => $dateNaissance,
                    'age' => $age,
                    'sexe' => $sexe,
                    'pays' => $pays,
                    'ville' => $ville,
                    'niveau_formation_id' => $niveau_formation_id,
                    'date1ereExperiencePro' => $date1ereExperiencePro,
                    'nbre_annee_experience_pro' => $nbre_annee_experience_pro,
                    'date1ereExperienceEnTantQueConsultant' => $date1ereExperienceEnTantQueConsultant,
                    'experienceAvecCooperationAllemande' => $experienceAvecCooperationAllemande,
                    'experienceAvecLesNationsUnies' => $experienceAvecLesNationsUnies,
                    'experienceAvecLesAutresPartenaires' => $experienceAvecLesAutresPartenaires,
                    'adresse' => $adresse,
                    'created_at' => Carbon::now(),
                    'updated_at' => Carbon::now()
                ]
            ]);
            */

        \DB::table('consultant')
                    ->where('id','=',$consultant_id)
                    ->update([
                        'user_id' => $user_id,
                        'statut_id' => $statut_id,
                        'disponibilite_id' => $disponibilite_id,
                        'recommandation_id' => $recommandation_id,
                        'nom' => $nom,
                        'prenom' => $prenom,
                        'dateNaissance' => $dateNaissance,
                        'age' => $age,
                        'sexe' => $sexe,
                        'pays' => $pays,
                        'ville' => $ville,
                        'niveau_formation_id' => $niveau_formation_id,
                        'date1ereExperiencePro' => $date1ereExperiencePro,
                        'nbre_annee_experience_pro' => $nbre_annee_experience_pro,
                        'date1ereExperienceEnTantQueConsultant' => $date1ereExperienceEnTantQueConsultant,
                        'experienceAvecCooperationAllemande' => $experienceAvecCooperationAllemande,
                        'experienceAvecLesNationsUnies' => $experienceAvecLesNationsUnies,
                        'experienceAvecLesAutresPartenaires' => $experienceAvecLesAutresPartenaires,
                        'adresse' => $adresse,
                        'updated_at' => Carbon::now()
                    ]);    

        //maintenant je récupère le user_id pour pouvoir save les autres infos CVs, profils, experience_geographique, domaines, contacts et courriels
        $user = \DB::table('consultant')
            ->where('id','=',$consultant_id)
            ->first();

        //define('CHEMIN_CV','/home/apivisavis/public_html/giz/');
        define('CHEMIN_CV', '/usr/www/users/amberm/public/'); 

        if(!empty($user)){
            $user_id = $user->id;
            $ref_user = $user->ref_user;

            //je supprime tous les CVs du consultant avec ref_user avec les fichiers CVs stockés
            $cv_users = \DB::table('cv_users')
                ->where('ref_user','=',$ref_user)
                ->get();


            if(!empty($cv_users)){
                foreach ($cv_users as $cv) {
                    $chemin = $cv->cv;
                    unlink(CHEMIN_CV . $chemin);    //qui va delete le fichier dans le dossier /img/uploads
                }
            }    

            \DB::table('cv_users')
                ->where('ref_user','=',$ref_user)
                ->delete();


            //je supprime tous les profils du consultant avec ref_user
            \DB::table('profil_users')
                ->where('ref_user','=',$ref_user)
                ->delete();

            //je supprime toutes les expériences géographiques du consultant avec ref_user
            \DB::table('experience_geographique_users')
                ->where('ref_user','=',$ref_user)
                ->delete();

            //je supprime tous les domaines d'expertises et professionnels du consultant avec ref_user
            \DB::table('domaine_expertise_users')
                ->where('ref_user','=',$ref_user)
                ->delete();

            //je supprime tous les téléphones du consultant avec ref_user
            \DB::table('contact_users')
                ->where('ref_user','=',$ref_user)
                ->delete();

            //je supprime tous les courriels (emails) du consultant avec ref_user
            \DB::table('courriel_users')
                ->where('ref_user','=',$ref_user)
                ->delete();



            //j'enregistre d'abord les CVs du consultant
            //define('UPLOAD_DIR','/home/mooevents/public_html/img/uploads/');
            //define('UPLOAD_DIR','/Applications/MAMP/htdocs/giz_frontend/public/img/uploads/CVs/');
            //define('UPLOAD_DIR','/home/apivisavis/public_html/giz/img/uploads/CVs/');
            define('UPLOAD_DIR','/usr/www/users/amberm/public/img/uploads/CVs/');

            if($liste_CV != ""){
                if(sizeof($liste_CV) != 0){
                    for($i=0; $i<sizeof($liste_CV); $i++){
    
                        $ref_cv = str_random(4);
    
                        $pdf = $liste_CV[$i]->CV;
                        $data = base64_decode($pdf);
                        //$nom = uniqid() . '.pdf';
                        $name = 'CV_'.$nom.'_'.$prenom.'_'.'Ref_'.$ref_cv. '.pdf';
                        $file = UPLOAD_DIR . $name;
                        $chemin='img/uploads/CVs/'.$name ;
                        file_put_contents($file, $data);        //pour upload le fichier dans le dossier du chemin UPLOAD_DIR
    
                        //extraction du contenu du cv et stockage
                        $text = (new Pdf())
                            ->setPdf($file)
                            ->text();
    
                        \DB::table('cv_users')
                            ->insert([
                                [
                                    'cv' => $chemin,
                                    'cv_en_base_64' => $pdf,
                                    'ref_user' => $ref_user,
                                    'ref_cv' => $ref_cv,
                                    'contenu_cv' => $text,
                                    'created_at' => Carbon::now(),
                                    'updated_at' => Carbon::now()
                                ]
                            ]);
                    }
                }
            }
            

            //j'enregistre les profils du consultant
            if(sizeof($liste_profil) != 0){
                for($i=0; $i<sizeof($liste_profil); $i++){
                    $profil_id = $liste_profil[$i]->profil_id;

                    \DB::table('profil_users')
                        ->insert([
                            [
                                'profil_id' => $profil_id,
                                'ref_user' => $ref_user,
                                'type' => $type,
                                'created_at' => Carbon::now(),
                                'updated_at' => Carbon::now()
                            ]
                        ]);
                }
            }

            //j'enregistre les expériences géographiques du consultant
            if(sizeof($liste_experience_geographique) != 0){
                for($i=0; $i<sizeof($liste_experience_geographique); $i++){
                    $experience_geographique_id = $liste_experience_geographique[$i]->experience_geographique_id;

                    \DB::table('experience_geographique_users')
                        ->insert([
                            [
                                'experience_geographique_id' => $experience_geographique_id,
                                'ref_user' => $ref_user,
                                'type' => $type,
                                'created_at' => Carbon::now(),
                                'updated_at' => Carbon::now()
                            ]
                        ]);
                }
            }

            //j'enregistre les domaines d'expertise et professionnels du consultant
            if(sizeof($liste_domaine_expertise) != 0){
                for($i=0; $i<sizeof($liste_domaine_expertise); $i++){
                    $domaine_id = $liste_domaine_expertise[$i]->domaine_id;
                    $nbre_consultation = $liste_domaine_expertise[$i]->nbre_consultation;

                    \DB::table('domaine_expertise_users')
                        ->insert([
                            [
                                'domaine_id' => $domaine_id,
                                'nbre_consultation' => $nbre_consultation,
                                'ref_user' => $ref_user,
                                'type' => $type,
                                'created_at' => Carbon::now(),
                                'updated_at' => Carbon::now()
                            ]
                        ]);
                }
            }

            //j'enregistre les téléphones du consultant
            if(sizeof($liste_telephone) != 0){
                for($i=0; $i<sizeof($liste_telephone); $i++){
                    $telephone = $liste_telephone[$i]->telephone;

                    \DB::table('contact_users')
                        ->insert([
                            [
                                'telephone' => $telephone,
                                'ref_user' => $ref_user,
                                'type' => $type,
                                'created_at' => Carbon::now(),
                                'updated_at' => Carbon::now()
                            ]
                        ]);
                }
            }

            //j'enregistre les courriels (emails) du consultant
            if(sizeof($liste_courriel) != 0){
                for($i=0; $i<sizeof($liste_courriel); $i++){
                    $email = $liste_courriel[$i]->email;

                    \DB::table('courriel_users')
                        ->insert([
                            [
                                'email' => $email,
                                'ref_user' => $ref_user,
                                'type' => $type,
                                'created_at' => Carbon::now(),
                                'updated_at' => Carbon::now()
                            ]
                        ]);
                }
            }

        }

        return response()->json(['message' => 'success']);
    }


    //permet de supprimer les infos d'un consultant
    public function deleteConsultant($consultant_id,$token){
        $request = Request::instance();
        $data = json_decode($request->getContent());

        //je vérifie si consultant_id existe bien en BD
        $check_consultant = \DB::table('consultant')
            ->where('id','=',$consultant_id)
            ->first();

        if(empty($check_consultant)){
            return response()->json(['user_not_found' => false, 'consultant_id_not_exist' => true], 401);
        }    

        //je vérifie le token
        $check = \DB::table('users')
            ->where('remember_token','=',$token)
            ->first();

        if(empty($check)){
            return response()->json(['user_not_found' => true, 'consultant_id_not_exist' => false], 401);
        }    


        //maintenant je récupère le user_id pour pouvoir save les autres infos CVs, profils, experience_geographique, domaines, contacts et courriels
        $user = \DB::table('consultant')
            ->where('id','=',$consultant_id)
            ->first();

        //define('CHEMIN_CV','/home/apivisavis/public_html/giz/');  
        define('CHEMIN_CV','/usr/www/users/amberm/public/');   

        if(!empty($user)){
            $user_id = $user->id;
            $ref_user = $user->ref_user;

            //je supprime tous les CVs du consultant avec ref_user avec les fichiers CVs stockés
            $cv_users = \DB::table('cv_users')
                ->where('ref_user','=',$ref_user)
                ->get();


            if(!empty($cv_users)){
                foreach ($cv_users as $cv) {
                    $chemin = $cv->cv;
                    unlink(CHEMIN_CV . $chemin);    //qui va delete le fichier dans le dossier /img/uploads
                }
            }    

            \DB::table('cv_users')
                ->where('ref_user','=',$ref_user)
                ->delete();


            //je supprime tous les profils du consultant avec ref_user
            \DB::table('profil_users')
                ->where('ref_user','=',$ref_user)
                ->delete();

            //je supprime toutes les expériences géographiques du consultant avec ref_user
            \DB::table('experience_geographique_users')
                ->where('ref_user','=',$ref_user)
                ->delete();

            //je supprime tous les domaines d'expertises et professionnels du consultant avec ref_user
            \DB::table('domaine_expertise_users')
                ->where('ref_user','=',$ref_user)
                ->delete();

            //je supprime tous les téléphones du consultant avec ref_user
            \DB::table('contact_users')
                ->where('ref_user','=',$ref_user)
                ->delete();

            //je supprime tous les courriels (emails) du consultant avec ref_user
            \DB::table('courriel_users')
                ->where('ref_user','=',$ref_user)
                ->delete();

            
            //je finis par la suppression du consultant lui-même
            \DB::table('consultant')
                ->where('ref_user','=',$ref_user)
                ->delete();    

        }

        return response()->json(['message' => 'success']);
    }





}
