<?php

namespace App\Http\Controllers;

use Illuminate\Http\Request;

use App\Repositories\UserRepository;

use Dompdf\FrameDecorator\NullFrameDecorator;
use DateTime;
use Input;

use Response;

//use Request;

use App\Models\User;

use Auth;

//use Illuminate\Http\Request;

use JWTAuth;

use Tymon\JWTAuth\Exceptions\JWTException;

use DB;

use Carbon\Carbon;

use Mail;

use GuzzleHttp\Client;

use PushNotification;

use Facebook;
use Facebook\Helpers\FacebookRedirectLoginHelper;
use Facebook\FacebookSDKException;
use Facebook\Authentication\OAuth2Client;



use Codebird\Codebird;

use Spatie\UrlSigner\MD5UrlSigner;

use Illuminate\Support\Facades\View;
use Illuminate\Support\ServiceProvider;
//use App\Http\Controllers\Snowfire\Beautymail\Beautymail;
use Snowfire\Beautymail\Beautymail;


//use Illuminate\Http\Request;

use App\Http\Requests;

use Excel;




class ExcelController extends Controller
{


    //permet de renvoyer la view importExport.blade
    public function index(){
        return view('tontine.importExport');
    }


    //permet de download le fichier excel selon le type (xls, xlsx ou csv)
    public function downloadExcel($type,$tontine_id,$cycle_id){

        //nom de la tontine
        $tontine = \DB::table('tontines')
            ->where('id','=',$tontine_id)
            ->first();

        if(empty($tontine)){
            return response()->json(['message' => 'error', 'cycle_not_found' => false, 'tontine_not_found' => true], 400);
        }

        $cycle = \DB::table('cycles')
            ->where('id','=',$cycle_id)
            ->first();

        if(empty($cycle)){
            return response()->json(['message' => 'error', 'cycle_not_found' => true, 'tontine_not_found' => false], 400);
        }

        //on sélectionne les users distincts de la tontine
        $data_test = \DB::table('users')
            ->join('membrestontines','membrestontines.user_id','=','users.id')
            ->where('membrestontines.tontine_id','=',$tontine_id)
            ->select('users.id','users.lastname','membrestontines.administrator')
            ->distinct()
            ->orderBy('users.lastname','asc')
            ->get();



        $seances = \DB::table('seances')
            ->where('cycle_id','=',$cycle_id)
            ->where('tontine_id','=',$tontine_id)
            //->where('archived','=',1)
            ->get();

        $nombre_seance = \DB::table('seances')
            ->where('cycle_id','=',$cycle_id)
            ->where('tontine_id','=',$tontine_id)
            ->count();





        //puis on créé une liste unique de user distinct
        $liste = array();
        foreach ($data_test as $user){
            $users = \DB::table('users')
                ->join('membrestontines','membrestontines.user_id','=','users.id')
                ->where('users.id','=',$user->id)
                ->select('users.id as user_id','users.firstname','users.lastname','users.email','users.phone',
                         'users.pays','users.ville','users.sexe','membrestontines.administrator')
                ->first();

            $user_id = $users->user_id;
            $firstname = $users->firstname;
            $lastname = $users->lastname;
            $email = $users->email;
            $phone = $users->phone;
            $pays = $users->pays;
            $ville = $users->ville;
            $sexe = $users->sexe;
            $administrator = $users->administrator;

            $tmp["user_id"] = $user_id;
            $tmp["firstname"] = $firstname;
            $tmp["lastname"] = $lastname;
            $tmp["email"] = $email;
            $tmp["phone"] = $phone;
            $tmp["pays"] = $pays;
            $tmp["ville"] = $ville;
            $tmp["sexe"] = $sexe;
            $tmp["administrator"] = $administrator;

            array_push($liste,$tmp);

        }



//        ,'users.firstname','users.lastname','users.email','users.phone','users.pays','users.ville','users.sexe','membrestontines.numero_part',
//        'membrestontines.administrator'


        $nombre_m = \DB::table('users')
            ->join('membrestontines','membrestontines.user_id','=','users.id')
            ->where('membrestontines.tontine_id','=',$tontine_id)
            ->select('users.id')
            ->distinct()
            ->get();

        $nombre_membres = 0;
        foreach($nombre_m as $n){
            $nombre_membres ++ ;
        }
            //->toArray();


        $nombre_parts = \DB::table('membrestontines')
            ->where('tontine_id','=',$tontine_id)
            ->count();


//
//        $data_test = $data_test->toArray();

        $data = User::get()->toArray();


        //liste des membres devant payés des pénalités
//        $liste_membres = \DB::table('penalites')
//            ->where('tontine_id','=',$tontine_id)
//            ->where('statut_penalite','=','pas_tout_paye')
//            ->get();
//
//        if (!empty($liste_membres)){
//
//        }




        return Excel::create($tontine->name, function($excel) use ($data,$liste,$nombre_membres,$nombre_parts,$tontine_id,$tontine,$seances,$nombre_seance,$cycle) {

            //pour afficher feuille1
            $excel->sheet('Dashboard', function($sheet) use ($data,$liste,$nombre_membres,$nombre_parts,$tontine_id,$tontine,$seances,$nombre_seance,$cycle)
            {
                $qualitie = \DB::table('qualities')
                    ->where('id','=',$tontine->quality_id)
                    ->first();

                $drawingtype = \DB::table('drawingtypes')
                    ->where('id','=',$tontine->drawingtype_id)
                    ->first();

                //periodicité
                $nombre_mois = 0;
                if($tontine->periodicite == "day"){
                    $nombre_mois = $nombre_parts / 30;
                }

                if($tontine->periodicite == "week"){
                    $nombre_mois = $nombre_parts / 4;
                }

                if($tontine->periodicite == "month"){
                    $nombre_mois = $nombre_parts;
                }

                //type pénalité sur le retard


                $sheet->setCellValue('A1', 'Date');
                $sheet->setCellValue('B1', Carbon::now());




                //$sheet->fromArray($data);
                $sheet->setCellValue('B2', 'Group Type');
                $sheet->setCellValue('B3', 'Tontine name');
                $sheet->setCellValue('B4', 'Circle');
                $sheet->setCellValue('B5', 'Number of member');
                $sheet->setCellValue('B6', 'Number of shares');
                $sheet->setCellValue('B7', 'Number of lot');
                $sheet->setCellValue('B8', 'Contribution amount');
                $sheet->setCellValue('B9', 'Number of month');
                $sheet->setCellValue('B10', 'Jackpot per member');
                $sheet->setCellValue('B11', 'Currency');
                $sheet->setCellValue('B12', 'Interest on loan');
                $sheet->setCellValue('B13', 'Cycle');
                $sheet->setCellValue('B14', 'Drawing type');
                $sheet->setCellValue('B15', 'Penalty on late payment ayant bouffé');
                $sheet->setCellValue('B16', 'Penalty on late payment n\'ayant pas bouffé');
                $sheet->setCellValue('B17', 'Penalty on the absence ayant bouffé');
                $sheet->setCellValue('B18', 'Penalty on the absence n\'ayant pas bouffé');
                $sheet->setCellValue('B19', 'Number of sessions');
                $sheet->setCellValue('B20', 'Cycle n°');


                $sheet->getStyle('B2:B20')->getFont()->setSize(13)->setBold( true );   //mettre en gras



                $sheet->setCellValue('C2', $qualitie->name);
                $sheet->setCellValue('C3', $tontine->name);
                $sheet->setCellValue('C4', $tontine->cercle);
                $sheet->setCellValue('C5', $nombre_membres);
                $sheet->setCellValue('C6', $nombre_parts);
                $sheet->setCellValue('C7', $tontine->numberlot);
                $sheet->setCellValue('C8', $tontine->coutshare);
                $sheet->setCellValue('C9', $nombre_mois);
                $sheet->setCellValue('C10', $tontine->coutshare * $nombre_parts);
                $sheet->setCellValue('C11', $tontine->monnaie);
                $sheet->setCellValue('C12', 'RAS');
                $sheet->setCellValue('C13', $tontine->periodicite);
                $sheet->setCellValue('C14', $drawingtype->name);

                if($tontine->typepenaliteretardsurlacontributionayantbouffe == "pourcentage"){
                    $sheet->setCellValue('C15', $tontine->penaliteretardsurlacontributionayantbouffe.'%');
                }
                else{
                    $sheet->setCellValue('C15', $tontine->penaliteretardsurlacontributionayantbouffe);
                }

                if($tontine->typepenaliteretardsurlacontributionnayantpasbouffe == "pourcentage"){
                    $sheet->setCellValue('C16', $tontine->penaliteretardsurlacontributionnayantpasbouffe.'%');
                }
                else{
                    $sheet->setCellValue('C16', $tontine->penaliteretardsurlacontributionnayantpasbouffe);
                }

                if($tontine->typepenaliteabsencesurlacontributionayantbouffe == "pourcentage"){
                    $sheet->setCellValue('C17', $tontine->penaliteabsencesurlacontributionayantbouffe.'%');
                }
                else{
                    $sheet->setCellValue('C17', $tontine->penaliteabsencesurlacontributionayantbouffe);
                }

                if($tontine->typepenaliteabsencesurlacontributionnayantpasbouffe == "pourcentage"){
                    $sheet->setCellValue('C18', $tontine->penaliteabsencesurlacontributionnayantpasbouffe.'%');
                }
                else{
                    $sheet->setCellValue('C18', $tontine->penaliteabsencesurlacontributionnayantpasbouffe);
                }

                $sheet->setCellValue('C19', $nombre_seance);

                $sheet->setCellValue('C20', $cycle->numerocycle);


                $sheet->getStyle('C2:C20')->getFont()->setSize(13);   //augmenter la taille


                if($drawingtype->name == "Alphabetically" || $drawingtype->name == "Random Draw"){

                    $sheet->setCellValue('A24', 'Session');
                    $sheet->setCellValue('B24', 'Période');
                    $sheet->setCellValue('C24', 'Heure');
                    $sheet->setCellValue('D24', 'Statut');
                    $sheet->setCellValue('E24', 'Contributions à obtenir');
                    $sheet->setCellValue('F24', 'Contributions reçues');
                    $sheet->setCellValue('G24', 'Pénalités à payer');
                    $sheet->setCellValue('H24', 'Pénalités payées');
                    $sheet->setCellValue('I24', 'Total des entrées');
                    $sheet->setCellValue('J24', 'Total des sorties');
                    $sheet->setCellValue('K24', 'Total en caisse');

                    $sheet->getStyle('A24:K24')->getFont()->setSize(13)->setBold( true );   //mettre en gras

                    $i = 25;    //pour commencer à la ligne 25
                    $total_somme_penalite_a_payer = 0;
                    $total_somme_penalite_payee = 0;
                    $total_somme_cotisation_reçue_entree = 0;
                    $total_somme_cotisation_reçue_sortie = 0;

                    //pour chaque séance, je dois calculer les contributions ainsi que les pénalités faites
                    if(!empty($seances)){
                        foreach( $seances as $seance){
                            //je calcule pour la séance les contributions faites et les pénalités payées

                            //calcul des contributions faites
                            $contributions = \DB::table('contributions')
                                ->where('seance_id','=',$seance->id)
                                ->where('typecontribution_id','=',2)        //2 pour cotisation
                                ->get();

                            $somme_cotisation_entree = 0;
                            $somme_cotisation_sortie = 0;
                            if(!empty($contributions)){
                                foreach($contributions as $calcul){
                                    $somme_cotisation_entree += $calcul->montant;
                                }
                            }

                            //$total_somme_cotisation_reçue_entree += $somme_cotisation_entree;

                            //on mets à jour total_somme_cotisation_reçue
                            if($seance->archived == 1){
                                $total_somme_cotisation_reçue_sortie += $somme_cotisation_entree;
                            }

                            $total_somme_cotisation_reçue_entree += $somme_cotisation_entree;

                            //calcul des pénalités à payer
                            $penalites_a_payer = \DB::table('penalites')
                                ->where('seance_id','=',$seance->id)
                                ->get();

                            $somme_penalite_a_payer = 0;
                            if(!empty($penalites_a_payer)){
                                foreach($penalites_a_payer as $penalite_a_payer){
                                    $somme_penalite_a_payer += $penalite_a_payer->penalite_a_payer;
                                }
                            }

                            //on mets à jour total_somme_penalite_a_payer
                            $total_somme_penalite_a_payer += $somme_penalite_a_payer;

                            //calcul des pénalités payées
                            $penalites_payees = \DB::table('contributions')
                                ->where('seance_id','=',$seance->id)
                                ->where('typecontribution_id','=',1)        //1 pour penalite
                                ->get();

                            $somme_penalite_payee = 0;
                            if(!empty($penalites_payees)){
                                foreach($penalites_payees as $penalite_payee){
                                    $somme_penalite_payee += $penalite_payee->montant;
                                }
                            }

                            //on mets à jour total_somme_penalite_payee
                            $total_somme_penalite_payee += $somme_penalite_payee;


                            //remplissage des cellules
                            $sheet->setCellValue('A'.$i, 'Session n°'.$seance->numero_seance);
                            $sheet->setCellValue('B'.$i, 'Du '.$seance->date_debut.' au '.$seance->date_fin);
                            $sheet->setCellValue('C'.$i, 'De '.$seance->heure_debut.' à '.$seance->heure_fin);

                            if($seance->archived == 1){ //1 pour dire terminée
                                $sheet->setCellValue('D'.$i, 'Session terminée');
                            }
                            else{
                                $sheet->setCellValue('D'.$i, 'Session en cours');
                            }

                            $sheet->setCellValue('E'.$i, $nombre_parts * $tontine->coutshare);
                            $sheet->setCellValue('F'.$i, $somme_cotisation_entree);
                            $sheet->setCellValue('G'.$i, $somme_penalite_a_payer);
                            $sheet->setCellValue('H'.$i, $somme_penalite_payee);
                            $sheet->setCellValue('I'.$i, $somme_cotisation_entree + $somme_penalite_payee);
                            //$sheet->setCellValue('J'.$i, $somme_cotisation);
                            //$sheet->setCellValue('K'.$i, $somme_penalite_payee);

                            if($seance->archived == 1){
                                $sheet->setCellValue('J'.$i, $somme_cotisation_entree);
                                $sheet->setCellValue('K'.$i, $somme_penalite_payee);
                            }
                            else{
                                $sheet->setCellValue('J'.$i, $somme_cotisation_sortie);
                                $sheet->setCellValue('K'.$i, $somme_penalite_payee + $somme_cotisation_entree - $somme_cotisation_sortie);
                            }

                            $i++;   //on passe à la ligne suivante

                        }

                        $total_somme_cotisation_a_obtenir = $nombre_seance * $nombre_parts * $tontine->coutshare;

                        //remplissage des cellules pour les totaux
                        $sheet->setCellValue('D'.$i, 'TOTAL');
                        $sheet->setCellValue('E'.$i, $total_somme_cotisation_a_obtenir);
                        $sheet->setCellValue('F'.$i, $total_somme_cotisation_reçue_entree);
                        $sheet->setCellValue('G'.$i, $total_somme_penalite_a_payer);
                        $sheet->setCellValue('H'.$i, $total_somme_penalite_payee);
                        $sheet->setCellValue('I'.$i, $total_somme_cotisation_reçue_entree + $total_somme_penalite_payee);
                        $sheet->setCellValue('J'.$i, $total_somme_cotisation_reçue_sortie);
                        $sheet->setCellValue('K'.$i, $total_somme_penalite_payee + $total_somme_cotisation_reçue_entree - $total_somme_cotisation_reçue_sortie);

                        $sheet->getStyle('D'.$i.':K'.$i)->getFont()->setSize(13)->setBold( true );   //mettre en gras


                        $i = $i + 3; // commencer à la ligne $i + 3

                        foreach($seances as $seance){
                            //entête de la partie pour montrer les membres ayant bouffés à une séance donnée
                            $sheet->setCellValue('A'.$i, 'Principal Jackpot '.$nombre_parts * $tontine->coutshare);
                            $sheet->getStyle('A'.$i)->getFont()->setSize(13)->setBold( true );   //mettre en gras

                            $i++; //on passe à la ligne suivante

                            $sheet->setCellValue('A'.$i, 'Session');
                            $sheet->setCellValue('B'.$i, 'Date');
                            $sheet->setCellValue('C'.$i, 'Lot N°');
                            $sheet->setCellValue('D'.$i, 'Montant lot');
                            $sheet->setCellValue('E'.$i, 'Part N°');
                            $sheet->setCellValue('F'.$i, 'Bénéficiaire');
                            $sheet->setCellValue('G'.$i, 'Avaliseur');
                            $sheet->setCellValue('H'.$i, 'Argent reçu par le bénéficiaire');
                            $sheet->setCellValue('I'.$i, 'Argent restant à bouffer');

                            $sheet->getStyle('A'.$i.':I'.$i)->getFont()->setSize(13)->setBold( true );   //mettre en gras

                            $i++;   //on passe à la ligne suivante

                            //je récupère les membres bénéficiaires de la séance
                            $beneficiaires = \DB::table('bouffes')
                                ->join('users','users.id','=','bouffes.user_id')
                                ->where('bouffes.seance_id','=',$seance->id)
                                ->select('bouffes.argent_a_bouffer_avant_toute_coupure as montant_lot','bouffes.somme as argent_recu',
                                    'bouffes.argent_restant_a_bouffer', 'bouffes.numero_part','bouffes.numero_lot','users.firstname',
                                    'users.lastname')
                                ->get();

                            $total_montant_lot = 0;
                            $total_argent_recu_par_le_beneficiaire = 0;
                            $total_argent_restant_a_bouffer = 0;

                            if(!empty($beneficiaires)){
                                foreach($beneficiaires as $beneficiaire){
                                    $montant_lot = ($nombre_parts * $tontine->coutshare) / $tontine->numberlot;

                                    $sheet->setCellValue('A'.$i, $seance->numero_seance);
                                    $sheet->setCellValue('B'.$i, 'Du '.$seance->date_debut.' au '.$seance->date_fin);
                                    $sheet->setCellValue('C'.$i, $beneficiaire->numero_lot);
                                    $sheet->setCellValue('D'.$i, $montant_lot);
                                    $sheet->setCellValue('E'.$i, $beneficiaire->numero_part);
                                    $sheet->setCellValue('F'.$i, $beneficiaire->firstname.' '.$beneficiaire->lastname);
                                    $sheet->setCellValue('G'.$i, $beneficiaire->firstname.' '.$beneficiaire->lastname);
                                    $sheet->setCellValue('H'.$i, $beneficiaire->argent_recu);
                                    $sheet->setCellValue('I'.$i, $beneficiaire->argent_restant_a_bouffer);

                                    $total_montant_lot += $montant_lot;
                                    $total_argent_recu_par_le_beneficiaire += $beneficiaire->argent_recu;
                                    $total_argent_restant_a_bouffer += $beneficiaire->argent_restant_a_bouffer;

                                    $i++; //on passe à la ligne suivante
                                }
                            }

                            //on remplit les différents totaux
                            $sheet->setCellValue('C'.$i, 'TOTAL');
                            $sheet->setCellValue('D'.$i, $total_montant_lot);
                            $sheet->setCellValue('H'.$i, $total_argent_recu_par_le_beneficiaire);
                            $sheet->setCellValue('I'.$i, $total_argent_restant_a_bouffer);


                            $sheet->getStyle('C'.$i.':D'.$i)->getFont()->setSize(13)->setBold( true );   //mettre en gras
                            $sheet->getStyle('H'.$i.':I'.$i)->getFont()->setSize(13)->setBold( true );   //mettre en gras

                            $i = $i + 2;

                        }




                    }

                }

                if($drawingtype->name == "Bid"){

                    $sheet->setCellValue('A24', 'Session');
                    $sheet->setCellValue('B24', 'Période');
                    $sheet->setCellValue('C24', 'Heure');
                    $sheet->setCellValue('D24', 'Statut');
                    $sheet->setCellValue('E24', 'Contributions à obtenir');
                    $sheet->setCellValue('F24', 'Contributions reçues');
                    $sheet->setCellValue('G24', 'Pénalités à payer');
                    $sheet->setCellValue('H24', 'Pénalités payées');
                    $sheet->setCellValue('I24', 'Montant Bid enregistré');
                    $sheet->setCellValue('J24', 'Total des entrées');
                    $sheet->setCellValue('K24', 'Total des sorties');
                    $sheet->setCellValue('L24', 'Total en caisse');

                    $sheet->getStyle('A24:L24')->getFont()->setSize(13)->setBold( true );   //mettre en gras

                    $i = 25;    //pour commencer à la ligne 25
                    $total_somme_penalite_a_payer = 0;
                    $total_somme_penalite_payee = 0;
                    $total_somme_cotisation_reçue_sortie = 0;
                    $total_somme_cotisation_reçue_entree = 0;
                    $total_somme_bid = 0;

                    //pour chaque séance, je dois calculer les contributions ainsi que les pénalités faites
                    if(!empty($seances)){
                        foreach( $seances as $seance){
                            //je calcule pour la séance les contributions faites et les pénalités payées

                            //je recense tout le montant bid enregistré
                            $montant_bid = \DB::table('contributions')
                                ->where('seance_id','=',$seance->id)
                                ->where('typecontribution_id','=',5)        //5 pour bid
                                ->get();

                            $somme_bid = 0;
                            if(!empty($montant_bid)){
                                foreach($montant_bid as $montant){
                                    $somme_bid += $montant->montant;
                                }
                            }

                            //on mets à jour total_somme_bid
                            $total_somme_bid += $somme_bid;

                            //calcul des contributions faites
                            $contributions = \DB::table('contributions')
                                ->where('seance_id','=',$seance->id)
                                ->where('typecontribution_id','=',2)        //2 pour cotisation
                                ->get();

                            $somme_cotisation_entree = 0;
                            $somme_cotisation_sortie = 0;
                            if(!empty($contributions)){
                                foreach($contributions as $calcul){
                                    $somme_cotisation_entree += $calcul->montant;
                                }
                            }

                            //on mets à jour total_somme_cotisation_reçue
                            if($seance->archived == 1){
                                $total_somme_cotisation_reçue_sortie += $somme_cotisation_entree;
                            }

                            $total_somme_cotisation_reçue_entree += $somme_cotisation_entree;

                            //calcul des pénalités à payer
                            $penalites_a_payer = \DB::table('penalites')
                                ->where('seance_id','=',$seance->id)
                                ->get();

                            $somme_penalite_a_payer = 0;
                            if(!empty($penalites_a_payer)){
                                foreach($penalites_a_payer as $penalite_a_payer){
                                    $somme_penalite_a_payer += $penalite_a_payer->penalite_a_payer;
                                }
                            }

                            //on mets à jour total_somme_penalite_a_payer
                            $total_somme_penalite_a_payer += $somme_penalite_a_payer;

                            //calcul des pénalités payées
                            $penalites_payees = \DB::table('contributions')
                                ->where('seance_id','=',$seance->id)
                                ->where('typecontribution_id','=',1)        //1 pour penalite
                                ->get();

                            $somme_penalite_payee = 0;
                            if(!empty($penalites_payees)){
                                foreach($penalites_payees as $penalite_payee){
                                    $somme_penalite_payee += $penalite_payee->montant;
                                }
                            }

                            //on mets à jour total_somme_penalite_payee
                            $total_somme_penalite_payee += $somme_penalite_payee;


                            //remplissage des cellules
                            $sheet->setCellValue('A'.$i, 'Session n°'.$seance->numero_seance);
                            $sheet->setCellValue('B'.$i, 'Du '.$seance->date_debut.' au '.$seance->date_fin);
                            $sheet->setCellValue('C'.$i, 'De '.$seance->heure_debut.' à '.$seance->heure_fin);

                            if($seance->archived == 1){ //1 pour dire terminée
                                $sheet->setCellValue('D'.$i, 'Session terminée');
                            }
                            else{
                                $sheet->setCellValue('D'.$i, 'Session en cours');
                            }

                            $sheet->setCellValue('E'.$i, $nombre_parts * $tontine->coutshare);
                            $sheet->setCellValue('F'.$i, $somme_cotisation_entree);
                            $sheet->setCellValue('G'.$i, $somme_penalite_a_payer);
                            $sheet->setCellValue('H'.$i, $somme_penalite_payee);
                            $sheet->setCellValue('I'.$i, $somme_bid);
                            $sheet->setCellValue('J'.$i, $somme_cotisation_entree + $somme_penalite_payee + $somme_bid);
                            if($seance->archived == 1){
                                $sheet->setCellValue('K'.$i, $somme_cotisation_entree);
                                $sheet->setCellValue('L'.$i, $somme_penalite_payee);
                            }
                            else{
                                $sheet->setCellValue('K'.$i, $somme_cotisation_sortie);
                                $sheet->setCellValue('L'.$i, $somme_penalite_payee + $somme_cotisation_entree - $somme_cotisation_sortie);
                            }

                            $i++;   //on passe à la ligne suivante

                        }

                        $total_somme_cotisation_a_obtenir = $nombre_seance * $nombre_parts * $tontine->coutshare;

                        //remplissage des cellules pour les totaux
                        $sheet->setCellValue('D'.$i, 'TOTAL');
                        $sheet->setCellValue('E'.$i, $total_somme_cotisation_a_obtenir);
                        $sheet->setCellValue('F'.$i, $total_somme_cotisation_reçue_entree);
                        $sheet->setCellValue('G'.$i, $total_somme_penalite_a_payer);
                        $sheet->setCellValue('H'.$i, $total_somme_penalite_payee);
                        $sheet->setCellValue('I'.$i, $total_somme_bid);
                        $sheet->setCellValue('J'.$i, $total_somme_cotisation_reçue_entree + $total_somme_penalite_payee);
                        $sheet->setCellValue('K'.$i, $total_somme_cotisation_reçue_sortie);
                        $sheet->setCellValue('L'.$i, $total_somme_penalite_payee + $total_somme_cotisation_reçue_entree - $total_somme_cotisation_reçue_sortie + $total_somme_bid);

                        $sheet->getStyle('D'.$i.':L'.$i)->getFont()->setSize(13)->setBold( true );   //mettre en gras


                        $i = $i + 3; // commencer à la ligne $i + 3

                        foreach($seances as $seance){
                            //entête de la partie pour montrer les membres ayant bouffés à une séance donnée
                            $sheet->setCellValue('A'.$i, 'Principal Jackpot '.$nombre_parts * $tontine->coutshare);
                            $sheet->getStyle('A'.$i)->getFont()->setSize(13)->setBold( true );   //mettre en gras

                            $i++; //on passe à la ligne suivante

                            $sheet->setCellValue('A'.$i, 'Session');
                            $sheet->setCellValue('B'.$i, 'Date');
                            $sheet->setCellValue('C'.$i, 'Lot N°');
                            $sheet->setCellValue('D'.$i, 'Montant lot');
                            $sheet->setCellValue('E'.$i, 'Part N°');
                            $sheet->setCellValue('F'.$i, 'Bénéficiaire');
                            $sheet->setCellValue('G'.$i, 'Avaliseur');
                            $sheet->setCellValue('H'.$i, 'Argent reçu par le bénéficiaire');
                            $sheet->setCellValue('I'.$i, 'Argent restant à bouffer');
                            $sheet->setCellValue('J'.$i, 'Argent d\'achat du lot');

                            $sheet->getStyle('A'.$i.':J'.$i)->getFont()->setSize(13)->setBold( true );   //mettre en gras

                            $i++;   //on passe à la ligne suivante

                            //je récupère les membres bénéficiaires de la séance
                            $beneficiaires = \DB::table('bouffes')
                                ->join('users','users.id','=','bouffes.user_id')
                                ->where('bouffes.seance_id','=',$seance->id)
                                ->select('bouffes.argent_a_bouffer_avant_toute_coupure as montant_lot','bouffes.somme as argent_recu',
                                    'bouffes.argent_restant_a_bouffer', 'bouffes.numero_part','bouffes.numero_lot','users.firstname',
                                    'users.lastname','users.id as user_id')
                                ->get();

                            $total_montant_lot = 0;
                            $total_argent_recu_par_le_beneficiaire = 0;
                            $total_argent_restant_a_bouffer = 0;
                            $total_contribution_bid = 0;

                            if(!empty($beneficiaires)){
                                foreach($beneficiaires as $beneficiaire){

                                    //je ressors la contribution type = bid du user
                                    $contribution_bid = \DB::table('contributions')
                                        ->where('seance_id','=',$seance->id)
                                        ->where('user_id','=',$beneficiaire->user_id)
                                        ->where('typecontribution_id','=',5)
                                        ->first();



                                    $montant_lot = ($nombre_parts * $tontine->coutshare) / $tontine->numberlot;

                                    $sheet->setCellValue('A'.$i, $seance->numero_seance);
                                    $sheet->setCellValue('B'.$i, 'Du '.$seance->date_debut.' au '.$seance->date_fin);
                                    $sheet->setCellValue('C'.$i, $beneficiaire->numero_lot);
                                    $sheet->setCellValue('D'.$i, $montant_lot);
                                    $sheet->setCellValue('E'.$i, $beneficiaire->numero_part);
                                    $sheet->setCellValue('F'.$i, $beneficiaire->firstname.' '.$beneficiaire->lastname);
                                    $sheet->setCellValue('G'.$i, $beneficiaire->firstname.' '.$beneficiaire->lastname);
                                    $sheet->setCellValue('H'.$i, $beneficiaire->argent_recu);
                                    $sheet->setCellValue('I'.$i, $beneficiaire->argent_restant_a_bouffer);

                                    if(!empty($contribution_bid)){
                                        $sheet->setCellValue('J'.$i, $contribution_bid->montant.' '.$tontine->monnaie);
                                    }
                                    else{
                                        $sheet->setCellValue('J'.$i, '0'.' '.$tontine->monnaie);
                                    }


                                    $total_montant_lot += $montant_lot;
                                    $total_argent_recu_par_le_beneficiaire += $beneficiaire->argent_recu;
                                    $total_argent_restant_a_bouffer += $beneficiaire->argent_restant_a_bouffer;

                                    if(!empty($contribution_bid)){
                                        $total_contribution_bid += $contribution_bid->montant;
                                    }

                                    $i++; //on passe à la ligne suivante
                                }
                            }

                            //on remplit les différents totaux
                            $sheet->setCellValue('C'.$i, 'TOTAL');
                            $sheet->setCellValue('D'.$i, $total_montant_lot);
                            $sheet->setCellValue('H'.$i, $total_argent_recu_par_le_beneficiaire);
                            $sheet->setCellValue('I'.$i, $total_argent_restant_a_bouffer);
                            $sheet->setCellValue('J'.$i, $total_contribution_bid);


                            $sheet->getStyle('C'.$i.':D'.$i)->getFont()->setSize(13)->setBold( true );   //mettre en gras
                            $sheet->getStyle('H'.$i.':J'.$i)->getFont()->setSize(13)->setBold( true );   //mettre en gras

                            $i = $i + 2;

                        }




                    }

                }


            });

            //pour afficher feuille2
            $excel->sheet('Membres', function($sheet) use ($data,$liste,$nombre_membres,$nombre_parts,$tontine_id,$seances,$nombre_seance,$cycle)
            {

                //$sheet->fromArray($data);

                $sheet->setCellValue('A1', 'Date');
                $sheet->setCellValue('B1', Carbon::now());


                $sheet->setCellValue('B2', 'Nombre de membre(s)');
                $sheet->setCellValue('C2', 'Nombre de part(s)');

//                $sheet->getStyle('B2')->getFont()->setSize(15);
//                $sheet->getStyle('C2')->getFont()->setSize(15);

                $sheet->getStyle('B2:C2')->getFont()->setSize(15)->setBold( true );


                $sheet->setCellValue('B3', $nombre_membres);
                $sheet->setCellValue('C3', $nombre_parts);

//                $sheet->getStyle('B3')->getFont()->setSize(15);
//                $sheet->getStyle('C3')->getFont()->setSize(15);

                $sheet->getStyle('B3:C3')->getFont()->setSize(15)->setBold( true );



                $sheet->setCellValue('A5', 'N°');
                $sheet->setCellValue('B5', 'Nom');
                $sheet->setCellValue('C5', 'Prénom');
                $sheet->setCellValue('D5', 'Email');
                $sheet->setCellValue('E5', 'Téléphone');
                $sheet->setCellValue('F5', 'Pays');
                $sheet->setCellValue('G5', 'Ville');
                $sheet->setCellValue('H5', 'Sexe');
                $sheet->setCellValue('I5', 'Nombre de part(s)');
                $sheet->setCellValue('J5', 'Statut');
                //$sheet->setCellValue('K4', 'User Id');

//                $sheet->getStyle('B5')->getFont()->setSize(15)->setBold( true );
//                $sheet->getStyle('C5')->getFont()->setSize(15)->setBold( true );
//                $sheet->getStyle('D5')->getFont()->setSize(15)->setBold( true );
//                $sheet->getStyle('E5')->getFont()->setSize(15)->setBold( true );
//                $sheet->getStyle('F5')->getFont()->setSize(15)->setBold( true );
//                $sheet->getStyle('G5')->getFont()->setSize(15)->setBold( true );
//                $sheet->getStyle('H5')->getFont()->setSize(15)->setBold( true );
//                $sheet->getStyle('I5')->getFont()->setSize(15)->setBold( true );
//                $sheet->getStyle('J5')->getFont()->setSize(15)->setBold( true );

                $sheet->getStyle('A5:J5')->getFont()->setSize(15)->setBold( true );


                //dd($liste);

                $i = 6;
                $num = 1;
                for ($j = 0; $j < sizeof($liste); $j++){
                    $sheet->setCellValue('A'.$i, $num);
                    $sheet->setCellValue('B'.$i, $liste[$j]["lastname"]);
                    $sheet->setCellValue('C'.$i, $liste[$j]["firstname"]);
                    $sheet->setCellValue('D'.$i, $liste[$j]["email"]);
                    $sheet->setCellValue('E'.$i, $liste[$j]["phone"]);
                    $sheet->setCellValue('F'.$i, $liste[$j]["pays"]);
                    $sheet->setCellValue('G'.$i, $liste[$j]["ville"]);
                    $sheet->setCellValue('H'.$i, $liste[$j]["sexe"]);

                    $num++; //on incrémente les numéros


                    //maintenant on compte le nombre de parts du user
                    $nbre_part = \DB::table('membrestontines')
                        ->where('tontine_id','=',$tontine_id)
                        ->where('user_id','=',$liste[$j]["user_id"])
                        ->get();

                    //dd($liste[$j]["user_id"]);

                    $nombre_part = 0;
                    foreach($nbre_part as $nombre){
                        $nombre_part ++;
                    }

                    //dd($nombre_part);


                    $sheet->setCellValue('I'.$i, $nombre_part);


                    if($liste[$j]["administrator"] == 1){
                        $sheet->setCellValue('J'.$i,'Administrateur');
                    }
                    else{
                        $sheet->setCellValue('J'.$i,'Membre');
                    }


//                    $sheet->getStyle('B'.$i)->getFont()->setSize(13);
//                    $sheet->getStyle('C'.$i)->getFont()->setSize(13);
//                    $sheet->getStyle('D'.$i)->getFont()->setSize(13);
//                    $sheet->getStyle('E'.$i)->getFont()->setSize(13);
//                    $sheet->getStyle('F'.$i)->getFont()->setSize(13);
//                    $sheet->getStyle('G'.$i)->getFont()->setSize(13);
//                    $sheet->getStyle('H'.$i)->getFont()->setSize(13);
//                    $sheet->getStyle('I'.$i)->getFont()->setSize(13);
//                    $sheet->getStyle('J'.$i)->getFont()->setSize(13);
                    //$sheet->setCellValue('K'.$i, $d->id);

                    $sheet->getStyle('B'.$i.':J'.$i)->getFont()->setSize(13);


                    $i++;

                }
                //$sheet->fromArray($data);


            });


            //pour afficher feuille3
            $excel->sheet('Penalty', function($sheet) use ($data,$liste,$nombre_membres,$nombre_parts,$tontine_id,$tontine,$seances,$nombre_seance,$cycle)
            {

                $sheet->setCellValue('A1', 'Date');
                $sheet->setCellValue('B1', Carbon::now());
                $sheet->setCellValue('C1', 'Cycle N° '.$cycle->numerocycle);

                $sheet->getStyle('C1')->getFont()->setBold( true );   //mettre en gras


                $i = 3; //pour commencer à partir de la ligne 3


                if(!empty($seances)){
                    //pour chaque séance du cycle, je prends les pénalités appliquées
                    foreach( $seances as $seance){

                        $num = 1;

                        $penalites = \DB::table('penalites')
                            ->join('users','users.id','=','penalites.user_id')
                            ->where('penalites.seance_id','=',$seance->id)
                            ->where('penalites.tontine_id','=',$tontine_id)
                            ->select('users.id as user_id','users.firstname','users.lastname','penalites.numero_part','penalites.type_penalite',
                                     'penalites.penalite_a_payer','penalites.statut_penalite')
                            ->orderBy('users.lastname','asc')
                            ->get();

                        $sheet->setCellValue('B'.$i, 'Session n° '.$seance->numero_seance);
                        $sheet->setCellValue('C'.$i, 'Start date : '.$seance->date_debut);
                        $sheet->setCellValue('D'.$i, 'End date : '.$seance->date_fin);
                        $sheet->setCellValue('E'.$i, 'Start time : '.$seance->heure_debut);
                        $sheet->setCellValue('F'.$i, 'End time : '.$seance->heure_fin);

                        if($seance->archived == 1){ //séance terminée
                            $sheet->setCellValue('G'.$i, 'Status : session terminée');        //terminé ou en cours
                        }
                        if($seance->archived == 0){ //séance en cours
                            $sheet->setCellValue('G'.$i, 'Status : session en cours');        //terminé ou en cours
                        }

                        $sheet->getStyle('B'.$i.':G'.$i)->getFont()->setBold( true );   //mettre en gras


                        $i++;   //passer à la ligne suivante

                        $sheet->setCellValue('A'.$i, 'N°');
                        $sheet->setCellValue('B'.$i, 'Firstname');
                        $sheet->setCellValue('C'.$i, 'Lastname');
                        $sheet->setCellValue('D'.$i, 'Share N°');
                        $sheet->setCellValue('E'.$i, 'Type');
                        $sheet->setCellValue('F'.$i, 'Penalty to pay');
                        $sheet->setCellValue('G'.$i, 'Advanced');
                        $sheet->setCellValue('H'.$i, 'Rest to pay');
                        $sheet->setCellValue('I'.$i, 'Status');
                        $sheet->setCellValue('J'.$i, 'Amount received');

                        $sheet->getStyle('A'.$i.':J'.$i)->getFont()->setBold( true );   //mettre en gras


                        $total_penalite_a_payer = 0;
                        $total_avance = 0;
                        $total_rest = 0;
                        if(!empty($penalites)){
                            $i++;   //on passe à la ligne suivante
                            foreach( $penalites as $penalite){
                                $sheet->setCellValue('A'.$i, $num);
                                $sheet->setCellValue('B'.$i, $penalite->firstname);
                                $sheet->setCellValue('C'.$i, $penalite->lastname);
                                $sheet->setCellValue('D'.$i, $penalite->numero_part);
                                $sheet->setCellValue('E'.$i, $penalite->type_penalite);
                                $sheet->setCellValue('F'.$i, $penalite->penalite_a_payer);

                                //dd($penalite->user_id);

                                $num++;     //on incrémente les numéros

                                //on doit calculer ce qui a déjà été payé
                                $somme = 0;
                                $calculs = \DB::table('contributions')
                                    ->where('user_id','=',$penalite->user_id)
                                    ->where('seance_id','=',$seance->id)
                                    ->where('typecontribution_id','=',1)    //1 pour penalite
                                    ->get();
                                if(!empty($calculs)){
                                    foreach( $calculs as $calcul){
                                        $somme += $calcul->montant;
                                    }
                                }

                                $total_penalite_a_payer += $penalite->penalite_a_payer;
                                $total_avance += $somme;
                                $total_rest += $penalite->penalite_a_payer - $somme;

                                $sheet->setCellValue('G'.$i, $somme);
                                $sheet->setCellValue('H'.$i, $penalite->penalite_a_payer - $somme);
                                $sheet->setCellValue('I'.$i, $penalite->statut_penalite);
                                $sheet->setCellValue('J'.$i, $somme);

                                $i++; //puis on passe à la ligne suivante
                            }

                        }
                        else{
                            $i++;
                        }

                        $sheet->setCellValue('D'.$i, 'TOTAL');

                        $sheet->setCellValue('F'.$i, $total_penalite_a_payer);     //ici on doit mettre le total des pénalités à payer

                        $sheet->setCellValue('G'.$i, $total_avance);     //ici on doit mettre le total des avances

                        $sheet->setCellValue('H'.$i, $total_rest);     //ici on doit mettre le total des restes à payer

                        $sheet->setCellValue('J'.$i, $total_avance);     //ici on doit mettre le total du amount received

                        $sheet->getStyle('D'.$i)->getFont()->setBold( true );   //mettre en gras
                        $sheet->getStyle('F'.$i)->getFont()->setBold( true );   //mettre en gras
                        $sheet->getStyle('G'.$i)->getFont()->setBold( true );   //mettre en gras
                        $sheet->getStyle('H'.$i)->getFont()->setBold( true );   //mettre en gras
                        $sheet->getStyle('J'.$i)->getFont()->setBold( true );   //mettre en gras


                        $i = $i+4; //j'espace de 4 lignes

                    }

                }

            });


            //pour afficher feuille4
            $excel->sheet('Contribution', function($sheet) use ($data,$liste,$nombre_membres,$nombre_parts,$tontine_id,$tontine,$seances,$nombre_seance,$cycle)
            {
                $sheet->setCellValue('A1', 'Date');
                $sheet->setCellValue('B1', Carbon::now());
                $sheet->setCellValue('C1', 'Cycle N° '.$cycle->numerocycle);

                $sheet->getStyle('C1')->getFont()->setBold( true );   //mettre en gras


                $i = 3;


                if(!empty($seances)){
                    //pour chaque séance du cycle, je prends les contributions versées
                    foreach( $seances as $seance){

                        $num = 1;

                        $contributions = \DB::table('contributions')
                            ->join('users','users.id','=','contributions.user_id')
                            ->where('contributions.seance_id','=',$seance->id)
                            ->where('contributions.typecontribution_id','=',2)     //2 pour cotisation
                            ->select('users.id as user_id','users.firstname','users.lastname','contributions.numero_part','contributions.montant',
                                'contributions.created_at')
                            ->orderBy('users.lastname','asc')
                            ->get();

                        $sheet->setCellValue('B'.$i, 'Session n° '.$seance->numero_seance);
                        $sheet->setCellValue('C'.$i, 'Start date : '.$seance->date_debut);
                        $sheet->setCellValue('D'.$i, 'End date : '.$seance->date_fin);
                        $sheet->setCellValue('E'.$i, 'Start time : '.$seance->heure_debut);
                        $sheet->setCellValue('F'.$i, 'End time : '.$seance->heure_fin);

                        if($seance->archived == 1){ //séance terminée
                            $sheet->setCellValue('G'.$i, 'Status : session terminée');        //terminé ou en cours
                        }
                        if($seance->archived == 0){ //séance en cours
                            $sheet->setCellValue('G'.$i, 'Status : session en cours');        //terminé ou en cours
                        }

                        $sheet->getStyle('B'.$i.':G'.$i)->getFont()->setBold( true );   //mettre en gras


                        $i++;   //passer à la ligne suivante

                        $sheet->setCellValue('A'.$i, 'N°');
                        $sheet->setCellValue('B'.$i, 'Firstname');
                        $sheet->setCellValue('C'.$i, 'Lastname');
                        $sheet->setCellValue('D'.$i, 'Share N°');
                        $sheet->setCellValue('E'.$i, 'Avanced');
                        $sheet->setCellValue('F'.$i, 'Rest to contribue');
                        $sheet->setCellValue('G'.$i, 'Device');
                        $sheet->setCellValue('H'.$i, 'Contribution date');
                        $sheet->setCellValue('I'.$i, 'Status');
                        $sheet->setCellValue('J'.$i, 'Amount');

                        $sheet->getStyle('A'.$i.':J'.$i)->getFont()->setBold( true );   //mettre en gras


                        $total_avance = 0;
                        $total_rest = 0;
                        if(!empty($contributions)){
                            $i++;   //on passe à la ligne suivante
                            foreach( $contributions as $contribution){
                                $sheet->setCellValue('A'.$i, $num);
                                $sheet->setCellValue('B'.$i, $contribution->firstname);
                                $sheet->setCellValue('C'.$i, $contribution->lastname);
                                $sheet->setCellValue('D'.$i, $contribution->numero_part);

                                $num++;     //on incrémente les numéros

                                //on doit calculer ce qui a déjà été payé
                                $somme = 0;
                                $calculs = \DB::table('contributions')
                                    ->where('user_id','=',$contribution->user_id)
                                    ->where('seance_id','=',$seance->id)
                                    ->where('numero_part','=',$contribution->numero_part)
                                    ->where('typecontribution_id','=',2)    //2 pour cotisation
                                    ->get();
                                if(!empty($calculs)){
                                    foreach( $calculs as $calcul){
                                        $somme += $calcul->montant;
                                    }
                                }

                                $total_avance += $somme;
                                $total_rest += $tontine->coutshare - $somme;

                                $sheet->setCellValue('E'.$i, $somme);
                                $sheet->setCellValue('F'.$i, $tontine->coutshare - $somme);
                                $sheet->setCellValue('G'.$i, $tontine->monnaie);
                                $sheet->setCellValue('H'.$i, $contribution->created_at);

                                if($total_rest == 0){
                                    $sheet->setCellValue('I'.$i, 'contribution complete');
                                }
                                else{
                                    $sheet->setCellValue('I'.$i, 'contribution incomplete');
                                }

                                $sheet->setCellValue('J'.$i, $total_avance);


                                $i++; //puis on passe à la ligne suivante
                            }

                        }
                        else{
                            $i++;
                        }

                        $sheet->setCellValue('D'.$i, 'TOTAL');

                        $sheet->setCellValue('E'.$i, $total_avance);     //ici on doit mettre le total des avances

                        $sheet->setCellValue('F'.$i, $total_rest);     //ici on doit mettre le total des restes à payer

                        $sheet->setCellValue('J'.$i, $total_avance);     //ici on doit mettre le total du amount received

                        $sheet->getStyle('D'.$i)->getFont()->setBold( true );   //mettre en gras
                        $sheet->getStyle('E'.$i)->getFont()->setBold( true );   //mettre en gras
                        $sheet->getStyle('F'.$i)->getFont()->setBold( true );   //mettre en gras
                        $sheet->getStyle('J'.$i)->getFont()->setBold( true );   //mettre en gras
                        //$sheet->getStyle('J'.$i)->getFont()->setBold( true );   //mettre en gras


                        $i = $i+4; //j'espace de 4 lignes

                    }

                }



            });


        })->download($type);

    }




    public function downloadExcelTest(){
        /******  Code pour download en format csv   ******/
        /*
        ini_set('max_execution_time', 0);
        $json=array('STATUS'=>false,'msg'=>'no file');
        $this->load->library('excel');
        $writer = PHPExcel_IOFactory::createWriter('Excel2007');
        */

        // write header


        //load our new PHPExcel library
        //$this->load->library('excel');
//activate worksheet number 1
        $this->excel->setActiveSheetIndex(0);
//name the worksheet
        $this->excel->getActiveSheet()->setTitle('Statistiques MSO');
//set cell A1 content with some text
        $this->excel->getActiveSheet()->setCellValue('A1', 'Nombre pharmacies visitees');
        $this->excel->getActiveSheet()->setCellValue('B1', 'Nombre prix ajustes');
        $this->excel->getActiveSheet()->setCellValue('C1', 'Nombre produits aux prix ajustes');
        $this->excel->getActiveSheet()->setCellValue('D1', 'Region');
        $this->excel->getActiveSheet()->setCellValue('E1', 'Date debut');
        $this->excel->getActiveSheet()->setCellValue('F1', 'Date fin');
        $this->excel->getActiveSheet()->setCellValue('A2', 10);
        $this->excel->getActiveSheet()->setCellValue('B2', 20);
        $this->excel->getActiveSheet()->setCellValue('C2', 12);
        $this->excel->getActiveSheet()->setCellValue('D2', 'Rond Point express');
        $this->excel->getActiveSheet()->setCellValue('E2', '12-12-2017');
        $this->excel->getActiveSheet()->setCellValue('F2', '10-04-2018');

        /*$this->excel->getActiveSheet()->setCellValue('A2', $nbrP);
        $this->excel->getActiveSheet()->setCellValue('B2', $nbrC);
        //$this->excel->getActiveSheet()->setCellValue('C2', $nbrD);
        $this->excel->getActiveSheet()->setCellValue('D2', $date_debut);
        $this->excel->getActiveSheet()->setCellValue('E2', $date_fin);*/


//change the font size
        $this->excel->getActiveSheet()->getStyle('A1')->getFont()->setSize(20);
        $this->excel->getActiveSheet()->getStyle('B1')->getFont()->setSize(20);
        $this->excel->getActiveSheet()->getStyle('C1')->getFont()->setSize(20);
        $this->excel->getActiveSheet()->getStyle('D1')->getFont()->setSize(20);
        $this->excel->getActiveSheet()->getStyle('E1')->getFont()->setSize(20);
        $this->excel->getActiveSheet()->getStyle('F1')->getFont()->setSize(20);

        /*$this->excel->getActiveSheet()->getStyle('A2')->getFont()->setSize(10);
        $this->excel->getActiveSheet()->getStyle('B2')->getFont()->setSize(10);
        $this->excel->getActiveSheet()->getStyle('C2')->getFont()->setSize(10);
        $this->excel->getActiveSheet()->getStyle('D2')->getFont()->setSize(10);
        $this->excel->getActiveSheet()->getStyle('E2')->getFont()->setSize(10);*/
//make the font become bold
        //$this->excel->getActiveSheet()->getStyle('A1')->getFont()->setBold(true);
//merge cell A1 until D1
        //$this->excel->getActiveSheet()->mergeCells('A1:D1');
//set aligment to center for that merged cell (A1 to D1)
        // $this->excel->getActiveSheet()->getStyle('A1')->getAlignment()->setHorizontal(PHPExcel_Style_Alignment::HORIZONTAL_CENTER);

        $filename='statistiques.csv'; //save our workbook as this file name
        header("Content-Type: text/csv; charset=utf-8");
        header('Content-Disposition: attachment;filename="'.$filename.'"'); //tell browser what's the file name
        header('Cache-Control: max-age=0'); //no cache

//save it to Excel5 format (excel 2003 .XLS file), change this to 'Excel2007' (and adjust the filename extension, also the header mime type)
//if you want to save it as .XLSX Excel 2007 format
        $objWriter = PHPExcel_IOFactory::createWriter($this->excel, 'CSV'); //on mets 'Excel5' pour générer un fichier Excel
//force user to download the Excel file without writing it to server's HD
        $objWriter->setDelimiter(';');  // Define delimiter
        $objWriter->save('php://output');


        /******         End code                    *****/
    }




    public function pdfview(Request $request)

    {

        $created_at = Carbon::now();

        $items = DB::table("users")->get();

        view()->share('items',$items);


        if($request->has('download')){

            $pdf = PDF::loadView('meeting.pdfviewNew');

            return $pdf->download('listofuser.pdf');

        }


        return view('meeting.pdfview');

    }



    public function object_to_array($data)
    {
        if (is_array($data) || is_object($data))
        {
            $result = array();
            foreach ($data as $key => $value)
            {
                $result[$key] = object_to_array($value);
            }
            return $result;
        }
        return $data;
    }



    public function excel() {

        // Execute the query used to retrieve the data. In this example
        // we're joining hypothetical users and payments tables, retrieving
        // the payments table's primary key, the user's first and last name,
        // the user's e-mail address, the amount paid, and the payment
        // timestamp.

//        $payments = Payment::join('users', 'users.id', '=', 'payments.id')
//            ->select(
//                'payments.id',
//                \DB::raw("concat(users.first_name, ' ', users.last_name) as `name`"),
//                'users.email',
//                'payments.total',
//                'payments.created_at')
//            ->get();



        // Initialize the array which will be passed into the Excel
        // generator.
        $paymentsArray = [];

        // Define the Excel spreadsheet headers
        $paymentsArray[] = ['id', 'customer','email','total','created_at'];

        $usersArray[] = ['id', 'firstname','lastname','email','created_at'];

        // Convert each member of the returned collection into an array,
        // and append it to the payments array.

        $usersArray = \DB::table('users')
            ->select('id','firstname','lastname','email')
            ->get()
            ->toArray();
        //dd($users);
//        foreach ($users as $payment) {
//            $usersArray[] = $payment->toArray();
//        }

        //dd($usersArray);

        // Generate and return the spreadsheet
        \Excel::create('users', function($excel) use ($usersArray) {


            $usersArray1 = \DB::table('users')
                ->get()
                ->toArray();

            // Convert each member of the returned collection into an array,
            // and append it to the payments array.
//            foreach ($users as $payment) {
//                $usersArray[] = $payment->toArray();
//            }


            // Set the spreadsheet title, creator, and description
            $excel->setTitle('Users');
            $excel->setCreator('Laravel')->setCompany('Christopher, TNC');
            $excel->setDescription('users file');



            // Build the spreadsheet, passing in the payments array
            $excel->sheet('sheet1', function($sheet) use ($usersArray1) {

                //dd($usersArray1);

                $sheet->fromArray($usersArray1, null, 'A1', false, false);
            });

        })->download('xls');
    }
}
