<?php namespace App\Http\Controllers;

use App\Repositories\UserRepository;

use PDF;
use DateTime;
use Input;

use Response;

use Request;

use Illuminate\Support\Facades\Auth;

//use Auth;

//use Illuminate\Http\Request;

use JWTAuth;

//use Tymon\JWTAuth\Exceptions\JWTException;


use App\Http\Controllers\Controller;

use Session;


use JWTAuthException;

use DB;

use Carbon\Carbon;

use Mail;

use GuzzleHttp\Client;

use PushNotification;

use Facebook;
use Facebook\Helpers\FacebookRedirectLoginHelper;
use Facebook\FacebookSDKException;
use Facebook\Authentication\OAuth2Client;

use Illuminate\Support\Facades\View;
use Illuminate\Support\ServiceProvider;
use Snowfire\Beautymail\Beautymail;



use Codebird\Codebird;


//use Illuminate\Http\Request;

use App\Http\Requests;

class ExterieurController extends Controller {

    /**
     * @var Guard
     */
    private $guard;

    public function __construct(
        UserRepository $user

    )



    {

//Dans ce middleware on met le nom des fonctions qui auront à utiliser le token

        $this->middleware('jwt.auth', ['except' => ['accueil','accueil1','login','index','register','logout','getUsers', 'getRole','deleteUser','activeUser','updateRoleUser','signUp','getUser','updateUser', 'signIn', 'getUserProfil', 'getTypePaiement', 'PaymentMethod', 'UpdatePaymentMethod', 'CreateGradeLevel', 'UpdateGradeLevel', 'CreateTrip',
            'UpdateTrip', 'getPaymentMethod', 'getGradeLevel', 'getTrip', 'EditProfileUser', 'SendCodeToChangePassword', 'confirmCode', 'changePassword',
            'changePasswordWeb', 'createCompteUserTemporaire', 'testMoMo','signInSpecial','MTNMobileMoney','createExperienceUser','EditExperienceUser','getExperienceUser'
            ,'delai', 'getAllFeedBack', 'saveFeedBack', 'viewUpdateUser','index1','updateStatut', 'addUser','saveUser', 'getUserProfilwithId'
        ]]);

        // $this->guard = \Auth::guard('api');
    }



//    public function delai($delai){
//        $date_courante = new DateTime(carbon::now());
//        $difference = $delai - $date_courante;
//        if($difference > 0){
//            //alors tesmp écoulé
//            //echo link_to('http://toupesu.sdkgames.com/tontine/join-tontine');
//
//            return redirect('http://toupesu.sdkgames.com/tontine/join-tontine');
//        }
//
//    }

    
    //permet de get les users
    public function getUser(){
       $users = \DB::table('users')
                ->join('roles','roles.id','=','users.role_id')
                ->select('users.id','users.username','users.phone','users.email','users.role_id','roles.slug as role_name','users.active',
                         'users.created_at', 'users.updated_at')
                ->get();
       
       return response()->json(['message' => 'success', 'users' => $users]);         
                    
    }
    
    //permet d'update les infos d'un user
    public function updateUser($token){
        $request = Request::instance();
        $data = json_decode($request->getContent());
        
        $username = $data->username;
        $phone = $data->phone;
        $email = $data->email;
        
        if($username == NULL || $phone == NULL || $email == NULL){
            return response()->json(['message' => 'error', 'user_not_exist' => false, 'remplir_tous_les_champs' => true,
                                     'email_already_exist' => false, 'username_already_exist' => false, 'phone_already_exist' => false], 400); 
        }
        
        //I check if user exist
        $check = \DB::table('users')
                ->where('remember_token','=',$token)
                ->first();
        
        if(empty($check)){
           return response()->json(['message' => 'error', 'user_not_exist' => true, 'remplir_tous_les_champs' => false,
                                    'email_already_exist' => false, 'username_already_exist' => false, 'phone_already_exist' => false], 400); 
        }
        
        
        //je vérifie si l'email existe déjà en BD
        $check_email = \DB::table('users')
                ->where('email','=',$email)
                ->first();
        
        if(!empty($check_email)){
            if($check_email->id != $user_id){
                return response()->json(['message' => 'error', 'user_not_exist' => false, 'remplir_tous_les_champs' => false,
                                         'email_already_exist' => true, 'username_already_exist' => false, 'phone_already_exist' => false ], 400); 
            }
        }
        
        //je vérifie si le username existe déjà en BD
        $check_username = \DB::table('users')
                ->where('username','=',$username)
                ->first();
        
        if(!empty($check_username)){
            if($check_username->id != $user_id){
                return response()->json(['message' => 'error', 'user_not_exist' => false, 'remplir_tous_les_champs' => false,
                                         'email_already_exist' => false, 'username_already_exist' => true, 'phone_already_exist' => false ], 400); 
            }
        }
        
        
        //je vérifie si le phone existe déjà en BD
        $check_phone = \DB::table('users')
                ->where('phone','=',$phone)
                ->first();
        
        if(!empty($check_phone)){
            if($check_phone->id != $user_id){
                return response()->json(['message' => 'error', 'user_not_exist' => false, 'remplir_tous_les_champs' => false,
                                         'email_already_exist' => false, 'username_already_exist' => false, 'phone_already_exist' => true ], 400); 
            }
        } 
        
        //j'update les données en BD
        \DB::table('users')
            ->where('remember_token','=',$token)
            ->update([
                        'username' => $username,
                        'email' => $email,
                        'phone' => $phone,
                        'updated_at' => Carbon::now()
                    ]);
        
        return response()->json(['message' => 'success']);             
                
    }
    
    
    //permet de supprimer ou désactiver un user
    public function deleteUser($user_id){
        //I check if user exist
        $check = \DB::table('users')
                ->where('id','=',$user_id)
                ->first();
                
        if(empty($check)){
            return response()->json(['message' => 'error', 'user_not_exist' => true], 400);
        }
        
        //je désactive le user
        \DB::table('users')
            ->where('id','=',$user_id)
            ->update([
                        'active' => 0,
                        'updated_at' => Carbon::now()
                    ]);
        
        return response()->json(['message' => 'success']);    
        
    }
    
    
    //permet d'activer un user
    public function activeUser($user_id){
        //I check if user exist
        $check = \DB::table('users')
                ->where('id','=',$user_id)
                ->first();
                
        if(empty($check)){
            return response()->json(['message' => 'error', 'user_not_exist' => true], 400);
        }
        
        //j'active le user
        \DB::table('users')
            ->where('id','=',$user_id)
            ->update([
                        'active' => 1,
                        'updated_at' => Carbon::now()
                    ]);
        
        return response()->json(['message' => 'success']);
        
    }
    
    
    //permet de changer le rôle d'un user
    public function updateRoleUser($user_id){
        $request = Request::instance();
        $data = json_decode($request->getContent());
        
        $role_id = $data->role_id;
        
        //I check if user exist
        $check = \DB::table('users')
                ->where('id','=',$user_id)
                ->first();
                
        if(empty($check)){
            return response()->json(['message' => 'error', 'user_not_exist' => true, 'role_id_not_exist' => false], 400);
        }
        
        //I check if role_id exist
        $check_role = \DB::table('roles')
                ->where('id','=',$role_id)
                ->first();
                
        if(empty($check_role)){
            return response()->json(['message' => 'error', 'user_not_exist' => false, 'role_id_not_exist' => true], 400);
        }        
        
        //je change le rôle du user
        \DB::table('users')
            ->where('id','=',$user_id)
            ->update([
                        'role_id' => $role_id,
                        'updated_at' => Carbon::now()
                    ]);
        
        return response()->json(['message' => 'success']);
        
    }
    
    
    public function logout(){
        auth()->logout();

        //session()->flash('message', 'Some goodbye message');

        //return redirect('/login');

        return redirect('/')->with(['message' => 0]);
    }

    // permet de renvoyer la page d'accueil du login
    public function accueil(){
        return view ('login')->with(['message' => 0]);
    }

    public function accueil1($message){

        return view('login')->with(['message' => $message]);
    }

    //permet de prendre les infos pour se login côté backend
    public function login(Request $request){

        $request = Request::instance();

        //$pseudo_or_email = $request->input('pseudo_or_email');
        //$password = $request->input('password');

        $index = filter_var($request->input('username_or_email'), FILTER_VALIDATE_EMAIL) ? 'email' : 'username';

        $credentials[$index] = $request->input('username_or_email');
        $credentials['password'] = $request->input('password');

        try {
            // verify the credentials and create a token for the user
            if (! $token = JWTAuth::attempt($credentials)) {

                $message = 'Les informations entrées sont incorrectes. Veuillez réessayer !!!';
                $message = 1;

                echo '<div class = "alert alert-danger alert-dismissable" style="position: absolute;top: 150px;
                                right: 10px;z-index: 1000;width: 300px;height: 250px;">
                               <button type = "button" class = "close" data-dismiss = "alert" aria-hidden = "true">&times; </button>
                                  <h4>Error</h4><hr>
                                <b>' . $message . '.</b>
                            </div>';

                echo "<script>alert('Les informations entrées sont incorrectes. Veuillez réessayer !!!');</script><br/>";

                return redirect('/1')->with(['message' => 1]);
            }
        } catch (JWTException $e) {
            // something went wrong
            $message = 'Erreur Serveur. Veuillez réessayer !!!';

            $message = 2;

            echo '<div class = "alert alert-danger alert-dismissable" style="position: absolute;top: 150px;
                                right: 10px;z-index: 1000;width: 300px;height: 250px;">
                               <button type = "button" class = "close" data-dismiss = "alert" aria-hidden = "true">&times; </button>
                                  <h4>Error</h4><hr>
                                <b>' . $message . '.</b>
                            </div>';
            echo "<script>alert('Erreur Serveur. Veuillez réessayer !!!');</script><br/>";

            return redirect('/2')->with(['message' => 2]);
        }



        // Get the currently authenticated user...
        //$user = Auth::user();

        $user = Auth::user();
        $username = $user->username;
        $role = 'user';

        if($user->role_id == 1){
            $role = 'Administrator';
        }

        if($user->confirmed AND $user->role_id == 1){
            //ici on stocke le token avec lequel il sera connecté
            \DB::table('users')
                ->where('id','=',$user->id)
                ->update([
                    'remember_token' => $token
                ]);

        }
        else{
            $message = 'Vous n\'avez pas les droits de vous connecter. Veuillez contacter l\'administrateur !!!';

            $message = 3;

            /*echo '<div class = "alert alert-danger alert-dismissable" style="position: absolute;top: 150px;
                                right: 10px;z-index: 1000;width: 300px;height: 250px;">
                               <button type = "button" class = "close" data-dismiss = "alert" aria-hidden = "true">&times; </button>
                                  <h4>Error</h4><hr>
                                <b>' . $message . '.</b>
                            </div>';*/

            echo "<script>alert('Vous n\'avez pas les droits de vous connecter. Veuillez contacter l\'administrateur !!!');</script><br/>";

            return redirect('/3')->with(['message' => 3]);
        }

        //Session::set('username', $username);

        //session(['username' => $username]);
        session(['statut' => $role]);

        $request->session()->put('username', $username);

        //dd(Auth::id());

        return redirect('/home/'.$username)->with(['username'=> $username, Auth::user()]);
    }


    //permet de renvoyer le dashboard
    public function index($username){
        $users = \DB::table('users')
            ->get();

        session(['username' => $username]);

        return view('katika.index')->with(['users' => $users,'username'=> $username]);
    }

    //permet de renvoyer le dashboard
    public function index1(){
        $users = \DB::table('users')
            ->get();


        return view('katika.index')->with(['users' => $users]);
    }

    //permet de renvoyer la liste des users enregistrés
    public function getUsers(){
        $users = \DB::table('users')
            ->join('roles','roles.id','=','users.role_id')
            ->select('users.id as user_id','users.username','users.email','users.created_at','roles.title','roles.id as role_id')
            ->get();

        //dd($users);

        return view('katika.user_save')->with(['users' => $users]);
    }


    // permet de renvoyer la page d'accueil du register
    public function register(){
        return view ('register');
    }


    //permet d'update les infos sur un user
    public function viewUpdateUser($user_id){

        $find=\DB::table('users')
            ->where('id', $user_id)
            ->get();

        //dd($find);

        return view('katika.edit_user')->with(['edit' => $find, 'user_id' => $user_id]);


        // else{  

        //     \DB::table('users')
        //         ->where('id', $request['id'])
        //         ->delete();

        //     $liste = \DB::table('users')
        //         ->get();
        //     //var_dump($liste);

        //     return view('katika.liste_users')->with(['liste' => $liste]);
        // }

    }



    //permet d'update le statut du user
    public function updateStatut(){
        $request = Request::instance();

        $role_id = $request['statut'];
        $user_id = $request['user_id'];

        \DB::table('users')
            ->where('id', $user_id)
            ->update([
                'role_id' =>$role_id,
                'updated_at' => Carbon::now()
            ]);

        $users = \DB::table('users')
            ->join('roles','roles.id','=','users.role_id')
            ->select('users.id as user_id','users.username','users.email','users.created_at','roles.title','roles.id as role_id')
            ->get();

        //dd($users);

        return view('katika.user_save')->with(['users' => $users]);


    }

    //permet de renvoyer la vue pour add un user
    public function addUser(){


        return view('katika.add_user');
    }

    //permet d'enregistrer le user
    public function saveUser(){
        $request = Request::instance();

        $username = $request['username'];
        $email = $request['email'];
        $statut = $request['statut'];


        $test1 = \DB::table('users')
            ->where('username','=',$username)
            ->first();


        $test2 = \DB::table('users')
            ->where('email','=',$email)
            ->first();



        if($test1 != NULL){
            echo "<script>alert('Ce username existe déjà !!!');</script><br/>";
            return view('katika.add_user2')->with(['username' => $username, 'email' => $email, 'statut' => $statut]);
        }

        if($test2 != NULL){
            echo "<script>alert('Cet email existe déjà !!!');</script><br/>";
            return view('katika.add_user2')->with(['username' => $username, 'email' => $email, 'statut' => $statut]);
        }

        //insertion dans la table users
        \DB::table('users')
            ->insert([
                [
                    'username' => $username,
                    'email' => $email,
                    'role_id' => $statut,
                    'badge_id' => 1,
                    'password' => bcrypt($username),
                    'temporaire' => 0,
                    'created_at' => Carbon::now(),
                    'updated_at' => Carbon::now()
                ]
            ]);

        echo "<script>alert('User ajouté avec succès !!!');</script><br/>";


        return view('katika.add_user');

    }


    //permet de get tous les rôles
    public function getRole(){
        $role = \DB::table('roles')
            ->get();

        return response()->json(['message' => 'success','roles' => $role]);
            
    }


    // permet d'enregistrer un user

    public function signUp(Request $request)

    {

        $request = Request::instance();
        $content = $request->getContent();
        $tab=json_decode($content,TRUE);

        $email = $tab['email'];
        $phone = $tab['phone'];
        $username = $tab['username'];
        $password = $tab['password'];
        $role_id = $tab['role_id'];
        //$lastname = $tab['lastName'];
        //$firstname = $tab['firstName'];
        //$sexe = $tab['sexe'];
        //$ville = $tab['ville'];
        //$pays = $tab['pays'];
        $pays = NULL;


        $date_courante = Carbon::now();
        $date = new DateTime($date_courante);
        $dateValable = clone $date;
        $dateValable->modify('+2 hour');
        //$dateValable contient la date courante +1h heure de l'afrique du sud

        $new = $dateValable->format('Y-m-d H:i:s');



        //$device_id = $tab['token_notification'];

        if($email == NULL || $phone == NULL || $username == NULL || $role_id == NULL){
            return response()->json(['message' => 'error','email_exist_already' => false, 'phone_exist_already' => false, 'username_exist_already' => false, 'parametre_found' => true,'role_id_not_exist' => false], 400);
        }

        //$role_id = 3 ;  //par défaut role = utilisateur

        //je contrôle si le role_id existe bien
        $role = \DB::table('roles')
            ->where('id','=', $role_id)
            ->first();

        if(empty($role)){
            return response()->json(['message' => 'error','email_exist_already' => false, 'phone_exist_already' => false, 'username_exist_already' => false,
                'parametre_found' => false, 'role_id_not_exist' => true], 400);
        }    

        $user_email = \DB::table('users')
            ->where('email','=',$email)
            ->first();

        $user_phone = \DB::table('users')
            ->where('phone','=',$phone)
            ->first();

        $user_username = \DB::table('users')
            ->where('username','=',$username)
            ->first();

        if(!empty($user_email))                        //ici on contrôle si l'email du user existe déjà dans la BD
        {
           
            return response()->json(['message' => 'error','email_exist_already' => true, 'phone_exist_already' => false, 'username_exist_already' => false,
                'parametre_found' => false, 'role_id_not_exist' => false], 400);
        }

        if(!empty($user_phone))                        //ici on contrôle si le phone du user existe déjà dans la BD
        {
            return response()->json(['message' => 'error','email_exist_already' => false, 'phone_exist_already' => true, 'username_exist_already' => false,
                'parametre_found' => false, 'role_id_not_exist' => false], 400);
        }

        if(!empty($user_username))                        //ici on contrôle si le username existe déjà dans la BD
        {
          return response()->json(['message' => 'error','email_exist_already' => false, 'phone_exist_already' => false, 'username_exist_already' => true,
                'parametre_found' => true, 'role_id_not_exist' => false], 400);
        }

        if($email != NULL){
            $credentials['email'] = $email;
        }

        if($phone != NULL){
            $credentials['phone'] = $phone;
        }

        $credentials['password'] = $password;

        $tab['confirmed']= true;

         //insertion des données dans la table users
        \DB::table('users')
            ->insert([
                [
                    'username' => $username,
                    'phone' => $phone,
                    'email' => $email,
                    'password' => bcrypt($password),
                    'role_id' => $role_id,
                    'confirmed' => $tab['confirmed'],
                    'statut_update' => 0,
                    'active' => 1,
                    'created_at' => Carbon::now(),
                    'updated_at' => Carbon::now()
                ]
            ]);

        $user = \DB::table('users')
            ->where('email','=',$email)
            ->first();

        $role=\DB::table('roles')
            ->where('id', $role_id)
            ->first();

        try {
            $token = JWTAuth::attempt($credentials);
        } catch (\Exception $e)
        {
            $retour = array ('message' => 'invalid_credentials' );
            return response::json($retour);
        }

        //ici on stocke le token avec lequel il sera connecté
        \DB::table('users')
            ->where('email','=',$email)
            ->update([
                'remember_token' => $token
            ]);

        $user = \DB::table('users')
            ->where('email','=',$email)
            ->first();

        return response()->json(['message' => 'success', 'token' => $token, 'role' => $role->slug, 'user' => $user]);

    }



    //permet de connecter un user (login)
    public function signIn(Request $request){

        $request = Request::instance();
        $data = json_decode($request->getContent());


        //renvoit l'index (email ou phone) en fonction de ce que le user saisit
        $index = filter_var($data->email_or_phone, FILTER_VALIDATE_EMAIL) ? 'email' : 'phone';

        // dd($index);

        $credentials[$index] = $data->email_or_phone;

        $credentials['password'] = $data->password;

        //$device_id = $data->token_notification;
        $device_id = NULL;

        $date_courante = Carbon::now();
        $date = new DateTime($date_courante);
        $dateValable = clone $date;
        $dateValable->modify('+2 hour');
        //$dateValable contient la date courante +1h heure de l'afrique du sud

        $new = $dateValable->format('Y-m-d H:i:s');



        try {
            // verify the credentials and create a token for the user
            if (! $token = /*$this->guard->attempt*/JWTAuth::attempt($credentials)) {
                return response()->json(['user_not_found' => true], 401);
            }
        } catch (JWTAuthException $e) {
            // something went wrong
            return response()->json(['message' => 'error'], 500);
        }

        $user = /*JWTAuth::toUser($token)*//*$this->guard->user()*/Auth::user();
        $role=\DB::table('roles')
            ->where('id', $user->role_id)
            ->first();

        if($user->confirmed){

            if($index == "email"){
                if($device_id != NULL){ //si le user s'est connecté avec son téléphone je mets à jour son device_id
                    //ici on stocke le token avec lequel il sera connecté
                    \DB::table('users')
                        ->where('email','=',$data->email_or_phone)
                        ->update([
                            'remember_token' => $token,
                            'device_id' => $device_id
                        ]);
                }else{
                    //ici on stocke le token avec lequel il sera connecté
                    \DB::table('users')
                        ->where('email','=',$data->email_or_phone)
                        ->update([
                            'remember_token' => $token
                        ]);
                }

            }

            if($index == "username"){
                if($device_id != NULL){     //alors le user s'est connecté avec son téléphone et on mets son device_id à jour
                    //ici on stocke le token avec lequel il sera connecté
                    \DB::table('users')
                        ->where('username','=',$data->email_or_phone)
                        ->update([
                            'remember_token' => $token,
                            'device_id' => $device_id
                        ]);
                }
                else{
                    //ici on stocke le token avec lequel il sera connecté
                    \DB::table('users')
                        ->where('username','=',$data->email_or_phone)
                        ->update([
                            'remember_token' => $token
                        ]);
                }

            }
            
            $user = \DB::table('users')
                ->select('users.id','users.username','users.phone','users.email','users.role_id','users.active',
                         'users.created_at', 'users.updated_at')
                ->where('remember_token','=',$token)         
                ->first();

            // if no errors are encountered we can return a JWT
            return  response::json(['message' =>'success','token' =>$token,'user'=>$user,'role'=>$role->slug]);
        }
        else{
            return response()->json(['user_not_found' => true], 401);
        }
    }


    //permet de donner le profil d'un user
    public function getUserProfil($token){

        $user = \DB::table('users')
            ->where('remember_token','=',$token)
            ->first();

        if(!empty($user)){

            $badge = \DB::table('typebadges')
                ->where('id','=',$user->badge_id)
                ->first();

            $nombre_fois_win = \DB::table('nombre_fois_win_or_lose')
                ->where('statut','=','win')
                ->where('user_id','=',$user->id)
                ->count();

            $nombre_fois_lose = \DB::table('nombre_fois_win_or_lose')
                ->where('statut','=','lose')
                ->where('user_id','=',$user->id)
                ->count();

            return response()->json(['token' => $token,'user' => $user, 'badge_name' => $badge->name, 'nombre_fois_win' => $nombre_fois_win,
                'nombre_fois_lose' => $nombre_fois_lose]);
        }
        else{
            return response()->json(['message' => 'error', 'token' => false], 400);
        }
    }




    //permet de donner le profil d'un user avec user_id
    public function getUserProfilwithId($user_id){

        $user = \DB::table('users')
            ->where('id','=',$user_id)
            ->first();

        if(!empty($user)){

            $badge = \DB::table('typebadges')
                ->where('id','=',$user->badge_id)
                ->first();

            $nombre_fois_win = \DB::table('nombre_fois_win_or_lose')
                ->where('statut','=','win')
                ->where('user_id','=',$user_id)
                ->count();

            $nombre_fois_lose = \DB::table('nombre_fois_win_or_lose')
                ->where('statut','=','lose')
                ->where('user_id','=',$user_id)
                ->count();

            return response()->json(['token' => $user->remember_token,'user' => $user, 'badge_name' => $badge->name, 'nombre_fois_win' => $nombre_fois_win,
                'nombre_fois_lose' => $nombre_fois_lose]);
        }
        else{
            return response()->json(['message' => 'error', 'token' => false], 400);
        }
    }





    //permet d'enregistrer le feedback fait par le user
    public function saveFeedBack(){
        $request = Request::instance();
        $data = json_decode($request->getContent());

        //$username = $data->username;
        $email = $data->email;
        $suggestion = $data->suggestion;
        //$appreciation = $data->appreciation;
        //$autres = $data->autres;
        //$rapport_bug = $data->rapport_bug;
        $note_sur_5 = $data->note_sur_5;


        $date_courante = Carbon::now();
        $date = new DateTime($date_courante);
        $dateValable = clone $date;
        $dateValable->modify('+2 hour');
        //$dateValable contient la date courante +1h heure de l'afrique du sud

        $new = $dateValable->format('Y-m-d H:i:s');


        if(/*$username == NULL AND*/ $note_sur_5 == NULL AND $email == NULL){
            return response()->json(['message' => 'error', 'remplir_les_champs_email_et_note_sur_5' => true/*, 'email_already_exist' => false*/], 400);
        }

        /*$statut_email = \DB::table('feedback')
            ->where('email','=',$email)
            ->first();

        if(!empty($statut_email)){
            return response()->json(['message' => 'error', 'remplir_les_champs_email_et_note_sur_5' => false, 'email_already_exist' => true], 400);
        }*/

        //if(/*$username != NULL AND*/ $note_sur_5 != NULL AND $email != NULL){
        \DB::table('feedback')
            ->insert([
                [
                    //'username' => $username,
                    'email' => $email,
                    'suggestions' => $suggestion,
                    //'appreciations' => $appreciation,
                    //'autres' => $autres,
                    //'rapport_bug' => $rapport_bug,
                    'note_sur_5' => $note_sur_5,
                    'created_at' => $new/*Carbon::now()*/,
                    'updated_at' => $new/*Carbon::now()*/
                ]
            ]);
        //}




        //**************** Partie pour l'envoi du feedback par mail  /

        //partie pour envoyer le feedback par mail au user
        //$message = " Cher utilisateur,  \r\n \r\n voici le code à utiliser pour changer votre mot de passe";

        $message = " Dear user, \r\n \r\n here is the code to use to change your password";

        //$message = $message . "\r\n \r\n \r\n Note:Veuillez rafraichir votre page de vote Merci." ;
        //$subject = 'Changer le mot de passe du compte';


        $title = 'Feedback from an app user';

        $subject = 'New Feedback';

        //if (filter_var($data->email_or_phone, FILTER_VALIDATE_EMAIL)) {
        $data1 = [
            'from' => 'katika@api.visavisbet.com'/*'visavis@api.visavisbet.com'*/,
            'from_name' => 'VisavisBet',
            'to' => 'feedback@visavisbet.com',
            'subject' => $subject,
            'title' => $title,
            'email' => $email,
            'suggestion' => $suggestion,
            //'email' => '  Email : ' . $value->email,
            //'password' => $password,
            // 'download' => '  Download the application with the following link to connect ....' .
            //   ' Well after you can change your password. Thanks you',
            'note_sur_5' => $note_sur_5,
            'created_at' => $new
        ];

//                    Mail::send('tontine.reset_password', $data1, function ($message) use ($data1) {
//                        $message->from($data1['from'], $data1['from_name']);
//                        $message->to($data1['to'])->subject($data1['subject']);
//                    });

        $beautymail = app()->make(Beautymail::class);
        $beautymail->send('tontine.feedback', $data1, function($message) use ($data1)
        {
            //$email = $test->email_or_phone;
            $message->from($data1['from'],$data1['from_name']);
            $message->to($data1['to'])->subject($data1['subject']);
        });


        //}

        //**************************** end mail ***************************************************




        return response()->json(['message' => 'success']);
    }


    //permet de renvoyer tous les feedback enregistrés
    public function getAllFeedBack(){
        $feedback = \DB::table('feedback')
            ->orderBy('created_at','desc')
            ->get();

        return response()->json(['feedback' => $feedback]);
    }

















    //permet d'éditer les infos sur un user   astuce: créer un table users_history où les champs username, phone et email ne seront pas unique
    public function EditProfileUser($token){

        if (isset($_SERVER['HTTP_ORIGIN']))
        {

            //header("Access-Control-Allow-Origin: {$_SERVER['HTTP_ORIGIN']}");

            header('Access-Control-Allow-Credentials: true');

            header('Access-Control-Max-Age: 86400');    // cache for 1 day

        }


// Access-Control headers are received during OPTIONS requests

        if ($_SERVER['REQUEST_METHOD'] == 'OPTIONS') {

            if (isset($_SERVER['HTTP_ACCESS_CONTROL_REQUEST_METHOD']))

                header("Access-Control-Allow-Methods: GET, POST,PUT,DELETE, OPTIONS");
            header("Content-Type: application/json");



            if (isset($_SERVER['HTTP_ACCESS_CONTROL_REQUEST_HEADERS']))

                header("Access-Control-Allow-Headers:{$_SERVER['HTTP_ACCESS_CONTROL_REQUEST_HEADERS']}");



            exit(0);

        }



        $request = Request::instance();
        $data = json_decode($request->getContent());

        $username = $data->username;
        $lastname = $data->lastName;
        $firstname = $data->firstName;
        //$phone = $data->phone;
        //$email = $data->email;
        //$password = $data->password;
        $sexe = $data->sexe;
        $pays = $data->pays;
        $ville = $data->ville;
        $address = $data->address;
        $profession = $data->profession;
        $experience = ''/*$data->experience*/;

        //ça nous permettre de gérer l'affichage des messages
        $boolean_email = false;
        $boolean_phone = false;
        $boolean_username = false;

        $retour_email = array ('email_exist_already' => $boolean_email );
        $retour_phone = array ('phone_exist_already' => $boolean_phone );
        $retour_username = array ('username_exist_already' => $boolean_username );

        //partie pour récupérer l'image du user
        $inputs = json_decode($request->getContent(),TRUE);

        //dd($inputs['picture']);


        //recuperer l'image
        //if(array_key_exists('image',$inputs))
        //{
        //if(!isset($inputs['picture']))
        //{
        //define('UPLOAD_DIR','/home/mooevents/public_html/img/uploads/');

        define('UPLOAD_DIR','img/uploads/');

        $image = $inputs['picture'];
        $data = base64_decode($image);
        $nom = uniqid() . '.png';
        $file = UPLOAD_DIR . $nom;
        //$chemin=url('img/uploads/'.$nom );
        $chemin='img/uploads/'.$nom ;
        if(file_put_contents($file,$data)){
            $inputs['picture']=$chemin;

        }else $inputs['picture']= "NULL";
        //}else $inputs['picture']='';



        $user = \DB::table('users')
            ->where('remember_token','=',$token)
            ->first();

        $role_id = $user->role_id;
        $badge_id = $user->badge_id;

        /*if($username != NULL AND $lastname != NULL AND $firstname != NULL AND $phone != NULL AND $email != NULL AND $password != NULL AND $sexe != NULL
            AND $pays != NULL AND $ville != NULL AND $address != NULL AND $profession != NULL AND $experience != NULL )
        {*/
        $tab['confirmed'] = true;  //pour confirmer le user
        /*
            $user_email = \DB::table('users')
                ->where('email','=',$email)
                ->first();

            $user_phone = \DB::table('users')
                ->where('phone','=',$phone)
                ->first();
        */
        $user_username = \DB::table('users')
            ->where('username','=',$username)
            ->first();
        //dd($user->email);
        /*    if(!empty($user_email)){
                if($user_email->email == $user->email){
                    //return response::json(['email_exist_already' => true]);
                }
                else{
                    $boolean_email = true;
                    $retour_email = array ('email_exist_already' => $boolean_email );
                    //return response::json(['email_exist_already' => true]);
                }
            }

            if(!empty($user_phone)){
                if($user_phone->phone == $user->phone){
                    //return response::json(['phone_exist_already' => true]);
                }
                else{
                    $boolean_phone = true;
                    $retour_phone = array ('phone_exist_already' => $boolean_phone );
                   // return response::json(['phone_exist_already' => true]);
                }
            }
        */
        if(!empty($user_username)){
            if($user_username->username == $user->username){
                //return response::json(['username_exist_already' => true]);
            }
            else{
                $boolean_username = true;
                $retour_username = array ('username_exist_already' => $boolean_username );
                return response()->json([/*$retour_email, $retour_phone,*/ $retour_username], 400);
            }
        }

        //ici on affiche tous les boolean en json
        //if(/*!empty($user_email) || !empty($user_phone) || */!empty($user_username) )
        //{
        //    return response()->json([/*$retour_email, $retour_phone,*/ $retour_username], 400);

        // }

        //insertion des données dans la table users_history: je fais juste une recopie des infos de la table users pour un user donné
        \DB::table('users_history')
            ->insert([
                [
                    'original_id' => $user->id, 'username' => $user->username,'lastname' => $user->lastname,'firstname' => $user->firstname,'phone' => $user->phone,
                    'email' => $user->email, 'password' => $user->password, 'sexe' => $user->sexe, 'pays' => $user->pays, 'ville' => $user->ville,
                    'address' => $user->address, 'picture' => $user->picture, 'profession' => $user->profession, 'experience' => $user->experience,
                    'role_id' => $user->role_id, 'badge_id' => $user->badge_id, 'confirmed' => $user->confirmed, 'statut_update' => 1, 'remember_token' => $user->remember_token,
                    'created_at' => $user->created_at,'updated_at' => $user->updated_at]
            ]);

        if($image == "NULL"){
            $chemin = $user->picture;
        }


        //ici j'update original_id avec l'id du user puis j'update aussi statut_update à 1
        \DB::table('users')
            ->where('id','=',$user->id)
            //->where('original_id','=',0)
            //->where('statut_update','=',0)
            ->update([
                //'original_id' => $user->id,
                'statut_update' => 1,
                'username' => $username,
                'lastname' => $lastname,
                'firstname' => $firstname,
                //'phone' => $phone,
                //'email' => $email,
                //'password' => bcrypt($password),
                'sexe' => $sexe,
                'pays' => $pays,
                'ville' => $ville,
                'address' => $address,
                'picture' => $chemin/*$inputs['picture']*/,
                'profession' => $profession,
                'experience' => $experience,
                //'remember_token' => $token,
                'updated_at' => Carbon::now()
            ]);


        return response()->json([
            'token' => $token,'username' => $username,'lastName' => $lastname, 'firstName' => $firstname/*, 'phone' => $phone,
                'email' => $email, 'password' => bcrypt($password)*/, 'sexe' => $sexe, 'pays' => $pays, 'ville' => $ville,
            'address' => $address, 'picture' => $chemin, 'profession' => $profession/*, 'experience' => $experience*/
        ]);

        //}

        return response::json(['message' => 'error'], 400);

    }



    //permet d'envoyer le code au user pour changer le password
    public function SendCodeToChangePassword(){

        $request = Request::instance();
        $data = json_decode($request->getContent());

        $boolean_email = false;
        $boolean_phone = false;


        //renvoit l'index (email ou phone) en fonction de ce que le user saisit
        $index = filter_var($data->email_or_phone, FILTER_VALIDATE_EMAIL) ? 'email' : 'phone';

        if($index == "email")
        {
            $user = \DB::table('users')
                ->where('email','=',$data->email_or_phone)
                ->first();

            //pour dire si l'email du user existe en BD
            if(!empty($user)){

                $code = str_random(7);

                //je recherche si le user existe déjà dans la table passwordresets
                $recherche = \DB::table('passwordresets')
                    ->where('user_id','=',$user->id)
                    ->first();

                if(!empty($recherche)){  //dans le cas où il existe on update son code et on mets confirmation_code à 0 pour dire qu'il doit confirmer
                    //on fait une copie dans la table passwordresets_history
                    \DB::table('passwordresets_history')
                        ->insert([
                            [
                                'user_id' => $recherche->id,
                                'code' => $recherche->code,
                                'confirmation_code' => $recherche->confirmation_code,
                                'statutvalidite' => $recherche->statutvalidite,
                                'created_at' => $recherche->created_at,
                                'updated_at' => $recherche->updated_at
                            ]
                        ]);

                    //puis on fait maintenant un update
                    \DB::table('passwordresets')
                        ->where('user_id','=',$user->id)
                        ->update([
                            'code' => $code,
                            'confirmation_code' => 0,
                            'statutvalidite' => 'valid',
                            'updated_at' => Carbon::now()
                        ]);
                }
                else{//dans le cas contraire on l'enregistre dans la table
                    \DB::table('passwordresets')
                        ->insert([
                            [
                                'user_id' => $user->id,
                                'code' => $code,
                                'confirmation_code' => 0,
                                'statutvalidite' => 'valid',
                                'created_at' => Carbon::now(),
                                'updated_at' => Carbon::now()
                            ]
                        ]);
                }


                //**************** Partie pour l'envoi du codecle par mail au user /

                //partie pour envoyer le code par mail au user
                //$message = " Cher utilisateur,  \r\n \r\n voici le code à utiliser pour changer votre mot de passe";

                $message = " Dear user, \r\n \r\n here is the code to use to change your password";

                //$message = $message . "\r\n \r\n \r\n Note:Veuillez rafraichir votre page de vote Merci." ;
                //$subject = 'Changer le mot de passe du compte';


                $subject = 'Change password of account';

                //if (filter_var($data->email_or_phone, FILTER_VALIDATE_EMAIL)) {
                $data1 = [
                    'from' => 'katika@api.visavisbet.com'/*'visavis@api.visavisbet.com'*/,
                    'from_name' => 'VisavisBet',
                    'to' => $user->email,
                    'subject' => $subject,
                    'title' => $message,
                    'code' => '  Code : ' . $code,
                    //'email' => '  Email : ' . $value->email,
                    //'password' => $password,
                    // 'download' => '  Download the application with the following link to connect ....' .
                    //   ' Well after you can change your password. Thanks you',
                    'link' => 'Vous pouvez aussi cliquer sur le lien suivant pour changer votre mot de passe',
                    'code' => $code
                ];

//                    Mail::send('tontine.reset_password', $data1, function ($message) use ($data1) {
//                        $message->from($data1['from'], $data1['from_name']);
//                        $message->to($data1['to'])->subject($data1['subject']);
//                    });

                $beautymail = app()->make(Beautymail::class);
                $beautymail->send('katika.reset_password', $data1, function($message) use ($data1)
                {
                    //$email = $test->email_or_phone;
                    $message->from($data1['from'],$data1['from_name']);
                    $message->to($data1['to'])->subject($data1['subject']);
                });


                //}

                //**************************** end mail ***************************************************



                return response()->json(['message' => 'success', 'code' => $code]);


            }
            else{
                $boolean_email = true;
            }


        }


        if($index == "phone")
        {
            $user = \DB::table('users')
                ->where('phone','=',$data->email_or_phone)
                ->first();

            if(!empty($user)){

                $code = str_random(7);

                //je recherche si le user existe déjà dans la table passwordresets
                $recherche = \DB::table('passwordresets')
                    ->where('user_id','=',$user->id)
                    ->first();

                if(!empty($recherche)){  //dans le cas où il existe on update son code et on mets confirmation_code à 0 pour dire qu'il doit confirmer
                    //on fait une copie dans la table passwordresets_history
                    \DB::table('passwordresets_history')
                        ->insert([
                            [
                                'user_id' => $recherche->id,
                                'code' => $recherche->code,
                                'confirmation_code' => $recherche->confirmation_code,
                                'statutvalidite' => $recherche->statutvalidite,
                                'created_at' => $recherche->created_at,
                                'updated_at' => $recherche->updated_at
                            ]
                        ]);

                    \DB::table('passwordresets')
                        ->where('user_id','=',$user->id)
                        ->update([
                            'code' => $code,
                            'confirmation_code' => 0,
                            'statutvalidite' => 'valid',
                            'updated_at' => Carbon::now()
                        ]);
                }
                else{//dans le cas contraire on l'enregistre dans la table
                    \DB::table('passwordresets')
                        ->insert([
                            [
                                'user_id' => $user->id,
                                'code' => $code,
                                'confirmation_code' => 0,
                                'statutvalidite' => 'valid',
                                'created_at' => Carbon::now(),
                                'updated_at' => Carbon::now()
                            ]
                        ]);
                }

                /************************* Partie pour envoyer le code par SMS au user *********************/






                /*******************************************************************************************/

                return response()->json(['message' => 'success', 'code' => $code]);
            }
            else{
                $boolean_phone = true;
            }


        }


        return response()->json(['email_not_exist' => $boolean_email, 'phone_not_exist' => $boolean_phone], 400);


    }

    //permet de confirmer le code entrer par le user
    public function confirmCode(){
        $request = Request::instance();
        $data = json_decode($request->getContent());

        $code = $data->code;

        $code_problem = 2;

        if($code != NULL){
            $resultat = \DB::table('passwordresets')
                ->where('code','=',$code)
                ->where('statutvalidite','=','valid')
                ->first();

            $resultat1 = \DB::table('passwordresets')
                ->where('code','=',$code)
                ->where('statutvalidite','=','invalid')
                ->first();

            if(!empty($resultat1)){
                return response()->json(['message' => 'code_has_expired'], 400);
            }

            if(!empty($resultat)){
                $user = \DB::table('users')
                    ->where('id','=',$resultat->user_id)
                    ->first();
            }
            else{$user=array();}

            if(!empty($resultat)){
                \DB::table('passwordresets')
                    ->where('code','=',$code)
                    ->update([
                        'confirmation_code' => 1,
                        'updated_at' => Carbon::now()
                    ]);

                return response()->json(['message' => 'success', 'code' => $code, 'user' => $user]);
            }
            else{
                return response()->json(['message' => 'code_not_exist'], 400);
            }

        }

        return response()->json(['message' => 'error'], 400);

    }


    //permet de modifier le password du user
    public function changePassword(){
        $request = Request::instance();
        $data = json_decode($request->getContent());

        $password = $data->password;
        $user_id = $data->user_id;

        if($password != NULL){
            //je teste si le user a déjà confirmé son code
            $resultat = \DB::table('passwordresets')
                ->where('user_id','=',$user_id)
                ->where('confirmation_code','=',1)
                ->first();

            if(!empty($resultat)){ //pour dire que oui il a déjà confirmé
                \DB::table('users')
                    ->where('id','=',$user_id)
                    ->update([
                        'password' => bcrypt($password),
                        //'updated_at' => Carbon::now()
                    ]);

                return response()->json(['message' => 'success']);
            }

            return response()->json(['message' => 'user_not_confirm_code'], 400); //pour dire que le user n'a pas encore confirmé son code
        }

        return response()->json(['message' => 'error'], 400); //pour dire que le user n'a pas encore confirmé son code
    }




    //permet de modifier le password du user
    public function changePasswordWeb(Request $request){
        $request = Request::instance();
        // $data = json_decode($request->getContent());

        $password = $request->input('password');
        $user_id = $request->input('user_id');

        //var_dump($user_id);

        if($password != NULL){
            //je teste si le user a déjà confirmé son code
            $resultat = \DB::table('passwordresets')
                ->where('user_id','=',$user_id)
                ->where('confirmation_code','=',1)
                ->first();

            if(!empty($resultat)){ //pour dire que oui il a déjà confirmé
                \DB::table('users')
                    ->where('id','=',$user_id)
                    ->update([
                        'password' => bcrypt($password),
                        //'updated_at' => Carbon::now()
                    ]);

                $message = "Cher utilisateur,  \r\n \r\n votre mot de passe a été bien réinitialisé. Merci";

                echo '<div class = "alert alert-success alert-dismissable" style="position: absolute;top: 150px;
                                right: 10px;z-index: 1000;width: 300px;height: 150px;">
                               <button type = "button" class = "close" data-dismiss = "alert" aria-hidden = "true">&times; </button>
                                  <h4>Success</h4><hr>
                                <b>'.$message.'.</b>
                            </div>';

                //return response()->json(['message' => 'success']);
                return view('auth.login');
            }

            // return response()->json(['message' => 'user_not_confirm_code'], 400); //pour dire que le user n'a pas encore confirmé son code
        }

        $message = "Cher utilisateur,  \r\n \r\n veuillez entrer votre mot de passe. Merci";

        echo '<div class = "alert alert-danger alert-dismissable" style="position: absolute;top: 150px;
                                right: 10px;z-index: 1000;width: 300px;height: 150px;">
                               <button type = "button" class = "close" data-dismiss = "alert" aria-hidden = "true">&times; </button>
                                  <h4>Error</h4><hr>
                                <b>'.$message.'.</b>
                            </div>';

        return view('tontine.changePassword')->with(['user_id' => $user_id]);

        // return response()->json(['message' => 'error'], 400); //pour dire que le user n'a pas encore confirmé son code
    }


    // permet de créer le compte d'un user temporaire

    public function createCompteUserTemporaire()

    {
        $request = Request::instance();
        $content = $request->getContent();
        $tab=json_decode($content,TRUE);

        /*$user = DB::table('users')->select('*')
                ->where('email','=',$tab['email'])->first();*/
        $user_id = $tab['user_id'];
        $email = $tab['email'];
        $phone = $tab['phone'];
        $username = $tab['username'];
        $password = $tab['password'];
        $lastname = $tab['lastName'];
        $firstname = $tab['firstName'];
        $sexe = $tab['sexe'];

        $role_id = 3 ;  //par défaut role = utilisateur
        $badge_id = 1 ; //par défaut

        //ça nous permettre de gérer l'affichage des messages
        $boolean_email = false;
        $boolean_phone = false;
        $boolean_username = false;

        $retour_email = array ('email_exist_already' => $boolean_email );
        $retour_phone = array ('phone_exist_already' => $boolean_phone );
        $retour_username = array ('username_exist_already' => $boolean_username );

        $user = \DB::table('users')
            ->where('id','=',$user_id)
            ->first();

        $user_email = \DB::table('users')
            ->where('email','=',$email)
            ->first();

        $user_phone = \DB::table('users')
            ->where('phone','=',$phone)
            ->first();

        $user_username = \DB::table('users')
            ->where('username','=',$username)
            ->first();

        if(!empty($user_email))                        //ici on contrôle si l'email du user existe déjà dans la BD
        {
            if($user_email->email != $user->email){ //alors ce n'est pas l'email du même user
                $boolean_email = true;
                $retour_email = array ('email_exist_already' => $boolean_email );
            }
        }

        if(!empty($user_phone))                        //ici on contrôle si le phone du user existe déjà dans la BD
        {
            if($user_phone->phone != $user->phone){
                $boolean_phone = true;
                $retour_phone = array ('phone_exist_already' => $boolean_phone );
            }
        }

        if(!empty($user_username))                        //ici on contrôle si le username existe déjà dans la BD
        {
            if($user_username->username != $user->username){
                $boolean_username = true;
                $retour_username = array ('username_exist_already' => $boolean_username );
            }
        }

        //ici on affiche tous les boolean en json
        if((!empty($user_email) AND ($user_email->email != $user->email)) || (!empty($user_phone) AND ($user_phone->phone != $user->phone)) || (!empty($user_username) AND ($user_username->username != $user->username)) )
        {
            return response()->json([$retour_email, $retour_phone, $retour_username], 400);

        }

        if($email != NULL){
            $credentials['email'] = $email;
        }

        if($phone != NULL){
            $credentials['phone'] = $phone;
        }

        $credentials['password'] = $password;

        $tab['confirmed']= true;

        //$user = $user_gestion->store( $tab, $confirmation_code = null);


        \DB::table('users')
            ->where('id','=',$user->id)
            //->where('original_id','=',0)
            //->where('statut_update','=',0)
            ->update([
                //'original_id' => $user->id,
                'statut_update' => 1,
                'username' => $username,
                'lastname' => $lastname,
                'firstname' => $firstname,
                'phone' => $phone,
                'email' => $email,
                'password' => bcrypt($password),
                'sexe' => $sexe,
                'role_id' => $role_id,
                'badge_id' => $badge_id,
                'confirmed' => $tab['confirmed'],
                //'pays' => $pays,
                //'ville' => $ville,
                // 'address' => $address,
                //'picture' => $inputs['picture'],
                //'profession' => $profession,
                //'experience' => $experience,
                //'remember_token' => $token,
                'temporaire' => 0,
                'created_at' => Carbon::now(),
                'updated_at' => Carbon::now()
            ]);


        /*
                //insertion des données dans la table users
                \DB::table('users')
                    ->insert([
                        ['original_id' => 0, 'username' => $username,'lastname' => $lastname,'firstname' => $firstname,'phone' => $phone, 'email' => $email, 'password' => bcrypt($password), 'sexe' => $sexe, 'role_id' => $role_id, 'badge_id' => $badge_id, 'confirmed' => $tab['confirmed'],'temporaire' => 0 , 'created_at' => Carbon::now(),'updated_at' => Carbon::now()]
                    ]);*/

        $user = \DB::table('users')
            ->where('phone','=',$phone)
            ->first();

        $role=\DB::table('roles')
            ->where('id', $user->role_id)
            ->first();

        try {
            $token = JWTAuth::attempt($credentials);
        } catch (\Exception $e)
        {
            $retour = array ('message' => 'invalid_credentials' );
            return response::json($retour);
        }

        //ici on stocke le token avec lequel il sera connecté
        \DB::table('users')
            ->where('phone','=',$phone)
            ->update([
                'remember_token' => $token
            ]);

        $badge = \DB::table('typebadges')
            ->where('id','=',$badge_id)
            ->first();

        $retour = array ('message' => 'success', 'token' => $token, 'role' => $role->slug, 'user' => $user, 'badge_name' => $badge->name );

        return response::json($retour);

    }


    public function testMoMo()

    {

        if (isset($_SERVER['HTTP_ORIGIN']))
        {
            header("Access-Control-Allow-Origin: {$_SERVER['HTTP_ORIGIN']}");
            header('Access-Control-Allow-Credentials: true');
            header('Access-Control-Max-Age: 86400');    // cache for 1 day
        }

        // Access-Control headers are received during OPTIONS requests

        if ($_SERVER['REQUEST_METHOD'] == 'OPTIONS')
        {
            if (isset($_SERVER['HTTP_ACCESS_CONTROL_REQUEST_METHOD']))
                header("Access-Control-Allow-Methods: GET, POST, OPTIONS");

            if (isset($_SERVER['HTTP_ACCESS_CONTROL_REQUEST_HEADERS']))
                header("Access-Control-Allow-Headers:{$_SERVER['HTTP_ACCESS_CONTROL_REQUEST_HEADERS']}");

            exit(0);
        }

        $request = Request::instance();
        $content = $request->getContent();
        $tab=json_decode($content,TRUE);

        $client = new Client([
            'http_errors' => false// false = http errors won't throw Exceptions
        ]);//"237650638139"

        $res = $client->request('POST', 'http://mobilemoney.sdkgames.com/mooeventRequestPayment', [
            'form_params' => [
                'refID' => str_random(5),
                'msidn' => "237677468973"  ,
                'amount' =>   "10" ,
                'moneyCode' =>   "XAF"
            ]
        ]);

        //dd($res->getBody());
        // echo $res->getStatusCode();
        // "200"
        // dd ($res->getHeader('content-type'));
        // 'application/json; charset=utf8'
        //echo $res->getBody() ;
        // {"type":"User"...'
        if( $res->getStatusCode() != "200")
            return response::json(["reponse"=>"failure"]);

        $resultat = json_decode($res->getBody(),TRUE);
        //dd($resultat);
        if(isset($resultat["soapenv:Fault"]))
            return response::json(["reponse"=> $resultat["soapenv:Fault"]["faultstring"]]);

        //return response::json(["reponse"=> $resultat["ThirdPartyAcctRef"]]);
        return response::json(["reponse"=> "success"]);

    }

    public function MTNMobileMoney($token){
        $request = Request::instance();
        $data = json_decode($request->getContent());

        //$user_id = $data->user_id;
        $cout = $data->montant;
        $confirm = 0;
        $numero = $data->numero;        //précédé de 237
        //$phone_number = '237'.$numero;
        //$type = "MTNMobileMoney";

        $transaction_id = str_random(5);

        $user = \DB::table('users')
            ->where('remember_token','=',$token)
            ->first();

        if(empty($user)){
            return response::json(["message"=> "error", "user_not_found" => true]);
        }

        $user_id = $user->id;

        DB::table('achat')->insert(
            [   'user_id' => $user_id,
                'transaction_id' => $transaction_id,
                'processingNumber' => 0,
                'operateur' => 'mtn',
                'cout' => $cout,
                //'type' => $type,
                'confirm' => $confirm,
                'created_at' => Carbon::now(),
                'updated_at' => Carbon::now(),
                'phone_number' => $numero
            ]
        );

        $ch = curl_init('http://mobilemoney.sdkgames.com/mooeventRequestPayment');
        $encoded = urlencode("refID") ."=".urldecode($transaction_id);
        $encoded .= "&".urlencode("msidn") ."=".urldecode($numero);
        $encoded .= "&".urlencode("amount") ."=".urldecode((int)($cout));
        $encoded .= "&".urlencode("moneyCode") ."=".urldecode('XAF');
        $encoded .= "&".urlencode("product") ."=".urldecode('MissCam2017');
        //dd($encoded);
        curl_setopt($ch, CURLOPT_POSTFIELDS,  $encoded);
        curl_setopt($ch, CURLOPT_HEADER, 0);
        curl_setopt($ch, CURLOPT_POST, 1);
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
        $resultat = curl_exec($ch);
        //$info = curl_getinfo($ch);
        curl_close($ch);


        if(!isset($resultat["soapenv:Fault"])) {

            //    var_dump($resultat);

            //   $resultat ="'".$resultat."'";

            //var_dump($resultat);


            $re1='.*?'; # Non-greedy match on filler
            $re2='\\d+';    # Uninteresting: int
            $re3='.*?'; # Non-greedy match on filler
            $re4='(\\d+)';  # Integer Number 1
            $re5='.*?'; # Non-greedy match on filler
            $re6='(\\d+)';  # Integer Number 2
            $re7='.*?'; # Non-greedy match on filler
            $re8='(?:[a-z][a-z]+)'; # Uninteresting: word
            $re9='.*?'; # Non-greedy match on filler
            $re10='((?:[a-z][a-z]+))';  # Word 1

            preg_match_all ("/".$re1.$re2.$re3.$re4.$re5.$re6.$re7.$re8.$re9.$re10."/is", $resultat, $matches);

            $ProcessingNumber=(int)$matches[1][0]/* - 10400*/;
            //$ProcessingNumber=(int)$matches[1][0];
            $statusCode=$matches[2][0];

            if (/*$resultat->statusCode*/ $statusCode == "01") //si c'est différent de "01" alors Errors Will differenciate reasons ( Insuffisant credit, bad number, ...)
            {
                //    var_dump($resultat);


                //      $resultat ="'".$resultat."'";

                // var_dump($resultat);

                $re1='.*?'; # Non-greedy match on filler
                $re2='\\d+';    # Uninteresting: int
                $re3='.*?'; # Non-greedy match on filler
                $re4='(\\d+)';  # Integer Number 1
                $re5='.*?'; # Non-greedy match on filler
                $re6='(\\d+)';  # Integer Number 2
                $re7='.*?'; # Non-greedy match on filler
                $re8='(?:[a-z][a-z]+)'; # Uninteresting: word
                $re9='.*?'; # Non-greedy match on filler
                $re10='((?:[a-z][a-z]+))';  # Word 1

                preg_match_all ("/".$re1.$re2.$re3.$re4.$re5.$re6.$re7.$re8.$re9.$re10."/is", $resultat, $matches);

                $ProcessingNumber=(int)$matches[1][0]/* - 10400*/;
                //$ProcessingNumber=(int)$matches[1][0];
                $statusCode=$matches[2][0];
                //$word1= $matches[3][0];

                //print " $int1 $int2 $word1 \n";

                //  print_r($matches);


                // var_dump($statusCode);

                $updated_at = Carbon::now();
                \DB::table('achat')
                    //->where('user_id', /*$resultat->ProcessingNumber*/ $ProcessingNumber)
                    ->where('transaction_id','=',$transaction_id)
                    ->update([
                        'confirm' => 1,
                        'processingNumber' => $ProcessingNumber,
                        'updated_at' =>$updated_at
                    ]);

                return response::json(["message"=> "success"]);

            }

            else{

                $updated_at = Carbon::now();
                \DB::table('achat')
                    ->where('transaction_id','=',$transaction_id)
                    ->update([
                        'confirm' => 2,
                        'processingNumber' => $ProcessingNumber,
                        'updated_at' => $updated_at
                    ]);

                return response::json(["message"=> "failure"]);

            }

        }
        else{

            return Response::json(["reponse"=> $resultat["soapenv:Fault"]["faultstring"]]);

        }

    }







    /*************************************** START Fonctions réutilisables *************************************************/

    //fonction pour créditer le portemonnaie
    public function creditePortemonnaie($user_id, $valeur_coin){
        $date_courante = Carbon::now();

        $date = new DateTime($date_courante);
        $now = clone $date;
        $now->modify('+2 hour');
        //$dateValable contient la date courante +1h heure de l'afrique du sud

        $new_date = $now->format('Y-m-d H:i:s');


        //insertion dans la table portemonnaie
        $recherche = \DB::table('portemonnaie')
            ->where('user_id','=',$user_id)
            ->first();

        if(empty($recherche)){
            \DB::table('portemonnaie')
                ->insert([
                    [
                        'user_id' => $user_id,
                        'solde_coin' => $valeur_coin,
                        'created_at' => $new_date/*Carbon::now()*/,
                        'updated_at' => $new_date/*Carbon::now()*/
                    ]
                ]);
        }
        else{
//            $solde = \DB::table('portemonnaie')
//                ->where('user_id','=',$user_id)
//                ->first();

            \DB::table('portemonnaie')
                ->where('user_id','=',$user_id)
                ->update([
                    'solde_coin' => $recherche->solde_coin + $valeur_coin,
                    'updated_at' => $new_date/*Carbon::now()*/
                ]);
        }

        //return response()->json(['message' => 'success']);
    }


    //fonction pour débiter le portemonnaie
    public function debitePortemonnaie($user_id,$valeur_coin){
        $date_courante = Carbon::now();

        $date = new DateTime($date_courante);
        $now = clone $date;
        $now->modify('+2 hour');
        //$dateValable contient la date courante +1h heure de l'afrique du sud

        $new_date = $now->format('Y-m-d H:i:s');


        $recherche = \DB::table('portemonnaie')
            ->where('user_id','=',$user_id)
            ->first();

        if(!empty($recherche)){
            $somme = $recherche->solde_coin - $valeur_coin;
            /*if($somme < 0){
                return response()->json(['message' => 'error']);
            }*/

            \DB::table('portemonnaie')
                ->where('user_id','=',$user_id)
                ->update([
                    'solde_coin' => $somme,
                    'updated_at' => $new_date/*Carbon::now()*/
                ]);
        }

        // return response()->json(['message' => 'success']);
    }


    //fonction pour remplir transaction_portemonnaie
    public function remplirTransactionPortemonnaie($user_id,$valeur_coin,$mise_id,$statut,$motif){
        $date_courante = Carbon::now();

        $date = new DateTime($date_courante);
        $now = clone $date;
        $now->modify('+2 hour');
        //$dateValable contient la date courante +1h heure de l'afrique du sud

        $new_date = $now->format('Y-m-d H:i:s');


        //mettre à jour la table transaction_portemonnaie
        $reference_transaction = str_random(6);

        \DB::table('transaction_portemonnaie')
            ->insert([
                [
                    'user_id' => $user_id,
                    'valeur_coin' => $valeur_coin,
                    'reference_transaction' => $reference_transaction,
                    'mise_id' => $mise_id,
                    'statut' => $statut,        //statut = entrant ou sortant
                    'motif' => $motif,          //motif = coins chargés ou coins gagnés ou coins reçues après annulation mise ou coins pariés ou coins retirés pour le cash ou coins en attente de validation par le système pour le cash
                    'created_at' => $new_date/*Carbon::now()*/,
                    'updated_at' => $new_date/*Carbon::now()*/
                ]
            ]);

    }


    //fonction pour remplir transaction_caise
    public function remplirTransactionCaisse($valeur_coin,$type,$statut){
        $date_courante = Carbon::now();

        $date = new DateTime($date_courante);
        $now = clone $date;
        $now->modify('+2 hour');
        //$dateValable contient la date courante +1h heure de l'afrique du sud

        $new_date = $now->format('Y-m-d H:i:s');


        \DB::table('transaction_caisse')
            ->insert([
                [
                    'valeur_coin' => $valeur_coin,
                    'type' => $type,       //type = portemonnaie ou mise ou benefice (argent reçu par le katika)
                    'statut' => $statut,    //statut = entrant ou sortant
                    'created_at' => $new_date/*Carbon::now()*/,
                    'updated_at' => $new_date/*Carbon::now()*/
                ]
            ]);
    }


    //permet d'envoyer les notifications aux device_id des users renseignés
    public function sendMessage($app_id,$rest_api,$device_id,$message,$type,$data){    //$device_id est un array, $app_id est un string et $rest_api est un string, $type=("mise" ou "transaction_paypal") et $data est une variable pour les Metadata
        $authorization = 'Authorization: Basic '.$rest_api;

        $content = array(
            "en" => /*'English Message'*/$message
        );

        $fields = array(
            'app_id' => /*"5eb5a37e-b458-11e3-ac11-000c2940e62c"*/ $app_id,
            'include_player_ids' => /*array("6392d91a-b206-4b7b-a620-cd68e32c3a76","76ece62b-bcfe-468c-8a78-839aeaa8c5fa","8e0f21fa-9a5a-4ae7-a9a6-ca1f24294b86")*/ $device_id,
            'data' => array("type" => $type,"id" => $data),   //partie Metadata pouvant être récuperée par le mobile
            'contents' => $content,
            'android_sound' => "notification"       //pour le son de notification
        );

        $fields = json_encode($fields);
        print("\nJSON sent:\n");
        print($fields);

        $ch = curl_init();
        curl_setopt($ch, CURLOPT_URL, "https://onesignal.com/api/v1/notifications");
        curl_setopt($ch, CURLOPT_HTTPHEADER, array('Content-Type: application/json; charset=utf-8',
            /*'Authorization: Basic NGEwMGZmMjItY2NkNy0xMWUzLTk5ZDUtMDAwYzI5NDBlNjJj'*/
            $authorization));
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, TRUE);
        curl_setopt($ch, CURLOPT_HEADER, FALSE);
        curl_setopt($ch, CURLOPT_POST, TRUE);
        curl_setopt($ch, CURLOPT_POSTFIELDS, $fields);
        curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, FALSE);

        $response = curl_exec($ch);
        curl_close($ch);

        $return["allresponses"] = $response;
        $return = json_encode( $return);

        print("\n\nJSON received:\n");
        print($return);
        print("\n");

        return $response;
    }


    //permet de voir les détails d'une notification
    public function viewNotification($notification_id,$app_id,$rest_api){
        $Authorization = 'Authorization: Basic '.$rest_api;

        $ch = curl_init();
        curl_setopt($ch, CURLOPT_URL, "https://onesignal.com/api/v1/notifications/".$notification_id."?app_id=".$app_id);
        curl_setopt($ch, CURLOPT_HTTPHEADER, array('Content-Type: application/json',
            /*'Authorization: Basic AUTH_KEY'*/$Authorization));
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, TRUE);
        curl_setopt($ch, CURLOPT_HEADER, FALSE);
        curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, FALSE);

        $response = curl_exec($ch);
        curl_close($ch);
        $return["allresponses"] = $response;
        $return = json_encode( $return);

        print("\n\nJSON received:\n");
        print($return);
        print("\n");

        return $response;


    }


    //permet d'envoyer les notifications à un user à un temps donné
    public function sendMessagewithDelivery($app_id,$rest_api,$device_id,$time,$message){    //$device_id est un array, $app_id est un string, $rest_api est un string et $time est le temps pour notifier
        $authorization = 'Authorization: Basic '.$rest_api;

        $content = array(
            "en" => /*'English Message'*/$message
        );

        $fields = array(
            'app_id' => /*"5eb5a37e-b458-11e3-ac11-000c2940e62c"*/ $app_id,
            'include_player_ids' => /*array("6392d91a-b206-4b7b-a620-cd68e32c3a76","76ece62b-bcfe-468c-8a78-839aeaa8c5fa","8e0f21fa-9a5a-4ae7-a9a6-ca1f24294b86")*/ $device_id,
            'data' => array("foo" => "bar"),
            'contents' => $content,
            'android_sound' => "notification",       //pour le son de notification
            'delayed_option' => "timezone",
            'delivery_time_of_day' => $time       //time = "12:25PM"  temps auquel la notification va être envoyée
        );

        $fields = json_encode($fields);
        print("\nJSON sent:\n");
        print($fields);

        $ch = curl_init();
        curl_setopt($ch, CURLOPT_URL, "https://onesignal.com/api/v1/notifications");
        curl_setopt($ch, CURLOPT_HTTPHEADER, array('Content-Type: application/json; charset=utf-8',
            /*'Authorization: Basic NGEwMGZmMjItY2NkNy0xMWUzLTk5ZDUtMDAwYzI5NDBlNjJj'*/
            $authorization));
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, TRUE);
        curl_setopt($ch, CURLOPT_HEADER, FALSE);
        curl_setopt($ch, CURLOPT_POST, TRUE);
        curl_setopt($ch, CURLOPT_POSTFIELDS, $fields);
        curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, FALSE);

        $response = curl_exec($ch);
        curl_close($ch);

        return $response;
    }



    public function addDeviceId($app_id,$identifier){
        $fields = array(
            'app_id' => $app_id,
            'identifier' => $identifier/*"ce777617da7f548fe7a9ab6febb56cf39fba6d382000c0395666288d961ee566"*//*APA91bHbYHk7aq-Uam_2pyJ2qbZvqllyyh2wjfPRaw5gLEX2SUlQBRvOc6sck1sa7H7nGeLNlDco8lXj83HWWwzV*/,
            'language' => "en",
            'timezone' => "-28800",
            'game_version' => "1.0",
            'device_os' => "9.1.3",
            'device_type' => "1",
            'device_model' => "android",
            'tags' => array("foo" => "bar")
        );

        $fields = json_encode($fields);
        print("\nJSON sent:\n");
        print($fields);

        $ch = curl_init();
        curl_setopt($ch, CURLOPT_URL, "https://onesignal.com/api/v1/players");
        curl_setopt($ch, CURLOPT_HTTPHEADER, array('Content-Type: application/json'));
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, TRUE);
        curl_setopt($ch, CURLOPT_HEADER, FALSE);
        curl_setopt($ch, CURLOPT_POST, TRUE);
        curl_setopt($ch, CURLOPT_POSTFIELDS, $fields);
        curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, FALSE);

        $response = curl_exec($ch);
        curl_close($ch);

        $return["allresponses"] = $response;
        $return = json_encode( $return);

        print("\n\nJSON received:\n");
        print($return);
        print("\n");
    }


    //permet de remplir la table notifications
    public function SaveNotification($titre,$description,$user_id,$mise_id,$paypal_id,$type,$coin_id,$nbre_piece){  //type = mise ou transaction_paypal ou ajout_nbre_piece_coin ou achat
        \DB::table('notifications')
            ->insert([
                [
                    'titre' => $titre,
                    'description' => $description,
                    'lu' => 0,      //pour dire pas encore lu
                    'user_id' => $user_id,
                    'type' => $type,
                    'mise_id' => $mise_id,
                    'paypal_id' => $paypal_id,
                    'coin_id' => $coin_id,
                    'nbre_piece' => $nbre_piece,
                    'created_at' => Carbon::now(),
                    'updated_at' => Carbon::now()
                ]
            ]);
    }



    /*************************************** START function pour transférer l'argent d'un compte paypal vers un autre ************************/

    public function transfertMoneyToPaypalAccountToAnotherPaypalAccount($email_sandbox_sender,$password_sender,$signature_sender,$email_sandbox_receiver,
                                                                        $amount){

        //$email_sandbox_receiver = '';     //email sandbox du user receiver que je dois renseigner
        //$amount = '1.00';         //le montant en USD que le user veut retirer
        //$email_sandox_sender = 'bricedonaldkamte-facilitator_api1.gmail.com';         //email sandbox du user qui envoit l'argent que je dois renseigner
        //$password_sender = '2STTQ853L7SBCBXW';                //password du compte du user qui envoit l'argent
        //$signature_sender = 'AFSj6TtDWU3HQ95PDRWuDHKXw6UNA2XUv21lGIKVLRHAmmMHqYz9t1sU';               //signature du compte du user qui envoit l'argent

        $url = 'https://svcs.sandbox.paypal.com/AdaptivePayments/Pay';

        //$url = 'https://svcs.paypal.com/AdaptivePayments/Pay';

//        $url = https://svcs.paypal.com/AdaptivePayments/<API-Operation>           live paiement
//        $url = https://svcs.sandbox.paypal.com/AdaptivePayments/<API-Operation>    sandbox paiement

        $headers = array
        (
            'X-PAYPAL-SECURITY-USERID: '.$email_sandbox_sender,
            'X-PAYPAL-SECURITY-PASSWORD: '.$password_sender,
            'X-PAYPAL-SECURITY-SIGNATURE: '.$signature_sender,
            'X-PAYPAL-REQUEST-DATA-FORMAT: JSON',
            'X-PAYPAL-RESPONSE-DATA-FORMAT: JSON',
            //'X-PAYPAL-APPLICATION-ID: AdZKTq2vUFLg_8us9cVQBjDaj94KNCRBBCd9miyRTt1Z-EqxYYl33b6M5b8ipPmgqYo0fi4NtDmJHrrd'
            'X-PAYPAL-APPLICATION-ID: APP-80W284485P519543T'
        );

        $receivers = array("amount" => $amount,"email" => $email_sandbox_receiver);

        $fields['actionType']= "CREATE";
        $fields['currencyCode']= "USD";
        $fields['receiverList']['receiver']= $receivers;
        $fields['returnUrl']= "https://api.visavisbet.com/mookatikaGood/";//"https://example.com/success.html";
        $fields['cancelUrl']= "https://api.visavisbet.com/mookatikaGood/";//"https://example.com/failure.html";
        $fields['requestEnvelope']['errorLanguage']= "en_US";

//        $fields = '{ "actionType": "PAY","currencyCode": "USD","receiverList": {"receiver": [{"amount":'.$amount.',"email":'.$email_sandbox_receiver.'}]},'
//        .'"returnUrl": "https://example.com/success.html","cancelUrl": "https://example.com/failure.html","requestEnvelope": {"errorLanguage": "en_US",'
//        .'"detailLevel": "ReturnAll"}}';

        $ch = curl_init();
        curl_setopt( $ch,CURLOPT_URL, $url );
        curl_setopt( $ch,CURLOPT_POST, true );
        curl_setopt( $ch,CURLOPT_HTTPHEADER, $headers );
        curl_setopt( $ch,CURLOPT_RETURNTRANSFER, true );
        curl_setopt( $ch,CURLOPT_SSL_VERIFYPEER, false );
        curl_setopt( $ch,CURLOPT_POSTFIELDS, json_encode( $fields ) );
        $result = curl_exec($ch );
        curl_close( $ch );

        //echo $result;
        return $result;
    }

    /*************************************** END function pour transférer l'argent d'un compte paypal vers un autre ************************/


    //fonction qui permet d'avoir le détail de paiement d'une transaction paypal avec payKey
    public function getPaymentDetailPaypal($email_sandbox_sender,$password_sender,$signature_sender,$PAYKEY){

//                PAYMENTDETAILS=$(wget --output-document=- \
//                --quiet \
//                --header="X-PAYPAL-SERVICE-VERSION: 1.0.0" \
//                --header="X-PAYPAL-SECURITY-USERID: $APIUSER" \
//                --header="X-PAYPAL-SECURITY-PASSWORD: $APIPASS" \
//                --header="X-PAYPAL-SECURITY-SIGNATURE: $APISIG" \
//                --header="X-PAYPAL-REQUEST-DATA-FORMAT: NV" \
//                --header="X-PAYPAL-RESPONSE-DATA-FORMAT: NV" \
//                --header="X-PAYPAL-APPLICATION-ID:  $APPLICATIONID" \
//                --post-data="payKey=$PAYKEY&requestEnvelope.errorLanguage=en_US" \
//                https://www.paypal.com/AdaptivePayments/PaymentDetails)
//        if echo $PAYMENTDETAILS | grep -q "\&status=COMPLETED"
//        then  echo "Thank you for approving pay key $PAYKEY"
//        else  echo "Sorry, you were unable to approve pay key $PAYKEY.  Please try another transaction!"
//        fi

        //$url = 'https://www.paypal.com/AdaptivePayments/PaymentDetails';

        //$url = 'https://svcs.sandbox.paypal.com/AdaptivePayments/PaymentDetails';

        $url = 'https://svcs.paypal.com/AdaptivePayments/PaymentDetails';

//        $url = https://svcs.paypal.com/AdaptivePayments/<API-Operation>           live paiement
//        $url = https://svcs.sandbox.paypal.com/AdaptivePayments/<API-Operation>    sandbox paiement

        $headers = array
        (
            'X-PAYPAL-SERVICE-VERSION: 1.0.0',
            'X-PAYPAL-SECURITY-USERID: '.$email_sandbox_sender,
            'X-PAYPAL-SECURITY-PASSWORD: '.$password_sender,
            'X-PAYPAL-SECURITY-SIGNATURE: '.$signature_sender,
            'X-PAYPAL-REQUEST-DATA-FORMAT: NV',
            'X-PAYPAL-RESPONSE-DATA-FORMAT: JSON',
            'X-PAYPAL-APPLICATION-ID: APP-80W284485P519543T'
        );

        $fields = 'payKey='.$PAYKEY.'&requestEnvelope.errorLanguage=en_US';

        $ch = curl_init();
        curl_setopt( $ch,CURLOPT_URL, $url );
        curl_setopt($ch, CURLOPT_VERBOSE, true);
        curl_setopt( $ch,CURLOPT_POST, true );
        curl_setopt( $ch,CURLOPT_HTTPHEADER, $headers );
        curl_setopt( $ch,CURLOPT_RETURNTRANSFER, true );
        curl_setopt( $ch,CURLOPT_SSL_VERIFYPEER, false );
        curl_setopt( $ch, CURLOPT_SSL_VERIFYHOST, false);
        curl_setopt( $ch,CURLOPT_POSTFIELDS, /*json_encode(*/ $fields /*)*/ );
        $result = curl_exec($ch );
        curl_close( $ch );

        //echo $result;
        return $result;

    }





    //fonction qui permet d'exécuter une transaction paypal avec payKey qui a été initiée par le client
    public function executePaymentPaypal($email_sandbox_sender,$password_sender,$signature_sender,$PAYKEY,$actionType,$token){

//                PAYMENTDETAILS=$(wget --output-document=- \
//                --quiet \
//                --header="X-PAYPAL-SERVICE-VERSION: 1.0.0" \
//                --header="X-PAYPAL-SECURITY-USERID: $APIUSER" \
//                --header="X-PAYPAL-SECURITY-PASSWORD: $APIPASS" \
//                --header="X-PAYPAL-SECURITY-SIGNATURE: $APISIG" \
//                --header="X-PAYPAL-REQUEST-DATA-FORMAT: NV" \
//                --header="X-PAYPAL-RESPONSE-DATA-FORMAT: NV" \
//                --header="X-PAYPAL-APPLICATION-ID:  $APPLICATIONID" \
//                --post-data="payKey=$PAYKEY&requestEnvelope.errorLanguage=en_US" \
//                https://www.paypal.com/AdaptivePayments/PaymentDetails)
//        if echo $PAYMENTDETAILS | grep -q "\&status=COMPLETED"
//        then  echo "Thank you for approving pay key $PAYKEY"
//        else  echo "Sorry, you were unable to approve pay key $PAYKEY.  Please try another transaction!"
//        fi

        //$url = 'https://www.paypal.com/AdaptivePayments/PaymentDetails';


        //$url = 'https://svcs.sandbox.paypal.com/AdaptivePayments/ExecutePayment';

        $url = 'https://svcs.paypal.com/AdaptivePayments/ExecutePayment';

//        $url = https://svcs.paypal.com/AdaptivePayments/<API-Operation>           live paiement
//        $url = https://svcs.sandbox.paypal.com/AdaptivePayments/<API-Operation>    sandbox paiement

        $headers = array
        (
            'X-PAYPAL-SERVICE-VERSION: 1.0.0',
            'X-PAYPAL-SECURITY-USERID: '.$email_sandbox_sender,
            'X-PAYPAL-SECURITY-PASSWORD: '.$password_sender,
            'X-PAYPAL-SECURITY-SIGNATURE: '.$signature_sender,
            'X-PAYPAL-REQUEST-DATA-FORMAT: NV',
            'X-PAYPAL-RESPONSE-DATA-FORMAT: JSON',
            'X-PAYPAL-APPLICATION-ID: APP-80W284485P519543T',
            'Authorization: Bearer ' . $token,
            'Accept: application/json',
            'Content-Type: application/json'
        );

        $fields = 'payKey='.$PAYKEY./*'&actionType='.$actionType.*/'&requestEnvelope.errorLanguage=en_US';

        $ch = curl_init();
        curl_setopt( $ch,CURLOPT_URL, $url );
        curl_setopt($ch, CURLOPT_VERBOSE, true);
        curl_setopt( $ch,CURLOPT_POST, true );
        curl_setopt( $ch,CURLOPT_HTTPHEADER, $headers );
        curl_setopt( $ch,CURLOPT_RETURNTRANSFER, true );
        curl_setopt( $ch,CURLOPT_SSL_VERIFYPEER, false );
        curl_setopt( $ch, CURLOPT_SSL_VERIFYHOST, false);
        curl_setopt( $ch,CURLOPT_POSTFIELDS, /*json_encode(*/ $fields /*)*/ );
        $result = curl_exec($ch );
        curl_close( $ch );

        //echo $result;
        return $result;

    }





    //fonction pour créditer le portemonnaie_detail
    public function creditePortemonnaieDetail($user_id, $coin_id,$nbre,$statut){
        $date_courante = Carbon::now();

        $date = new DateTime($date_courante);
        $now = clone $date;
        $now->modify('+2 hour');
        //$dateValable contient la date courante +1h heure de l'afrique du sud

        $new_date = $now->format('Y-m-d H:i:s');


        //insertion dans la table portemonnaie_detail
        $recherche = \DB::table('portemonnaie_detail')
            ->where('user_id','=',$user_id)
            ->where('coin_id','=',$coin_id)
            ->where('statut','=',$statut)
            ->first();

        if(empty($recherche)){
            \DB::table('portemonnaie_detail')
                ->insert([
                    [
                        'user_id' => $user_id,
                        'coin_id' => $coin_id,
                        'nbre' => $nbre,
                        'statut' => $statut,
                        'created_at' => $new_date/*Carbon::now()*/,
                        'updated_at' => $new_date/*Carbon::now()*/
                    ]
                ]);
        }
        else{
//            $solde = \DB::table('portemonnaie_detail')
//                ->where('user_id','=',$user_id)
//                ->where('statut','=',$statut)
//                ->first();

            \DB::table('portemonnaie_detail')
                ->where('user_id','=',$user_id)
                ->where('coin_id','=',$coin_id)
                ->where('statut','=',$statut)
                ->update([
                    'nbre' => $recherche->nbre + $nbre,
                    'updated_at' => $new_date/*Carbon::now()*/
                ]);
        }

        //return response()->json(['message' => 'success']);
    }


    //fonction pour débiter le portemonnaie_detail
    public function debitePortemonnaieDetail($user_id,$coin_id,$nbre,$statut){
        $date_courante = Carbon::now();

        $date = new DateTime($date_courante);
        $now = clone $date;
        $now->modify('+2 hour');
        //$dateValable contient la date courante +1h heure de l'afrique du sud

        $new_date = $now->format('Y-m-d H:i:s');


        $recherche = \DB::table('portemonnaie_detail')
            ->where('user_id','=',$user_id)
            ->where('coin_id','=',$coin_id)
            ->where('statut','=',$statut)
            ->first();

        if(!empty($recherche)){
            $somme = $recherche->nbre - $nbre;
            /*if($somme < 0){
                return response()->json(['message' => 'error']);
            }*/
            if($somme >= 0){
                \DB::table('portemonnaie_detail')
                    ->where('user_id','=',$user_id)
                    ->where('coin_id','=',$coin_id)
                    ->where('statut','=',$statut)
                    ->update([
                        'nbre' => $somme,
                        'updated_at' => $new_date/*Carbon::now()*/
                    ]);

                if($somme == 0){
                    \DB::table('portemonnaie_detail')
                        ->where('user_id','=',$user_id)
                        ->where('coin_id','=',$coin_id)
                        ->where('statut','=',$statut)
                        ->delete();
                }

            }
            /*else{
                \DB::table('portemonnaie_detail')
                    ->where('user_id','=',$user_id)
                    ->where('coin_id','=',$coin_id)
                    ->where('statut','=',$statut)
                    ->delete();
            }*/


        }

        // return response()->json(['message' => 'success']);
    }


    //permet de réorganiser le portemonnaie_detail du user en recalculant les nbres de pièces par lot de coins
    public function reorganisePortemonnaieDetail($user_id,$valeur_coin,$statut){
        //je récupère tous les lots de coin du système
        $lot_coins = \DB::table('coins')
            ->orderBy('valeur_coin','desc')
            ->get();

        if(!empty($lot_coins)){
            foreach($lot_coins as $lot){
                $nbre = (int) ($valeur_coin / $lot->valeur_coin);  //ici on doit avoir une division entière
                $valeur_coin = $valeur_coin % $lot->valeur_coin;    //reste de la division

                if($nbre != 0){
                    //insertion dans la table portemonnaie_detail
                    $this->creditePortemonnaieDetail($user_id,$lot->id,$nbre,$statut);

                    //je notifie le user sur le nbre de lot de coins chargé
                    //$this->SaveNotification('Add number pieces lot of corners'/*'Ajout nombre pièces lot de coins'*/,'A number of corner lot pieces were loaded by the system'/*'Un nombre de pièces de lot de coins a été chargé par le système'*/,$user_id,0);
                }

            }
        }

    }


    //permet de calculer le solde coin dans le portemonnaie_detail du user en fonction du statut = (chargé ou gagné)
    public function calcul_solde_coin($user_id,$statut){
        $solde = 0;

        $calculs = \DB::table('portemonnaie_detail')
            ->join('coins','coins.id','=','portemonnaie_detail.coin_id')
            ->where('portemonnaie_detail.user_id','=',$user_id)
            ->where('portemonnaie_detail.statut','=',$statut)
            ->get();

        if(!empty($calculs)){
            foreach($calculs as $calcul){
                $solde += ($calcul->valeur_coin * $calcul->nbre);
            }
        }

        return $solde;
    }



    /*************************************** END Fonctions réutilisables *************************************************/







}