<?php

namespace App\Http\Controllers;

use App\Repositories\UserRepository;

use Dompdf\FrameDecorator\NullFrameDecorator;
use DateTime;
use Input;

use Response;

use Request;

use App\Models\User;

use Auth;

//use Illuminate\Http\Request;

use JWTAuth;

use Tymon\JWTAuth\Exceptions\JWTException;

use DB;

use Carbon\Carbon;

use Mail;

use GuzzleHttp\Client;

use PushNotification;

use Facebook;
use Facebook\Helpers\FacebookRedirectLoginHelper;
use Facebook\FacebookSDKException;
use Facebook\Authentication\OAuth2Client;



use Codebird\Codebird;

use Spatie\UrlSigner\MD5UrlSigner;

use Illuminate\Support\Facades\View;
use Illuminate\Support\ServiceProvider;
//use App\Http\Controllers\Snowfire\Beautymail\Beautymail;
use Snowfire\Beautymail\Beautymail;


//use Illuminate\Http\Request;

use App\Http\Requests;

class InvitationController extends Controller{

    //permet d'envoyer les codes à un ou plusieurs membre(s) pour joindre une tontine
    public function sendCodeMembersTontine($token){

        $request = Request::instance();
        $data = json_decode($request->getContent());

        //$delai = strtotime(Carbon::now()); /*+ 86400*///24h;

        //$urlSigner = new MD5UrlSigner('mysecretkey');

        //$expirationDate = (new DateTime)->modify('1 days');

        //$urlSigner->sign('http://toupesu.sdkgames.com/tontine/join-tontine', $expirationDate);

//        View::composer(
//            'invitation_confirm', function(){
//            $urlSigner = new MD5UrlSigner('mysecretkey');
//
//            $expirationDate = (new DateTime)->modify('1 minutes');
//
//
//
//            $urlSigner->sign('http://toupesu.sdkgames.com/tontine/join-tontine', $expirationDate);
//        }
//        );


        $tontine_id = $data->tontine_id;
        $senderid = \DB::table('users')
            ->where('remember_token','=',$token)
            ->first();

        if(empty($senderid)){
            return response()->json(['message' => 'error', 'user_not_found' => true], 400);
        }

        $sender_id = $senderid->id;
        $listeMembres = $data->members;

        $statutcode = "unused";     //pour dire codecle pas encore utilisé

        $statutvalidite = "valid";  //pour dire que le code n'est pas encore expiré

        //dd(sizeof($listeMembres));

        $test = array();
        $phone_already_exist = array();
        $email_already_exist = array();
        $invitation_already_send = array();
        $invitation = array();
        //$user = array();
        $code = array();
        $resultat = array();
        $user = array();
        $codecle = null;

        $phone_already_exist = false;
        $email_already_exist = false;
        $invitation_already_send = false;
        $tontine_not_found = false;
        $user_exist_tontine = false;
        $user_unauthorized = false;
        $no_match_email_to_phone = false;

        //ici je contrôle si le user est admin dans la tontine
        $authorization = \DB::table('membrestontines')
            ->where('user_id','=',$sender_id)
            ->where('tontine_id','=',$tontine_id)
            ->where('administrator','=',1)
            ->first();

        if(empty($authorization)){
            $user_unauthorized = true;
            $result = array(
                'message' => 'error',
                //'phone_already_exist' => $phone_already_exist,
                //'email_already_exist' => $email_already_exist,
                'invitation_exist' => $invitation_already_send,
                'tontine_not_found' => $tontine_not_found,
                'user_exist_tontine' => $user_exist_tontine,
                'user_unauthorized' => $user_unauthorized,
                //'no_match_email_to_phone' => $no_match_email_to_phone
                //'user_temporaire' => $user,
                //'invitation' => $invitation,
                //'code' => $codecle
            );

            return response()->json(['resultat' => $result],400);

        }

        if(sizeof($listeMembres)!= 0){
            for ($i = 0; $i < sizeof($listeMembres); $i++) {
                $test = $listeMembres[$i];

                $phone_already_exist = false;
                $email_already_exist = false;
                $invitation_already_send = false;
                $tontine_not_found = false;
                $user_exist_tontine = false;
                $no_match_email_to_phone = false;

                //ici je contrôle si la tontine existe en BD
                $tontine = \DB::table('tontines')
                    ->where('id','=',$tontine_id)
                    ->first();

                if(empty($tontine)){
                    $tontine_not_found = true;
                }


                //$username = $test->username;
                $administrator = $test->administrator;

                $index = filter_var($test->email_or_phone, FILTER_VALIDATE_EMAIL) ? 'email' : 'phone';

                if($index == "email"){
                    $email = $test->email_or_phone;

                    if($email != NULL){
                        $resultat_email = \DB::table('users')
                            ->where('email','=',$email)
                            ->first();

                        $user = \DB::table('users')
                            ->where('email','=',$email)
                            ->first();

                        if(!empty($resultat_email)){
                            //ça veut dire que le user existe déjà. on va contrôler s'il est déjà membre de la tontine
                            $sender = \DB::table('tontines')
                                ->where('id','=',$tontine_id)
                                ->first();

                            //ici je me rassure si l'invitation a déjà été envoyée au user. Si c'est le cas je mets juste à jour son codecle
                            $recherche_invitation = \DB::table('invitations')
                                //->where('sender_id','=',$sender_id)
                                ->where('receiver_id','=',$resultat_email->id)
                                ->where('tontine_id','=',$tontine_id)
                                ->where('etat','=','en attente')
                                ->first();

                            //puis on recherche le user dans la table membrestontines
                            $recherche_user = \DB::table('membrestontines')
                                ->where('user_id','=',$resultat_email->id)
                                ->where('tontine_id','=',$tontine_id)
                                ->first();

                            if(!empty($recherche_invitation)){
                                $invitation_already_send = true;
                            }

                            if(!empty($recherche_user)){
                                $user_exist_tontine = true;
                            }

                            if(empty($recherche_invitation) AND empty($recherche_user)){ //si l'invitation n'existe pas et que le user n'est pas encore membre de la tontine alors on envoie l'invitation
                                $codecle = str_random(6);
                                $etat = "en attente";

                                $code[$i] = $codecle;
                                \DB::table('invitations')
                                    ->insert([
                                        [
                                            'sender_id' => $sender_id,
                                            'receiver_id' => $resultat_email->id,
                                            'tontine_id' => $tontine_id,
                                            'codecle' => $codecle,
                                            'etat' => $etat,
                                            'administrator' => $administrator,
                                            'statutcode' => $statutcode,
                                            'statutvalidite' => $statutvalidite,
                                            'created_at' => Carbon::now(),
                                            'updated_at' => Carbon::now()]
                                    ]);

                                $invitation = \DB::table('invitations')
                                    //->where('sender_id','=',$sender_id)
                                    ->where('receiver_id','=',$resultat_email->id)
                                    ->where('tontine_id','=',$tontine_id)
                                    ->where('etat','=','en attente')
                                    ->first();

                                //**************** Partie pour l'envoi du codecle par mail au user /
                                $nom_tontine = $sender->name;
                                if($email != NULL){ //alors on envoit le mail. Dans le cas contraire on considère qu'il n'a pas d'email

                                    //$message = " Cher utilisateur,  \r\n \r\n voici le code à utiliser pour pouvoir joindre la tontine ".$nom_tontine;

                                    $message = " Cher utilisateur,  \r\n \r\n vous venez de recevoir une invitation pour pouvoir joindre la tontine ".$nom_tontine ." avec les éléments suivants :";

                                    //$message = $message . "\r\n \r\n \r\n Note:Veuillez rafraichir votre page de vote Merci." ;
                                    $subject = 'Joindre une tontine';

                                    $lien = 'Vous pouvez cliquer sur le lien suivant pour joindre la tontine et entrer votre code';



                                    //if (filter_var($data->email_or_phone, FILTER_VALIDATE_EMAIL)) {
                                    $data1 = [
                                        'from' => 'toupesu@dev.sdkgames.com',
                                        'from_name' => 'Toupesu',
                                        'to' => $email,
                                        'subject' => $subject,
                                        'title' => $message,
                                        'code' => '  Code : ' . $codecle,
                                        //'email' => '  Email : ' . $value->email,
                                        //'password' => $password,
                                        // 'download' => '  Download the application with the following link to connect ....' .
                                        //   ' Well after you can change your password. Thanks you',
                                        'link' => $lien,
                                        'code' => $codecle,
                                        'tontine_name' => $nom_tontine,
                                        'tontine_slogan' => $sender->slogan,
                                        'cercle' => $sender->cercle
                                        //'delai' => $delai
                                    ];

//                                    Mail::send('tontine.invitation_confirm', $data1, function ($message) use ($data1) {
//                                        $message->from($data1['from'], $data1['from_name']);
//                                        $message->to($data1['to'])->subject($data1['subject']);
//                                    });
                                    // }


                                    $beautymail = app()->make(Beautymail::class);
                                    $beautymail->send('tontine.welcome', $data1, function($message) use ($data1)
                                    {
                                        //$email = $test->email_or_phone;
                                        $message->from($data1['from'],$data1['from_name']);
                                        $message->to($data1['to'])->subject($data1['subject']);
                                    });




                                }

                                //**************************** end mail ***************************************************

                            }

                        }
                        else{//le user n'existe pas; on va l'ajouter en user temporaire

                            $temporaire = 1;
                            $confirmed = false;
                            $codecle = str_random(6);
                            $etat = "en attente";

                            $code[$i] = $codecle;

                            \DB::table('users')
                                ->insert([
                                    [
                                        //'lastname' => $username,
                                        //'phone' => $phone,
                                        'email' => $email,
                                        'temporaire' => $temporaire,
                                        'confirmed' => $confirmed,
                                        'role_id' => 3,
                                        'badge_id' => 1,
                                        'created_at' => Carbon::now(),
                                        'updated_at' => Carbon::now()]
                                ]);

                            //je récupère l'id du user (receiver_id pour pouvoir enregistrer dans la table invitations
                            $user = \DB::table('users')
                                ->where('email','=',$email)
                                ->first();

                            //je récupère aussi l'id du user qui a créé la tontine dans la table tontines
                            $sender = \DB::table('tontines')
                                ->where('id','=',$tontine_id)
                                ->first();

                            \DB::table('invitations')
                                ->insert([
                                    [
                                        'sender_id' => $sender_id,
                                        'receiver_id' => $user->id,
                                        'tontine_id' => $tontine_id,
                                        'codecle' => $codecle,
                                        'etat' => $etat,
                                        'administrator' => $administrator,
                                        'statutcode' => $statutcode,
                                        'statutvalidite' => $statutvalidite,
                                        'created_at' => Carbon::now(),
                                        'updated_at' => Carbon::now()]
                                ]);

                            $invitation = \DB::table('invitations')
                                ->where('receiver_id','=',$user->id)
                                ->where('tontine_id','=',$tontine_id)
                                ->where('etat','=','en attente')
                                ->first();

                            //**************** Partie pour l'envoi du codecle par mail au user *************************
                            $nom_tontine = $sender->name;
                            if($email != NULL) { //alors on envoit le mail. Dans le cas contraire on considère qu'il n'a pas d'email

                                //$message = " Cher utilisateur,  \r\n \r\n voici le code à utiliser pour pouvoir joindre la tontine ".$nom_tontine;

                                $message = " Cher utilisateur,  \r\n \r\n vous venez de recevoir une invitation pour pouvoir joindre la tontine ".$nom_tontine ." avec les éléments suivants :";

                                //$message = $message . "\r\n \r\n \r\n Note:Veuillez rafraichir votre page de vote Merci." ;
                                $subject = 'Joindre une tontine';

                                $lien = 'Vous pouvez cliquer sur le lien suivant pour joindre la tontine et entrer votre code';



                                //if (filter_var($data->email_or_phone, FILTER_VALIDATE_EMAIL)) {
                                $data1 = [
                                    'from' => 'toupesu@dev.sdkgames.com',
                                    'from_name' => 'Toupesu',
                                    'to' => $email,
                                    'subject' => $subject,
                                    'title' => $message,
                                    'code' => '  Code : ' . $codecle,
                                    //'email' => '  Email : ' . $value->email,
                                    //'password' => $password,
                                    // 'download' => '  Download the application with the following link to connect ....' .
                                    //   ' Well after you can change your password. Thanks you',
                                    'link' => $lien,
                                    'code' => $codecle,
                                    'tontine_name' => $nom_tontine,
                                    'tontine_slogan' => $sender->slogan,
                                    'cercle' => $sender->cercle
                                ];

//                                Mail::send('tontine.invitation_confirm', $data1, function ($message) use ($data1) {
//                                    $message->from($data1['from'], $data1['from_name']);
//                                    $message->to($data1['to'])->subject($data1['subject']);
//                                });
                                // }

                                $beautymail = app()->make(Beautymail::class);
                                $beautymail->send('tontine.welcome', $data1, function($message) use ($data1)
                                {
                                    //$email = $test->email_or_phone;
                                    $message->from($data1['from'],$data1['from_name']);
                                    $message->to($data1['to'])->subject($data1['subject']);
                                });

                            }

                        }

                        //$status = 200;  //OK
                        if(/*$phone_already_exist == true ||*/ $invitation_already_send == true || $tontine_not_found == true || $user_exist_tontine == true /*|| $no_match_email_to_phone == true*/){
                            //permet de gérer l'affichage pour chaque user à la fin
                            $resultat[$i] = array(
                                'message' => 'error',
                                //'phone_already_exist' => $phone_already_exist,
                                //'email_already_exist' => $email_already_exist,
                                'invitation_exist' => $invitation_already_send,
                                'tontine_not_found' => $tontine_not_found,
                                'user_exist_tontine' => $user_exist_tontine,
                                'user_unauthorized' => $user_unauthorized,
                                //'not_match_email_to_phone' => $no_match_email_to_phone
                                //'user_temporaire' => $user,
                                //'invitation' => $invitation,
                                //'code' => $codecle
                            );
                            $status = 400;
                        }
                        else{
                            //permet de gérer l'affichage pour chaque user à la fin
                            $resultat[$i] = array(
                                'message' => 'success',
                                //'phone_already_exist' => $phone_already_exist,
                                //'email_already_exist' => $email_already_exist,
                                //'invitation_exist' => $invitation_already_send,
                                'user_temporaire' => $user,
                                'invitation' => $invitation,
                                'code' => $codecle
                            );
                            $status = 200;
                        }

                    }
                }

                if($index == "phone"){
                    $phone = $test->email_or_phone;

                    if($phone != NULL){
                        $resultat_phone = \DB::table('users')
                            ->where('phone','=',$phone)
                            ->first();

                        $user = \DB::table('users')
                            ->where('phone','=',$phone)
                            ->first();

                        if(!empty($resultat_phone)){
                            //ça veut dire que le user existe déjà. on va contrôler s'il est déjà membre de la tontine
                            $sender = \DB::table('tontines')
                                ->where('id','=',$tontine_id)
                                ->first();

                            //ici je me rassure si l'invitation a déjà été envoyée au user. Si c'est le cas je mets juste à jour son codecle
                            $recherche_invitation = \DB::table('invitations')
                                //->where('sender_id','=',$sender_id)
                                ->where('receiver_id','=',$resultat_phone->id)
                                ->where('tontine_id','=',$tontine_id)
                                ->where('etat','=','en attente')
                                ->first();

                            //puis on recherche le user dans la table membrestontines
                            $recherche_user = \DB::table('membrestontines')
                                ->where('user_id','=',$resultat_phone->id)
                                ->where('tontine_id','=',$tontine_id)
                                ->first();

                            if(!empty($recherche_invitation)){
                                $invitation_already_send = true;
                            }

                            if(!empty($recherche_user)){
                                $user_exist_tontine = true;
                            }

                            if(empty($recherche_invitation) AND empty($recherche_user)){ //si l'invitation n'existe pas et que le user n'est pas encore membre de la tontine alors on envoie l'invitation
                                $codecle = str_random(6);
                                $etat = "en attente";

                                $code[$i] = $codecle;
                                \DB::table('invitations')
                                    ->insert([
                                        [
                                            'sender_id' => $sender_id,
                                            'receiver_id' => $resultat_phone->id,
                                            'tontine_id' => $tontine_id,
                                            'codecle' => $codecle,
                                            'etat' => $etat,
                                            'administrator' => $administrator,
                                            'statutcode' => $statutcode,
                                            'statutvalidite' => $statutvalidite,
                                            'created_at' => Carbon::now(),
                                            'updated_at' => Carbon::now()]
                                    ]);

                                $invitation = \DB::table('invitations')
                                    //->where('sender_id','=',$sender_id)
                                    ->where('receiver_id','=',$resultat_phone->id)
                                    ->where('tontine_id','=',$tontine_id)
                                    ->where('etat','=','en attente')
                                    ->first();

                                $email = $resultat_phone->email;

                                //**************** Partie pour l'envoi du codecle par mail au user /
                                $nom_tontine = $sender->name;
                                if($email != NULL){ //alors on envoit le mail. Dans le cas contraire on considère qu'il n'a pas d'email

                                    //$message = " Cher utilisateur,  \r\n \r\n voici le code à utiliser pour pouvoir joindre la tontine ".$nom_tontine;

                                    $message = " Cher utilisateur,  \r\n \r\n vous venez de recevoir une invitation pour pouvoir joindre la tontine ".$nom_tontine ." avec les éléments suivants :";

                                    //$message = $message . "\r\n \r\n \r\n Note:Veuillez rafraichir votre page de vote Merci." ;
                                    $subject = 'Joindre une tontine';

                                    $lien = 'Vous pouvez cliquer sur le lien suivant pour joindre la tontine et entrer votre code';



                                    //if (filter_var($data->email_or_phone, FILTER_VALIDATE_EMAIL)) {
                                    $data1 = [
                                        'from' => 'toupesu@dev.sdkgames.com',
                                        'from_name' => 'Toupesu',
                                        'to' => $email,
                                        'subject' => $subject,
                                        'title' => $message,
                                        'code' => '  Code : ' . $codecle,
                                        //'email' => '  Email : ' . $value->email,
                                        //'password' => $password,
                                        // 'download' => '  Download the application with the following link to connect ....' .
                                        //   ' Well after you can change your password. Thanks you',
                                        'link' => $lien,
                                        'code' => $codecle,
                                        'tontine_name' => $nom_tontine,
                                        'tontine_slogan' => $sender->slogan,
                                        'cercle' => $sender->cercle
                                    ];

//                                    Mail::send('tontine.invitation_confirm', $data1, function ($message) use ($data1) {
//                                        $message->from($data1['from'], $data1['from_name']);
//                                        $message->to($data1['to'])->subject($data1['subject']);
//                                    });
                                    // }

                                    $beautymail = app()->make(Beautymail::class);
                                    $beautymail->send('tontine.welcome', $data1, function($message) use ($data1)
                                    {
                                        //$email = $test->email_or_phone;
                                        $message->from($data1['from'],$data1['from_name']);
                                        $message->to($data1['to'])->subject($data1['subject']);
                                    });



                                }

                                //**************************** end mail ***************************************************


                                //**************************** Partie pour l'envoi avec le phone ***************************


                                //****************************           end phone                **************************

                            }

                        }
                        else{//le user n'existe pas; on va l'ajouter en user temporaire

                            $temporaire = 1;
                            $confirmed = false;
                            $codecle = str_random(6);
                            $etat = "en attente";

                            $code[$i] = $codecle;

                            \DB::table('users')
                                ->insert([
                                    [
                                        //'lastname' => $username,
                                        'phone' => $phone,
                                        //'email' => $email,
                                        'temporaire' => $temporaire,
                                        'confirmed' => $confirmed,
                                        'role_id' => 3,
                                        'badge_id' => 1,
                                        'created_at' => Carbon::now(),
                                        'updated_at' => Carbon::now()]
                                ]);

                            //je récupère l'id du user (receiver_id pour pouvoir enregistrer dans la table invitations
                            $user = \DB::table('users')
                                ->where('phone','=',$phone)
                                ->first();

                            //je récupère aussi l'id du user qui a créé la tontine dans la table tontines
                            $sender = \DB::table('tontines')
                                ->where('id','=',$tontine_id)
                                ->first();

                            \DB::table('invitations')
                                ->insert([
                                    [
                                        'sender_id' => $sender_id,
                                        'receiver_id' => $user->id,
                                        'tontine_id' => $tontine_id,
                                        'codecle' => $codecle,
                                        'etat' => $etat,
                                        'administrator' => $administrator,
                                        'statutcode' => $statutcode,
                                        'statutvalidite' => $statutvalidite,
                                        'created_at' => Carbon::now(),
                                        'updated_at' => Carbon::now()]
                                ]);

                            $invitation = \DB::table('invitations')
                                ->where('receiver_id','=',$user->id)
                                ->where('tontine_id','=',$tontine_id)
                                ->where('etat','=','en attente')
                                ->first();

                            $email = $user->email;

                            //**************** Partie pour l'envoi du codecle par mail au user *************************
                            $nom_tontine = $sender->name;
                            if($email != NULL) { //alors on envoit le mail. Dans le cas contraire on considère qu'il n'a pas d'email

                                //$message = " Cher utilisateur,  \r\n \r\n voici le code à utiliser pour pouvoir joindre la tontine ".$nom_tontine;

                                $message = " Cher utilisateur,  \r\n \r\n vous venez de recevoir une invitation pour pouvoir joindre la tontine ".$nom_tontine ." avec les éléments suivants :";

                                //$message = $message . "\r\n \r\n \r\n Note:Veuillez rafraichir votre page de vote Merci." ;
                                $subject = 'Joindre une tontine';

                                $lien = 'Vous pouvez cliquer sur le lien suivant pour joindre la tontine et entrer votre code';


                                //if (filter_var($data->email_or_phone, FILTER_VALIDATE_EMAIL)) {
                                $data1 = [
                                    'from' => 'toupesu@dev.sdkgames.com',
                                    'from_name' => 'Toupesu',
                                    'to' => $email,
                                    'subject' => $subject,
                                    'title' => $message,
                                    'code' => '  Code : ' . $codecle,
                                    //'email' => '  Email : ' . $value->email,
                                    //'password' => $password,
                                    // 'download' => '  Download the application with the following link to connect ....' .
                                    //   ' Well after you can change your password. Thanks you',
                                    'link' => $lien,
                                    'code' => $codecle,
                                    'tontine_name' => $nom_tontine,
                                    'tontine_slogan' => $sender->slogan,
                                    'cercle' => $sender->cercle
                                ];

//                                Mail::send('tontine.invitation_confirm', $data1, function ($message) use ($data1) {
//                                    $message->from($data1['from'], $data1['from_name']);
//                                    $message->to($data1['to'])->subject($data1['subject']);
//                                });
                                // }

                                $beautymail = app()->make(Beautymail::class);
                                $beautymail->send('tontine.welcome', $data1, function($message) use ($data1)
                                {
                                    //$email = $test->email_or_phone;
                                    $message->from($data1['from'],$data1['from_name']);
                                    $message->to($data1['to'])->subject($data1['subject']);
                                });

                            }
                            //**************************** end mail ***************************************************


                            //**************************** Partie pour l'envoi avec le phone ***************************


                            //****************************           end phone                **************************

                        }

                        //$status = 200;  //OK
                        if(/*$phone_already_exist == true ||*/ $invitation_already_send == true || $tontine_not_found == true || $user_exist_tontine == true /*|| $no_match_email_to_phone == true*/){
                            //permet de gérer l'affichage pour chaque user à la fin
                            $resultat[$i] = array(
                                'message' => 'error',
                                //'phone_already_exist' => $phone_already_exist,
                                //'email_already_exist' => $email_already_exist,
                                'invitation_exist' => $invitation_already_send,
                                'tontine_not_found' => $tontine_not_found,
                                'user_exist_tontine' => $user_exist_tontine,
                                'user_unauthorized' => $user_unauthorized,
                                //'not_match_email_to_phone' => $no_match_email_to_phone
                                //'user_temporaire' => $user,
                                //'invitation' => $invitation,
                                //'code' => $codecle
                            );
                            $status = 400;
                        }
                        else{
                            //permet de gérer l'affichage pour chaque user à la fin
                            $resultat[$i] = array(
                                'message' => 'success',
                                //'phone_already_exist' => $phone_already_exist,
                                //'email_already_exist' => $email_already_exist,
                                //'invitation_exist' => $invitation_already_send,
                                'user_temporaire' => $user,
                                'invitation' => $invitation,
                                'code' => $codecle
                            );
                            $status = 200;
                        }

                    }



                }



            }

            return response()->json(['resultat' => $resultat],$status);

        }

        return response()->json(['message' => 'error'], 400);

    }








    //permet d'envoyer les codes à un ou plusieurs membre(s) pour joindre une tontine
    /*  public function sendCodeMembersTontine($token){

           $request = Request::instance();
           $data = json_decode($request->getContent());

           $tontine_id = $data->tontine_id;
           $senderid = \DB::table('users')
               ->where('remember_token','=',$token)
               ->first();
           $sender_id = $senderid->id;
           $listeMembres = $data->members;

           $statutcode = "unused";     //pour dire codecle pas encore utilisé

           //dd(sizeof($listeMembres));

           $test = array();
           $phone_already_exist = array();
           $email_already_exist = array();
           $invitation_already_send = array();
           $invitation = array();
           //$user = array();
           $code = array();
           $resultat = array();
           $user = array();
           $codecle = null;

           $phone_already_exist = false;
           $email_already_exist = false;
           $invitation_already_send = false;
           $tontine_not_found = false;
           $user_exist_tontine = false;
           $user_unauthorized = false;
           $no_match_email_to_phone = false;

           //ici je contrôle si le user est admin dans la tontine
           $authorization = \DB::table('membrestontines')
               ->where('user_id','=',$sender_id)
               ->where('tontine_id','=',$tontine_id)
               ->where('administrator','=',1)
               ->first();

           if(empty($authorization)){
               $user_unauthorized = true;
               $result = array(
                   'message' => 'error',
                   'phone_already_exist' => $phone_already_exist,
                   'email_already_exist' => $email_already_exist,
                   'invitation_exist' => $invitation_already_send,
                   'tontine_not_found' => $tontine_not_found,
                   'user_exist_tontine' => $user_exist_tontine,
                   'user_unauthorized' => $user_unauthorized,
                   'no_match_email_to_phone' => $no_match_email_to_phone
                   //'user_temporaire' => $user,
                   //'invitation' => $invitation,
                   //'code' => $codecle
               );

               return response()->json(['resultat' => $result],400);

           }

           if(sizeof($listeMembres)!= 0){
               for ($i = 0; $i < sizeof($listeMembres); $i++) {
                   $test = $listeMembres[$i];

                   $phone_already_exist = false;
                   $email_already_exist = false;
                   $invitation_already_send = false;
                   $tontine_not_found = false;
                   $user_exist_tontine = false;
                   $no_match_email_to_phone = false;

                   //ici je contrôle si la tontine existe en BD
                   $tontine = \DB::table('tontines')
                       ->where('id','=',$tontine_id)
                       ->first();

                   if(empty($tontine)){
                       $tontine_not_found = true;
                   }


                   //$username = $test->username;
                   $phone = $test->phone;
                   $email = $test->email;
                   $administrator = $test->administrator;

                   if($phone != NULL){  //ici le phone est obligatoire
                       //ici je cherche dans la table users si le numéro existe déjà
                       $resultat_phone = \DB::table('users')
                           ->where('phone','=',$test->phone)
                           ->first();


                       if($email != NULL){
                           //ici je cherche si l'email existe déjà dans la table des users
                           $resultat_email = \DB::table('users')
                               ->where('email','=',$test->email)
                               ->first();

                           $no_match = \DB::table('users')
                               ->where('phone','=',$test->phone)
                               ->where('email','=',$test->email)
                               ->first();

                           if(empty($no_match)){
                               $no_match_email_to_phone = true;
                           }

                           if(!empty($resultat_email)){
                               $email_already_exist = true;
                           }
                       }
                       else{
                           //ici je veux juste renvoyer l'objet vide dans $resultat_email car je suis sûr que l'email tamba ne va jamais exister dans BD vue sa structure
                           $resultat_email = \DB::table('users')
                               ->where('email','=','tamba')
                               ->first();
                       }

                       //ici c'est le cas où le phone du user est déjà dans la table users et donc le user est déjà présent et son code va être envoyé par mail
                       if(!empty($resultat_phone)){

                           //$phone_already_exist = true;

                           $user = \DB::table('users')
                               ->where('phone','=',$phone)
                               ->first();

                           $codecle = str_random(6);
                           $etat = "en attente";

                           $code[$i] = $codecle;

                           //je récupère aussi l'id du user qui a créé la tontine dans la table tontines
                           $sender = \DB::table('tontines')
                               ->where('id','=',$tontine_id)
                               ->first();

                           //ici je me rassure si l'invitation a déjà été envoyée au user. Si c'est le cas je mets juste à jour son codecle
                           $recherche_invitation = \DB::table('invitations')
                               //->where('sender_id','=',$sender_id)
                               ->where('receiver_id','=',$user->id)
                               ->where('tontine_id','=',$tontine_id)
                               ->where('etat','=','en attente')
                               ->first();

                           $invitation = \DB::table('invitations')
                               ->where('receiver_id','=',$user->id)
                               ->where('tontine_id','=',$tontine_id)
                               ->where('etat','=','en attente')
                               ->get();

                           //puis on recherche le user dans la table membrestontines
                           $recherche_user = \DB::table('membrestontines')
                               ->where('user_id','=',$user->id)
                               ->where('tontine_id','=',$tontine_id)
                               ->first();
                           if(!empty($recherche_user)){
                               $user_exist_tontine = true;

                               //permet de gérer l'affichage pour chaque user à la fin
                               $resultat[$i] = array(
                                   'message' => 'error',
                                   'phone_already_exist' => $phone_already_exist,
                                   //'email_already_exist' => $email_already_exist,
                                   'invitation_exist' => $invitation_already_send,
                                   'tontine_not_found' => $tontine_not_found,
                                   'user_exist_tontine' => $user_exist_tontine,
                                   'user_unauthorized' => $user_unauthorized,
                                   'not_match_email_to_phone' => $no_match_email_to_phone
                                   //'user_temporaire' => $user,
                                   //'invitation' => $invitation,
                                   //'code' => $codecle
                               );
                               $status = 400;

                               return response()->json(['resultat' => $resultat],$status);

                           }

                           if(!empty($recherche_invitation)){  //cas où l'invitation a déjà été envoyée
                               //je remets son codecle
                               $code = $recherche_invitation->codecle;
                               $invitation_already_send = true;

                           }
                           else{//dans ce cas l'invitation n'a pas encore été envoyée au user pour cette tontine

                               \DB::table('invitations')
                                   ->insert([
                                       [
                                           'sender_id' => $sender_id,
                                           'receiver_id' => $user->id,
                                           'tontine_id' => $tontine_id,
                                           'codecle' => $codecle,
                                           'etat' => $etat,
                                           'administrator' => $administrator,
                                           'statutcode' => $statutcode,
                                           'created_at' => Carbon::now(),
                                           'updated_at' => Carbon::now()]
                                   ]);

                               //**************** Partie pour l'envoi du codecle par mail au user /
                               $nom_tontine = $sender->name;
                               if($email != NULL){ //alors on envoit le mail. Dans le cas contraire on considère qu'il n'a pas d'email

                                   $message = " Cher utilisateur,  \r\n \r\n voici le code à utiliser pour pouvoir joindre la tontine ".$nom_tontine;

                                   //$message = $message . "\r\n \r\n \r\n Note:Veuillez rafraichir votre page de vote Merci." ;
                                   $subject = 'Joindre une tontine';


                                   //if (filter_var($data->email_or_phone, FILTER_VALIDATE_EMAIL)) {
                                   $data1 = [
                                       'from' => 'moomeetings@dev.sdkgames.com',
                                       'from_name' => 'MooTontine',
                                       'to' => $email,
                                       'subject' => $subject,
                                       'title' => $message,
                                       'code' => '  Code : ' . $codecle,
                                       //'email' => '  Email : ' . $value->email,
                                       //'password' => $password,
                                       // 'download' => '  Download the application with the following link to connect ....' .
                                       //   ' Well after you can change your password. Thanks you',
                                       'link' => 'Vous pouvez aussi cliquer sur le lien suivant pour joindre la tontine',
                                       'code' => $codecle
                                   ];

                                   Mail::send('tontine.invitation_confirm', $data1, function ($message) use ($data1) {
                                       $message->from($data1['from'], $data1['from_name']);
                                       $message->to($data1['to'])->subject($data1['subject']);
                                   });
                                   // }


                               }

                               //**************************** end mail ***************************************************


                               //************** Partie pour l'envoi du codecle par phone au user ***********************



                               //************************** end phone **************************************************

                           }

                       }

                       //ici s'il n'y a aucune occurrence du phone et l'email dans la table users alors on enregistre le user en temporaire et on l'envoit le code par phone et par mail
                       if(empty($resultat_phone) AND empty($resultat_email)){
                           $temporaire = 1;
                           $confirmed = false;
                           $codecle = str_random(6);
                           $etat = "en attente";

                           $code[$i] = $codecle;

                           \DB::table('users')
                               ->insert([
                                   [
                                       //'lastname' => $username,
                                       'phone' => $phone,
                                       'email' => $email,
                                       'temporaire' => $temporaire,
                                       'confirmed' => $confirmed,
                                       'role_id' => 3,
                                       'badge_id' => 1,
                                       'created_at' => Carbon::now(),
                                       'updated_at' => Carbon::now()]
                               ]);

                           //je récupère l'id du user (receiver_id pour pouvoir enregistrer dans la table invitations
                           $user = \DB::table('users')
                               ->where('phone','=',$phone)
                               ->first();

                           //je récupère aussi l'id du user qui a créé la tontine dans la table tontines
                           $sender = \DB::table('tontines')
                               ->where('id','=',$tontine_id)
                               ->first();

                           \DB::table('invitations')
                               ->insert([
                                   [
                                       'sender_id' => $sender_id,
                                       'receiver_id' => $user->id,
                                       'tontine_id' => $tontine_id,
                                       'codecle' => $codecle,
                                       'etat' => $etat,
                                       'administrator' => $administrator,
                                       'statutcode' => $statutcode,
                                       'created_at' => Carbon::now(),
                                       'updated_at' => Carbon::now()]
                               ]);

                           $invitation = \DB::table('invitations')
                               ->where('receiver_id','=',$user->id)
                               ->where('tontine_id','=',$tontine_id)
                               ->where('etat','=','en attente')
                               ->first();

                           //**************** Partie pour l'envoi du codecle par mail au user *************************
                           $nom_tontine = $sender->name;
                           if($email != NULL){ //alors on envoit le mail. Dans le cas contraire on considère qu'il n'a pas d'email

                               $message = " Cher utilisateur,  \r\n \r\n voici le code à utiliser pour pouvoir joindre la tontine ".$nom_tontine;

                               //$message = $message . "\r\n \r\n \r\n Note:Veuillez rafraichir votre page de vote Merci." ;
                               $subject = 'Joindre une tontine';


                               //if (filter_var($data->email_or_phone, FILTER_VALIDATE_EMAIL)) {
                               $data1 = [
                                   'from' => 'moomeetings@dev.sdkgames.com',
                                   'from_name' => 'MooTontine',
                                   'to' => $email,
                                   'subject' => $subject,
                                   'title' => $message,
                                   'code' => '  Code : ' . $codecle,
                                   //'email' => '  Email : ' . $value->email,
                                   //'password' => $password,
                                   // 'download' => '  Download the application with the following link to connect ....' .
                                   //   ' Well after you can change your password. Thanks you',
                                   'link' => 'Vous pouvez aussi cliquer sur le lien suivant pour joindre la tontine',
                                   'code' => $codecle
                               ];

                               Mail::send('tontine.invitation_confirm', $data1, function ($message) use ($data1) {
                                   $message->from($data1['from'], $data1['from_name']);
                                   $message->to($data1['to'])->subject($data1['subject']);
                               });
                               // }


                           }

                           //**************************** end mail ***************************************************


                           //************** Partie pour l'envoi du codecle par phone au user ***********************



                           //************************** end phone **************************************************
                       }

                   }

                   //$status = 200;  //OK
                   if($phone_already_exist == true || $invitation_already_send == true || $tontine_not_found == true || $user_exist_tontine == true || $no_match_email_to_phone == true){
                       //permet de gérer l'affichage pour chaque user à la fin
                       $resultat[$i] = array(
                           'message' => 'error',
                           'phone_already_exist' => $phone_already_exist,
                           //'email_already_exist' => $email_already_exist,
                           'invitation_exist' => $invitation_already_send,
                           'tontine_not_found' => $tontine_not_found,
                           'user_exist_tontine' => $user_exist_tontine,
                           'user_unauthorized' => $user_unauthorized,
                           'not_match_email_to_phone' => $no_match_email_to_phone
                           //'user_temporaire' => $user,
                           //'invitation' => $invitation,
                           //'code' => $codecle
                       );
                       $status = 400;
                   }
                   else{
                       //permet de gérer l'affichage pour chaque user à la fin
                       $resultat[$i] = array(
                           'message' => 'success',
                           //'phone_already_exist' => $phone_already_exist,
                           //'email_already_exist' => $email_already_exist,
                           //'invitation_exist' => $invitation_already_send,
                           'user_temporaire' => $user,
                           'invitation' => $invitation,
                           'code' => $codecle
                       );
                       $status = 200;
                   }




               }

               return response()->json(['resultat' => $resultat],$status);

           }

           return response()->json(['message' => 'error'], 400);

       }
   */

    //permet de confirmer le codecle du user pour joindre la tontine
    public function confirmCodeTontine(){
        $request = Request::instance();
        $data = json_decode($request->getContent());

        $code = $data->code_invitation;

        $code_problem = 1;  //1 pour dire le code n'existe pas

        $code_problem = 2; //2 pour dire le code a expiré

        $resultat = \DB::table('invitations')
            ->where('codecle','=',$code)
            ->where('etat','=','en attente')
            ->where('statutcode','=','unused')
            ->first();

        $resultat1 = \DB::table('invitations')
            ->where('codecle','=',$code)
            //->where('etat','=','en attente')
            ->where('statutcode','=','used')
            ->first();

        $resultat2 = \DB::table('invitations')
            ->where('codecle','=',$code)
            //->where('etat','=','en attente')
            ->where('statutvalidite','=','invalid')
            ->first();

        if(!empty($resultat1)){
            $code_problem = 3;  //pour dire le code est déjà utilisé
            return response()->json(['message' => 'error','code_problem' => $code_problem], 400);
        }

        if(!empty($resultat2)){
            $code_problem = 2;  //pour dire le code a expiré
            return response()->json(['message' => 'error','code_problem' => $code_problem], 400);
        }

        if(!empty($resultat)){      //je dois renvoyer les infos sur le user
            $user = \DB::table('users')
                ->where('id','=',$resultat->receiver_id)
                ->first();

            $tontine = \DB::table('tontines')
                ->where('id','=',$resultat->tontine_id)
                ->first();

            $method_payment = \DB::table('methodepaiementtontines')
                ->where('tontine_id','=',$resultat->tontine_id)
                ->get();

            return response()->json([
                'message' => 'success',
                'tontine' => $tontine,
                'method_payment' => $method_payment,
                'invitation' => $resultat,
                'code_invitation' => $code,
                'user_id' => $user->id,
                'user' => $user
            ]);

        }

        return response()->json(['message' => 'error','code_problem' => $code_problem], 400);

    }


    //permet à un user de joindre la tontine avec si possible avec son vrai compte
    public function acceptedJoinTontineSpecial(UserRepository $users){

        $request = Request::instance();
        $data = json_decode($request->getContent());


        $user_id = $data->user_id;
        $invitation_id = $data->invitation_id;

        $ajout_part_membre_en_contribuant_seances_passees_et_restantes = $data->ajout_part_membre_en_contribuant_seances_passees_et_restantes;      //rempli par oui ou non
        $ajout_part_membre_en_contribuant_seulement_seances_restantes = $data->ajout_part_membre_en_contribuant_seulement_seances_restantes;        //rempli par oui ou non

        $code_problem = 1;  //1 pour dire le code n'existe pas

        $code_problem = 2; //2 pour dire le code a expiré

        $user_not_found = false;

        $resultat1 = \DB::table('users')
            ->where('id','=',$user_id)
            ->first();

        $resultat2 = \DB::table('invitations')
            ->where('id','=',$invitation_id)
            //->where('etat','=','en attente')
            ->where('statutcode','=','used')
            ->first();

        $resultat3 = \DB::table('invitations')
            ->where('id','=',$invitation_id)
            //->where('etat','=','en attente')
            ->where('statutvalidite','=','invalid')
            ->first();

        if(empty($resultat1)){
            $user_not_found = true;
        }

        if(!empty($resultat2)){
            $code_problem = 3;  //pour dire le code est déjà utilisé
            return response()->json(['message' => 'error', /*'invitation_already_accepted' => true,*/ 'user_not_found' => $user_not_found, 'code_problem' => $code_problem], 400);

        }

        if(!empty($resultat3)){
            $code_problem = 2;  //pour dire le code a expiré
            return response()->json(['message' => 'error', /*'invitation_already_accepted' => true,*/ 'user_not_found' => $user_not_found, 'code_problem' => $code_problem], 400);
        }

        //ceci c'est le cas où le user veut dire qu'il a déjà un compte et que lors de l'envoi de l'invitation ça n'a pas été fait avec son vrai téléphone ou email
        if($invitation_id != NULL){
            $recherche = \DB::table('invitations')
                ->where('id','=',$invitation_id)
                ->where('etat','=','en attente')
                ->first();

            if(!empty($recherche)){

                //je teste si le user_id du user enregistré dans le système est différent de celui de receiver_id ds invitations
                if( $user_id != $recherche->receiver_id){
                    //je pars rechercher si le user est temporaire et je l'efface s'il est présent
                    \DB::table('users')
                        ->where('id','=',$recherche->receiver_id)
                        ->where('temporaire','=',1)
                        ->delete();

                    //puis je mets à jour le receiver_id dans la table invitations
                    \DB::table('invitations')
                        ->where('receiver_id','=',$recherche->receiver_id)
                        ->update([
                            'receiver_id' => $user_id,
                            'updated_at' => Carbon::now()
                        ]);
                }
            }
        }

        $resultat = \DB::table('invitations')
            ->where('id','=',$invitation_id)
            ->where('etat','=','en attente')
            ->where('statutcode','=','unused')
            ->where('statutvalidite','=','valid')
            ->first();

        if(!empty($resultat)){      //je dois save le user dans la table membrestontines

            \DB::table('invitations')
                ->where('id','=',$invitation_id)
                ->where('receiver_id','=',$user_id)
                ->where('etat','=','en attente')
                ->where('statutcode','=','unused')
                ->where('statutvalidite','=','valid')
                ->update([
                    'etat' => 'accepted',
                    'statutcode' => 'used',
                    'updated_at' => Carbon::now()
                ]);

            $tontine_id = $recherche->tontine_id;
            //puis je recherche dans la table membrestontines si le user existe déjà dans la tontine
            $recherche = \DB::table('membrestontines')
                ->where('user_id','=',$resultat->receiver_id)
                ->where('tontine_id','=',$tontine_id)
                ->first();
            if(empty($recherche)){
                //insertion dans la table membrestontines
                \DB::table('membrestontines')
                    ->insert([
                        [
                            'user_id' => $resultat->receiver_id,
                            'tontine_id' => $resultat->tontine_id,
                            'administrator' => $resultat->administrator,
                            'numero_part' => 1,
                            'created_at' => Carbon::now(),
                            'updated_at' => Carbon::now()]
                    ]);

                $cycle_id = $this->getCycleCourantId($resultat->tontine_id);
                $seance_id = $this->getSeanceCouranteId($resultat->tontine_id);

                //insertion dans la table parts
                \DB::table('parts')
                    ->insert([
                        [
                            'user_id' => $resultat->receiver_id,
                            'tontine_id' => $resultat->tontine_id,
                            'numero_part' => 1,
                            'cycle_id' => $cycle_id,
                            'seance_id' => $seance_id,
                            'ajout_part_membre_en_contribuant_seances_passees_et_restantes' => $ajout_part_membre_en_contribuant_seances_passees_et_restantes,
                            'ajout_part_membre_en_contribuant_seulement_seances_restantes' => $ajout_part_membre_en_contribuant_seulement_seances_restantes,
                            'created_at' => Carbon::now(),
                            'updated_at' => Carbon::now()]
                    ]);
            }

            $user = \DB::table('users')
                ->where('id','=',$resultat->receiver_id)
                ->first();

            $tontine = \DB::table('tontines')
                ->where('id','=',$resultat->tontine_id)
                ->first();

            $role = \DB::table('membrestontines')
                ->where('user_id','=',$resultat->receiver_id)
                ->where('tontine_id','=',$resultat->tontine_id)
                ->where('numero_part','=',1)
                ->first();

            $method_payment = \DB::table('methodepaiementtontines')
                ->where('tontine_id','=',$resultat->tontine_id)
                ->get();

            $invitation = \DB::table('invitations')
                ->where('id','=',$invitation_id)
                ->first();

            $email = NULL;
            $phone = NULL;
            if(!empty($invitation_id)){
                $test = \DB::table('users')
                    ->where('id','=',$invitation->receiver_id)
                    ->first();
                if(!empty($test)){
                    $email = $test->email;
                    $phone = $test->phone;
                }
            }

            return response()->json([
                'message' => 'success',
                'tontine' => $tontine,
                'method_payment' => $method_payment,
                'invitation' => $invitation,
                'email' => $email,
                'phone' => $phone
                //'user' => $user,
                //'administrator' => $role->administrator
            ]);

        }

        return response()->json(['message' => 'error', /*'invitation_already_accepted' => true,*/ 'user_not_found' => $user_not_found, 'code_problem' => $code_problem], 400);

    }


    //permet d'enregistrer la validation effective pour un user voulant joindre une tontine
    public function accceptedJoinTontine(UserRepository $users){
        $request = Request::instance();
        $data = json_decode($request->getContent());

        $user_id = $data->user_id;
        $code = $data->code_invitation;

        $ajout_part_membre_en_contribuant_seances_passees_et_restantes = $data->ajout_part_membre_en_contribuant_seances_passees_et_restantes;      //rempli par oui ou non
        $ajout_part_membre_en_contribuant_seulement_seances_restantes = $data->ajout_part_membre_en_contribuant_seulement_seances_restantes;        //rempli par oui ou non

        $code_problem = 1;  //1 pour dire le code n'existe pas

        $code_problem = 2; //2 pour dire le code a expiré

        $user_not_found = false;

        $resultat1 = \DB::table('users')
            ->where('id','=',$user_id)
            ->first();

        $resultat2 = \DB::table('invitations')
            ->where('codecle','=',$code)
            //->where('etat','=','en attente')
            ->where('statutcode','=','used')
            ->first();

        $resultat3 = \DB::table('invitations')
            ->where('codecle','=',$code)
            //->where('etat','=','en attente')
            ->where('statutvalidite','=','invalid')
            ->first();

        if(empty($resultat1)){
            $user_not_found = true;
        }

        if(!empty($resultat2)){
            $code_problem = 3;  //pour dire le code est déjà utilisé
            return response()->json(['message' => 'error', 'user_not_found' => $user_not_found, 'code_problem' => $code_problem], 400);

        }

        if(!empty($resultat3)){
            $code_problem = 2;  //pour dire le code a expiré
            return response()->json(['message' => 'error', 'user_not_found' => $user_not_found, 'code_problem' => $code_problem], 400);

        }

        $resultat = \DB::table('invitations')
            ->where('codecle','=',$code)
            ->where('etat','=','en attente')
            ->where('statutcode','=','unused')
            ->first();

        if(!empty($resultat)){      //je dois save le user dans la table membrestontines

            \DB::table('invitations')
                ->where('codecle','=',$code)
                ->where('receiver_id','=',$user_id)
                ->where('etat','=','en attente')
                ->where('statutcode','=','unused')
                ->update([
                    'etat' => 'accepted',
                    'statutcode' => 'used',
                    'updated_at' => Carbon::now()
                ]);

            //puis je recherche dans la table membrestontines si le user existe déjà dans la tontine
            $recherche = \DB::table('membrestontines')
                ->where('user_id','=',$resultat->receiver_id)
                ->first();
            if(empty($recherche)){
                //insertion ds la table membrestontines
                \DB::table('membrestontines')
                    ->insert([
                        [
                            'user_id' => $resultat->receiver_id,
                            'tontine_id' => $resultat->tontine_id,
                            'administrator' => $resultat->administrator,
                            'numero_part' => 1,
                            'created_at' => Carbon::now(),
                            'updated_at' => Carbon::now()]
                    ]);


                $cycle_id = $this->getCycleCourantId($resultat->tontine_id);
                $seance_id = $this->getSeanceCouranteId($resultat->tontine_id);

                //insertion dans la table parts
                \DB::table('parts')
                    ->insert([
                        [
                            'user_id' => $resultat->receiver_id,
                            'tontine_id' => $resultat->tontine_id,
                            'numero_part' => 1,
                            'cycle_id' => $cycle_id,
                            'seance_id' => $seance_id,
                            'ajout_part_membre_en_contribuant_seances_passees_et_restantes' => $ajout_part_membre_en_contribuant_seances_passees_et_restantes,
                            'ajout_part_membre_en_contribuant_seulement_seances_restantes' => $ajout_part_membre_en_contribuant_seulement_seances_restantes,
                            'created_at' => Carbon::now(),
                            'updated_at' => Carbon::now()]
                    ]);
            }

            $user = \DB::table('users')
                ->where('id','=',$resultat->receiver_id)
                ->first();

            $tontine = \DB::table('tontines')
                ->where('id','=',$resultat->tontine_id)
                ->first();

            $role = \DB::table('membrestontines')
                ->where('user_id','=',$resultat->receiver_id)
                ->where('tontine_id','=',$resultat->tontine_id)
                ->where('numero_part','=',1)
                ->first();

            $method_payment = \DB::table('methodepaiementtontines')
                ->where('tontine_id','=',$resultat->tontine_id)
                ->get();


            return response()->json([
                'message' => 'success',
                'tontine' => $tontine,
                'method_payment' => $method_payment,
                'invitation' => $resultat,
                //'user' => $user,
                //'administrator' => $role->administrator
            ]);

        }

        return response()->json(['message' => 'error', 'user_not_found' => $user_not_found, 'code_problem' => $code_problem], 400);

    }


    //permet de refuser une invitation à une tontine
    public function refusedJoinTontine(){
        $request = Request::instance();
        $data = json_decode($request->getContent());

        $user_id = $data->user_id;
        $code = $data->code_invitation;
        $motif = $data->motif;

        $code_problem = 1;  //1 pour dire le code n'existe pas

        $code_problem = 2; //2 pour dire le code a expiré

        $user_not_found = false;

        $resultat1 = \DB::table('users')
            ->where('id','=',$user_id)
            ->first();

        $resultat2 = \DB::table('invitations')
            ->where('codecle','=',$code)
            //->where('etat','=','en attente')
            ->where('statutcode','=','used')
            ->first();

        $resultat3 = \DB::table('invitations')
            ->where('codecle','=',$code)
            //->where('etat','=','en attente')
            ->where('statutvalidite','=','invalid')
            ->first();

        if(empty($resultat1)){
            $user_not_found = true;
        }

        if(!empty($resultat2)){
            $code_problem = 3;  //pour dire le code est déjà utilisé
        }

        if(!empty($resultat3)){
            $code_problem = 2;  //pour dire le code a expiré
        }


        $resultat = \DB::table('invitations')
            ->where('codecle','=',$code)
            ->where('etat','=','en attente')
            ->where('statutcode','=','unused')
            ->first();

        if(!empty($resultat)){
            \DB::table('invitations')
                ->where('codecle','=',$code)
                ->where('receiver_id','=',$user_id)
                ->where('etat','=','en attente')
                ->where('statutcode','=','unused')
                ->update([
                    'etat' => 'refused',
                    'motif' => $motif,
                    'statutcode' => 'used',
                    'updated_at' => Carbon::now()
                ]);

            $user = \DB::table('users')
                ->where('id','=',$resultat->receiver_id)
                ->first();

            $tontine = \DB::table('tontines')
                ->where('id','=',$resultat->tontine_id)
                ->first();


            $method_payment = \DB::table('methodepaiementtontines')
                ->where('tontine_id','=',$resultat->tontine_id)
                ->get();


            return response()->json([
                'message' => 'success',
                'tontine' => $tontine,
                'method_payment' => $method_payment,
                'invitation' => $resultat,
                //'user' => $user,
                //'administrator' => $role->administrator
            ]);
        }

        return response()->json(['message' => 'error', 'user_not_found' => $user_not_found, 'code_problem' => $code_problem], 400);

    }

    /*
        //permet de confirmer le codecle du user pour joindre la tontine
        public function confirmCodeTontine(){
            $request = Request::instance();
            $data = json_decode($request->getContent());

            $code = $data->code;

            $resultat = \DB::table('invitations')
                ->where('codecle','=',$code)
                ->where('etat','=','en attente')
                ->first();

            if(!empty($resultat)){
                \DB::table('invitations')
                    ->where('codecle','=',$code)
                    ->where('etat','=','en attente')
                    ->update([
                        'etat' => 'accepted',
                        'updated_at' => Carbon::now()
                    ]);

                //puis je change son statut de user temporaire à un user normal
                \DB::table('users')
                    ->where('id','=',$resultat->receiver_id)
                    ->update([
                        'temporaire' => 0,
                        'updated_at' => Carbon::now()
                    ]);

                //puis je recherche dans la table membrestontines si le user existe déjà dans la tontine
                $recherche = \DB::table('membrestontines')
                    ->where('user_id','=',$resultat->receiver_id)
                    ->first();
                if(empty($recherche)){
                    \DB::table('membrestontines')
                        ->insert([
                            [
                                'user_id' => $resultat->receiver_id,
                                'tontine_id' => $resultat->tontine_id,
                                'administrator' => $resultat->administrator,
                                'created_at' => Carbon::now(),
                                'updated_at' => Carbon::now()]
                        ]);
                }

                $user = \DB::table('users')
                    ->where('id','=',$resultat->receiver_id)
                    ->first();

                $tontine = \DB::table('tontines')
                    ->where('id','=',$resultat->tontine_id)
                    ->first();

                $role = \DB::table('membrestontines')
                    ->where('user_id','=',$resultat->receiver_id)
                    ->where('tontine_id','=',$resultat->tontine_id)
                    ->first();


                return response()->json(['message' => 'success', 'user' => $user, 'tontine' => $tontine, 'administrator' => $role->administrator]);

            }

            return response()->json(['message' => 'error'], 400);

        }

        */


    //permet de renvoyer tous les membres d'une tontine
    public function getMembersTontine($tontine_id, $token){

        $sender = \DB::table('users')
            ->where('remember_token','=',$token)
            ->first();

        $sender_id = $sender->id;

        $tontine_not_found = false;
        $user_unauthorized = false;

        //ici je contrôle si le user est admin dans la tontine
        $authorization = \DB::table('membrestontines')
            ->where('user_id','=',$sender_id)
            ->where('tontine_id','=',$tontine_id)
            //->where('administrator','=',1)
            ->first();

        if(empty($authorization)){
            $user_unauthorized = true;
            /*$result = array(
                'message' => 'error',
                'phone_already_exist' => $phone_already_exist,
                'email_already_exist' => $email_already_exist,
                'invitation_exist' => $invitation_already_send,
                'tontine_not_found' => $tontine_not_found,
                'user_exist_tontine' => $user_exist_tontine,
                'user_unauthorized' => $user_unauthorized
                //'user_temporaire' => $user,
                //'invitation' => $invitation,
                //'code' => $codecle
            );*/

            return response()->json([
                'message' => 'error',
                //'phone_already_exist' => $phone_already_exist,
                //'email_already_exist' => $email_already_exist,
                //'invitation_exist' => $invitation_already_send,
                'tontine_not_found' => $tontine_not_found,
                //'user_exist_tontine' => $user_exist_tontine,
                'user_unauthorized' => $user_unauthorized],400);
        }

        //ici je recherche si la tontine existe
        $tontine = \DB::table('tontines')
            ->where('id','=',$tontine_id)
            ->first();

        if(empty($tontine)){
            $tontine_not_found = true;
            /*$result = array(
                'message' => 'error',
                'phone_already_exist' => $phone_already_exist,
                'email_already_exist' => $email_already_exist,
                'invitation_exist' => $invitation_already_send,
                'tontine_not_found' => $tontine_not_found,
                'user_exist_tontine' => $user_exist_tontine,
                'user_unauthorized' => $user_unauthorized
                //'user_temporaire' => $user,
                //'invitation' => $invitation,
                //'code' => $codecle
            );*/

            return response()->json([
                'message' => 'error',
                //'phone_already_exist' => $phone_already_exist,
                //'email_already_exist' => $email_already_exist,
                //'invitation_exist' => $invitation_already_send,
                'tontine_not_found' => $tontine_not_found,
                //'user_exist_tontine' => $user_exist_tontine,
                'user_unauthorized' => $user_unauthorized],400);
        }


        $listes = \DB::table('membrestontines')
            ->join('users','users.id','=','membrestontines.user_id')
            ->where('membrestontines.tontine_id','=',$tontine_id)
            ->where('numero_part','=',1)
            ->get();

        $liste = array();

        if(!empty($listes)){
            foreach ($listes as $listUser){
                $id = $listUser->id;
                $username = $listUser->username;
                $firstname = $listUser->firstname;
                $lastname = $listUser->lastname;
                $phone = $listUser->phone;
                $email = $listUser->email;
                $sexe = $listUser->sexe;
                $pays = $listUser->pays;
                $ville = $listUser->ville;
                $address = $listUser->address;
                $picture = $listUser->picture;
                $profession = $listUser->profession;
                $experience = $listUser->experience;
                $token = $listUser->remember_token;
                $temporaire = $listUser->temporaire;
                $administrator = $listUser->administrator;

                $tmp ["id"] = $id;
                $tmp ["username"] = $username;
                $tmp ["firstname"] = $firstname;
                $tmp ["lastname"] = $lastname;
                $tmp ["phone"] = $phone;
                $tmp ["email"] = $email;
                $tmp ["sexe"] = $sexe;
                $tmp ["pays"] = $pays;
                $tmp ["ville"] = $ville;
                $tmp ["address"] = $address;
                $tmp ["picture"] = $picture;
                $tmp ["profession"] = $profession;
                $tmp ["experience"] = $experience;
                $tmp ["remember_token"] = $token;
                $tmp ["temporaire"] = $temporaire;
                $tmp ["administrator"] = $administrator;

                array_push($liste,$tmp ) ;
            }
        }

        return response()->json(['message' => 'success', 'members' => $liste]);

    }


    //permet de renvoyer la liste des membres dont les invitations sont en attente
    public function getMembersInvitationsAttente($tontine_id, $token){

        $sender = \DB::table('users')
            ->where('remember_token','=',$token)
            ->first();

        $sender_id = $sender->id;

        $tontine_not_found = false;
        $user_unauthorized = false;

        //ici je contrôle si le user est admin dans la tontine
        $authorization = \DB::table('membrestontines')
            ->where('user_id','=',$sender_id)
            ->where('tontine_id','=',$tontine_id)
            ->where('administrator','=',1)
            ->first();

        if(empty($authorization)){
            $user_unauthorized = true;
            /*$result = array(
                'message' => 'error',
                'phone_already_exist' => $phone_already_exist,
                'email_already_exist' => $email_already_exist,
                'invitation_exist' => $invitation_already_send,
                'tontine_not_found' => $tontine_not_found,
                'user_exist_tontine' => $user_exist_tontine,
                'user_unauthorized' => $user_unauthorized
                //'user_temporaire' => $user,
                //'invitation' => $invitation,
                //'code' => $codecle
            );*/

            return response()->json([
                'message' => 'error',
                //'phone_already_exist' => $phone_already_exist,
                //'email_already_exist' => $email_already_exist,
                //'invitation_exist' => $invitation_already_send,
                'tontine_not_found' => $tontine_not_found,
                //'user_exist_tontine' => $user_exist_tontine,
                'user_unauthorized' => $user_unauthorized],400);
        }

        //ici je recherche si la tontine existe
        $tontine = \DB::table('tontines')
            ->where('id','=',$tontine_id)
            ->first();

        if(empty($tontine)){
            $tontine_not_found = true;
            /*$result = array(
                'message' => 'error',
                'phone_already_exist' => $phone_already_exist,
                'email_already_exist' => $email_already_exist,
                'invitation_exist' => $invitation_already_send,
                'tontine_not_found' => $tontine_not_found,
                'user_exist_tontine' => $user_exist_tontine,
                'user_unauthorized' => $user_unauthorized
                //'user_temporaire' => $user,
                //'invitation' => $invitation,
                //'code' => $codecle
            );*/

            return response()->json([
                'message' => 'error',
                //'phone_already_exist' => $phone_already_exist,
                //'email_already_exist' => $email_already_exist,
                //'invitation_exist' => $invitation_already_send,
                'tontine_not_found' => $tontine_not_found,
                //'user_exist_tontine' => $user_exist_tontine,
                'user_unauthorized' => $user_unauthorized],400);
        }


        $listes = \DB::table('invitations')
            ->join('users','users.id','=','invitations.receiver_id')
            ->where('invitations.tontine_id','=',$tontine_id)
            ->where('invitations.etat','=','en attente')
            ->select('users.id','users.username','users.firstname','users.lastname','users.phone','users.email',
                'users.sexe','users.pays','users.ville','users.address','users.picture','users.profession',
                'users.experience','users.remember_token','users.temporaire','invitations.id as invitation_id','invitations.administrator',
                'invitations.statutvalidite')
            ->get();

        $liste = array();

        if(!empty($listes)){
            foreach ($listes as $listUser){
                $id = $listUser->id;
                $username = $listUser->username;
                $firstname = $listUser->firstname;
                $lastname = $listUser->lastname;
                $phone = $listUser->phone;
                $email = $listUser->email;
                $sexe = $listUser->sexe;
                $pays = $listUser->pays;
                $ville = $listUser->ville;
                $address = $listUser->address;
                $picture = $listUser->picture;
                $profession = $listUser->profession;
                $experience = $listUser->experience;
                $token = $listUser->remember_token;
                $temporaire = $listUser->temporaire;
                $administrator = $listUser->administrator;
                $invitation_id = $listUser->invitation_id;
                $statutvalidite = $listUser->statutvalidite;

                $tmp ["id"] = $id;
                $tmp ["username"] = $username;
                $tmp ["firstname"] = $firstname;
                $tmp ["lastname"] = $lastname;
                $tmp ["phone"] = $phone;
                $tmp ["email"] = $email;
                $tmp ["sexe"] = $sexe;
                $tmp ["pays"] = $pays;
                $tmp ["ville"] = $ville;
                $tmp ["address"] = $address;
                $tmp ["picture"] = $picture;
                $tmp ["profession"] = $profession;
                $tmp ["experience"] = $experience;
                $tmp ["remember_token"] = $token;
                $tmp ["temporaire"] = $temporaire;
                $tmp ["administrator"] = $administrator;
                $tmp ["invitation_id"] = $invitation_id;
                $tmp ["statutvalidite"] = $statutvalidite;

                array_push($liste,$tmp ) ;
            }
        }

        $invitation = \DB::table('invitations')
            ->where('tontine_id','=',$tontine_id)
            ->where('invitations.etat','=','en attente')
            ->get();

        return response()->json(['message' => 'success', 'invitation' => $invitation, 'liste' => $liste]);

    }


    //permet de renvoyer la liste des membres dont les invitations sont refusées
    public function getMembersInvitationsRefused($tontine_id, $token){

        $sender = \DB::table('users')
            ->where('remember_token','=',$token)
            ->first();

        $sender_id = $sender->id;

        $tontine_not_found = false;
        $user_unauthorized = false;

        //ici je contrôle si le user est admin dans la tontine
        $authorization = \DB::table('membrestontines')
            ->where('user_id','=',$sender_id)
            ->where('tontine_id','=',$tontine_id)
            ->where('administrator','=',1)
            ->first();

        if(empty($authorization)){
            $user_unauthorized = true;
            /*$result = array(
                'message' => 'error',
                'phone_already_exist' => $phone_already_exist,
                'email_already_exist' => $email_already_exist,
                'invitation_exist' => $invitation_already_send,
                'tontine_not_found' => $tontine_not_found,
                'user_exist_tontine' => $user_exist_tontine,
                'user_unauthorized' => $user_unauthorized
                //'user_temporaire' => $user,
                //'invitation' => $invitation,
                //'code' => $codecle
            );*/

            return response()->json([
                'message' => 'error',
                //'phone_already_exist' => $phone_already_exist,
                //'email_already_exist' => $email_already_exist,
                //'invitation_exist' => $invitation_already_send,
                'tontine_not_found' => $tontine_not_found,
                //'user_exist_tontine' => $user_exist_tontine,
                'user_unauthorized' => $user_unauthorized],400);
        }

        //ici je recherche si la tontine existe
        $tontine = \DB::table('tontines')
            ->where('id','=',$tontine_id)
            ->first();

        if(empty($tontine)){
            $tontine_not_found = true;
            /*$result = array(
                'message' => 'error',
                'phone_already_exist' => $phone_already_exist,
                'email_already_exist' => $email_already_exist,
                'invitation_exist' => $invitation_already_send,
                'tontine_not_found' => $tontine_not_found,
                'user_exist_tontine' => $user_exist_tontine,
                'user_unauthorized' => $user_unauthorized
                //'user_temporaire' => $user,
                //'invitation' => $invitation,
                //'code' => $codecle
            );*/

            return response()->json([
                'message' => 'error',
                //'phone_already_exist' => $phone_already_exist,
                //'email_already_exist' => $email_already_exist,
                //'invitation_exist' => $invitation_already_send,
                'tontine_not_found' => $tontine_not_found,
                //'user_exist_tontine' => $user_exist_tontine,
                'user_unauthorized' => $user_unauthorized],400);
        }

        $listes = \DB::table('invitations')
            ->join('users','users.id','=','invitations.receiver_id')
            ->where('invitations.tontine_id','=',$tontine_id)
            ->where('invitations.etat','=','refused')
            ->select('users.id','users.username','users.firstname','users.lastname','users.phone','users.email',
                'users.sexe','users.pays','users.ville','users.address','users.picture','users.profession',
                'users.experience','users.remember_token','users.temporaire','invitations.id as invitation_id','invitations.administrator','invitations.motif')
            ->get();

        $liste = array();

        if(!empty($listes)){
            foreach ($listes as $listUser){
                $id = $listUser->id;
                $username = $listUser->username;
                $firstname = $listUser->firstname;
                $lastname = $listUser->lastname;
                $phone = $listUser->phone;
                $email = $listUser->email;
                $sexe = $listUser->sexe;
                $pays = $listUser->pays;
                $ville = $listUser->ville;
                $address = $listUser->address;
                $picture = $listUser->picture;
                $profession = $listUser->profession;
                $experience = $listUser->experience;
                $token = $listUser->remember_token;
                $temporaire = $listUser->temporaire;
                $administrator = $listUser->administrator;
                $invitation_id = $listUser->invitation_id;
                $motif = $listUser->motif;

                $tmp ["id"] = $id;
                $tmp ["username"] = $username;
                $tmp ["firstname"] = $firstname;
                $tmp ["lastname"] = $lastname;
                $tmp ["phone"] = $phone;
                $tmp ["email"] = $email;
                $tmp ["sexe"] = $sexe;
                $tmp ["pays"] = $pays;
                $tmp ["ville"] = $ville;
                $tmp ["address"] = $address;
                $tmp ["picture"] = $picture;
                $tmp ["profession"] = $profession;
                $tmp ["experience"] = $experience;
                $tmp ["remember_token"] = $token;
                $tmp ["temporaire"] = $temporaire;
                $tmp ["administrator"] = $administrator;
                $tmp ["invitation_id"] = $invitation_id;
                $tmp ["motif"] = $motif;

                array_push($liste,$tmp ) ;
            }
        }

        $invitation = \DB::table('invitations')
            ->where('tontine_id','=',$tontine_id)
            ->where('invitations.etat','=','en attente')
            ->get();

        return response()->json(['message' => 'success', 'invitation' => $invitation, 'liste' => $liste]);

    }


    //permet de supprimer une invitation
    public function deleteInvitation($token){
        $request = Request::instance();
        $data = json_decode($request->getContent());

        $tontine_id = $data->tontine_id;
        $invitation_id = $data->invitation_id;

        $sender = \DB::table('users')
            ->where('remember_token','=',$token)
            ->first();

        $sender_id = $sender->id;

        $invitation_already_send = false;
        $tontine_not_found = false;
        $user_exist_tontine = false;
        $user_unauthorized = false;

        //ici je contrôle si le user est admin dans la tontine
        $authorization = \DB::table('membrestontines')
            ->where('user_id','=',$sender_id)
            ->where('tontine_id','=',$tontine_id)
            ->where('administrator','=',1)
            ->first();

        if(empty($authorization)){
            $user_unauthorized = true;
            /*$result = array(
                'message' => 'error',
                'phone_already_exist' => $phone_already_exist,
                'email_already_exist' => $email_already_exist,
                'invitation_exist' => $invitation_already_send,
                'tontine_not_found' => $tontine_not_found,
                'user_exist_tontine' => $user_exist_tontine,
                'user_unauthorized' => $user_unauthorized
                //'user_temporaire' => $user,
                //'invitation' => $invitation,
                //'code' => $codecle
            );*/

            return response()->json([
                'message' => 'error',
                //'phone_already_exist' => $phone_already_exist,
                //'email_already_exist' => $email_already_exist,
                'invitation_exist' => $invitation_already_send,
                'tontine_not_found' => $tontine_not_found,
                'user_exist_tontine' => $user_exist_tontine,
                'user_unauthorized' => $user_unauthorized],400);
        }

        //ici je recherche si la tontine existe
        $tontine = \DB::table('tontines')
            ->where('id','=',$tontine_id)
            ->first();

        if(empty($tontine)){
            $tontine_not_found = true;
            /*$result = array(
                'message' => 'error',
                'phone_already_exist' => $phone_already_exist,
                'email_already_exist' => $email_already_exist,
                'invitation_exist' => $invitation_already_send,
                'tontine_not_found' => $tontine_not_found,
                'user_exist_tontine' => $user_exist_tontine,
                'user_unauthorized' => $user_unauthorized
                //'user_temporaire' => $user,
                //'invitation' => $invitation,
                //'code' => $codecle
            );*/

            return response()->json([
                'message' => 'error',
                //'phone_already_exist' => $phone_already_exist,
                //'email_already_exist' => $email_already_exist,
                'invitation_exist' => $invitation_already_send,
                'tontine_not_found' => $tontine_not_found,
                'user_exist_tontine' => $user_exist_tontine,
                'user_unauthorized' => $user_unauthorized],400);
        }

        $resultat = \DB::table('invitations')
            ->where('tontine_id','=',$tontine_id)
            ->first();

        if(!empty($resultat)){
            //je fais une copie dans la table invitations_history
            \DB::table('invitations_history')
                ->insert([
                    [
                        'sender_id' => $resultat->sender_id,
                        'receiver_id' => $resultat->receiver_id,
                        'tontine_id' => $resultat->tontine_id,
                        'codecle' => $resultat->codecle,
                        'etat' => $resultat->etat,
                        'administrator' => $resultat->administrator,
                        'statutcode' => $resultat->statutcode,
                        'created_at' => $resultat->created_at,
                        'updated_at' => Carbon::now()]
                ]);


            //puis je renvois les infos du user dont on veut supprimer ces informations
            $listes = \DB::table('invitations')
                ->join('users', 'users.id', '=', 'invitations.receiver_id')
                ->where('invitations.tontine_id', '=', $tontine_id)
                ->where('invitations.id', '=', $invitation_id)
                ->where('invitations.etat', '=', 'en attente')
                ->get();

            //puis je delete la ligne
            \DB::table('invitations')
                ->where('id','=',$invitation_id)
                ->where('etat','=','en attente')
                ->where('tontine_id','=',$tontine_id)
                ->delete();

            $liste = array();

            if (!empty($listes)) {
                foreach ($listes as $listUser) {
                    $id = $listUser->id;
                    $username = $listUser->username;
                    $firstname = $listUser->firstname;
                    $lastname = $listUser->lastname;
                    $phone = $listUser->phone;
                    $email = $listUser->email;
                    $sexe = $listUser->sexe;
                    $pays = $listUser->pays;
                    $ville = $listUser->ville;
                    $address = $listUser->address;
                    $picture = $listUser->picture;
                    $profession = $listUser->profession;
                    $experience = $listUser->experience;
                    $token = $listUser->remember_token;
                    $temporaire = $listUser->temporaire;

                    //$tmp ["id"] = $id;
                    $tmp ["username"] = $username;
                    $tmp ["firstname"] = $firstname;
                    $tmp ["lastname"] = $lastname;
                    $tmp ["phone"] = $phone;
                    $tmp ["email"] = $email;
                    $tmp ["sexe"] = $sexe;
                    $tmp ["pays"] = $pays;
                    $tmp ["ville"] = $ville;
                    $tmp ["address"] = $address;
                    $tmp ["picture"] = $picture;
                    $tmp ["profession"] = $profession;
                    $tmp ["experience"] = $experience;
                    $tmp ["remember_token"] = $token;
                    $tmp ["temporaire"] = $temporaire;

                    array_push($liste, $tmp);
                }
            }

            $invitation = \DB::table('invitations')
                ->where('id','=',$invitation_id)
                ->where('etat','=','en attente')
                ->where('tontine_id','=',$tontine_id)
                ->first();


            return response()->json(['message' => 'success', 'invitation' => $invitation, 'user_temporaire' => $liste]);
        }

        return response()->json(['message' => 'error'], 400);

    }


    //permet de réenvoyer les codes à un ou plusieurs membre(s) par mail ou téléphone pour joindre une tontine
    public function ResendCodeMembersTontine($invitation_id, $token){

        $receiver = \DB::table('invitations')
            ->where('id','=',$invitation_id)
            ->first();
        //dd($receiver);

        $test = \DB::table('users')
            ->where('id','=',$receiver->receiver_id)
            ->first();
        //dd($test->email);

        $user = \DB::table('users')
            ->where('remember_token','=',$token)
            ->first();

        $tontine = \DB::table('tontines')
            ->where('id','=',$receiver->tontine_id)
            ->first();

        $administrator = \DB::table('membrestontines')
            ->where('user_id','=',$user->id)
            ->where('tontine_id','=',$receiver->tontine_id)
            ->where('administrator','=',1)
            ->first();

        if(empty($tontine)){
            return response()->json(['message' => 'error', 'tontine_not_found' => true, 'user_unauthorized' => false]);

        }

        if(empty($administrator)){
            return response()->json(['message' => 'error', 'tontine_not_found' => false, 'user_unauthorized' => true]);

        }

        $username = $test->username;
        $phone = $test->phone;
        $email = $test->email;
        //$administrator = $test->administrator;

        $codecle = str_random(6);
        $etat = "en attente";

        //$code[$i] = $codecle;

        //je récupère aussi l'id du user qui a créé la tontine dans la table tontines
        $sender = \DB::table('tontines')
            ->where('id','=',$receiver->tontine_id)
            ->first();

        //ici je me rassure si l'invitation a déjà été envoyée au user. Si c'est le cas je mets juste à jour son codecle
        $recherche_invitation = \DB::table('invitations')
            //->where('sender_id','=',$sender_id/*$sender->user_id*/)
            ->where('receiver_id','=',$receiver->receiver_id)
            ->where('tontine_id','=',$receiver->tontine_id)
            ->where('etat','=','en attente')
            ->first();
        //dd($recherche_invitation);

        if(!empty($recherche_invitation)){  //cas où l'invitation a déjà été envoyée
            //je remets son codecle
            //$code[$i] = $recherche_invitation->codecle;

           // $codecle = $recherche_invitation->codecle;

            //$invitation_resend[$i] = true;

            //je mets à jour son nouveau code dans invitation
            \DB::table('invitations')
                ->where('id', '=', $recherche_invitation->id)
                ->update([
                    'codecle' => $codecle,
                    'statutvalidite' => 'valid',
                    'updated_at' => Carbon::now()
                ]);


            //**************** Partie pour l'envoi du codecle par mail au user /
            $nom_tontine = $sender->name;
            if($email != NULL){ //alors on envoit le mail. Dans le cas contraire on considère qu'il n'a pas d'email

                //$message = " Cher utilisateur,  \r\n \r\n voici le code à utiliser pour pouvoir joindre la tontine ".$nom_tontine;

                $message = " Cher utilisateur,  \r\n \r\n vous venez de recevoir une invitation pour pouvoir joindre la tontine ".$nom_tontine ." avec les éléments suivants :";

                //$message = $message . "\r\n \r\n \r\n Note:Veuillez rafraichir votre page de vote Merci." ;
                $subject = 'Joindre une tontine';


                //if (filter_var($data->email_or_phone, FILTER_VALIDATE_EMAIL)) {
                $data1 = [
                    'from' => 'toupesu@dev.sdkgames.com',
                    'from_name' => 'Toupesu',
                    'to' => $email,
                    'subject' => $subject,
                    'title' => $message,
                    'code' => '  Code : ' . $codecle,
                    //'email' => '  Email : ' . $value->email,
                    //'password' => $password,
                    // 'download' => '  Download the application with the following link to connect ....' .
                    //   ' Well after you can change your password. Thanks you',
                    'link' => 'Vous pouvez cliquer sur le lien suivant pour joindre la tontine et entrer votre code',
                    'code' => $codecle,
                    'tontine_name' => $nom_tontine,
                    'tontine_slogan' => $sender->slogan,
                    'cercle' => $sender->cercle
                ];

//                Mail::send('tontine.invitation_confirm', $data1, function ($message) use ($data1) {
//                    $message->from($data1['from'], $data1['from_name']);
//                    $message->to($data1['to'])->subject($data1['subject']);
//                });
                // }

                $beautymail = app()->make(Beautymail::class);
                $beautymail->send('tontine.welcome', $data1, function($message) use ($data1)
                {
                    //$email = $test->email_or_phone;
                    $message->from($data1['from'],$data1['from_name']);
                    $message->to($data1['to'])->subject($data1['subject']);
                });


            }

            //**************************** end mail ***************************************************


            /************** Partie pour l'envoi du codecle par phone au user ***********************/



            /************************** end phone **************************************************/

            return response()->json(['message' => 'success']);

        }





        return response()->json(['message' => 'error'], 400);

    }


    //permet d'update l'invitation d'un user
    public function updateInvitation($token){
        $request = Request::instance();
        $data = json_decode($request->getContent());

        $invitation_id = $data->invitation_id;
        $tontine_id = $data->tontine_id;
        $listeMembres = $data->members;

        $codecle = str_random(6);

        $sender = \DB::table('users')
            ->where('remember_token','=',$token)
            ->first();

        $sender_id = $sender->id;

        $phone_already_exist = false;
        $email_already_exist = false;
        $invitation_already_send = false;
        $tontine_not_found = false;
        $user_exist_tontine = false;
        $user_unauthorized = false;

        //ici je contrôle si le user est admin dans la tontine
        $authorization = \DB::table('membrestontines')
            ->where('user_id','=',$sender_id)
            ->where('tontine_id','=',$tontine_id)
            ->where('administrator','=',1)
            ->first();

        if(empty($authorization)){
            $user_unauthorized = true;
            /*$result = array(
                'message' => 'error',
                'phone_already_exist' => $phone_already_exist,
                'email_already_exist' => $email_already_exist,
                'invitation_exist' => $invitation_already_send,
                'tontine_not_found' => $tontine_not_found,
                'user_exist_tontine' => $user_exist_tontine,
                'user_unauthorized' => $user_unauthorized
                //'user_temporaire' => $user,
                //'invitation' => $invitation,
                //'code' => $codecle
            );*/

            return response()->json([
                'message' => 'error',
                'phone_already_exist' => $phone_already_exist,
                'email_already_exist' => $email_already_exist,
                'invitation_exist' => $invitation_already_send,
                'tontine_not_found' => $tontine_not_found,
                'user_exist_tontine' => $user_exist_tontine,
                'user_unauthorized' => $user_unauthorized],400);
        }

        //ici je recherche si la tontine existe
        $tontine = \DB::table('tontines')
            ->where('id','=',$tontine_id)
            ->first();

        if(empty($tontine)){
            $tontine_not_found = true;
            /*$result = array(
                'message' => 'error',
                'phone_already_exist' => $phone_already_exist,
                'email_already_exist' => $email_already_exist,
                'invitation_exist' => $invitation_already_send,
                'tontine_not_found' => $tontine_not_found,
                'user_exist_tontine' => $user_exist_tontine,
                'user_unauthorized' => $user_unauthorized
                //'user_temporaire' => $user,
                //'invitation' => $invitation,
                //'code' => $codecle
            );*/

            return response()->json([
                'message' => 'error',
                'phone_already_exist' => $phone_already_exist,
                'email_already_exist' => $email_already_exist,
                'invitation_exist' => $invitation_already_send,
                'tontine_not_found' => $tontine_not_found,
                'user_exist_tontine' => $user_exist_tontine,
                'user_unauthorized' => $user_unauthorized],400);
        }



        if(sizeof($listeMembres)!= 0){
            for ($i = 0; $i < sizeof($listeMembres); $i++) {
                $test = $listeMembres[$i];

                //$phone = $test->phone;
                //$email = $test->email;
                $administrator = $listeMembres[$i]->administrator;

                $index = filter_var($test->email_or_phone, FILTER_VALIDATE_EMAIL) ? 'email' : 'phone';

                if($index == "phone"){
                    $numero = \DB::table('users')
                        ->where('phone', '=', $test->email_or_phone)
                        ->first();
                }

                if($index == "email"){
                    $numero = \DB::table('users')
                        ->where('email', '=', $test->email_or_phone)
                        ->first();
                }


                if(!empty($numero)){
                    //je recherche si le user existe déjà dans la table membrestontines
                    $response = \DB::table('membrestontines')
                        ->where('tontine_id','=',$tontine_id)
                        ->where('user_id','=',$numero->id)
                        ->first();
                }else{
                    $response = NULL;
                }

                if(!empty($response)){
                    $user_exist_tontine = true;
                    return response()->json([
                        'message' => 'error',
                        'phone_already_exist' => $phone_already_exist,
                        'email_already_exist' => $email_already_exist,
                        'invitation_exist' => $invitation_already_send,
                        'tontine_not_found' => $tontine_not_found,
                        'user_exist_tontine' => $user_exist_tontine,
                        'user_unauthorized' => $user_unauthorized],400);
                }

                $resultat = \DB::table('invitations')
                    ->where('id', '=', $invitation_id)
                    ->where('etat', '=', 'en attente')
                    ->where('tontine_id', '=', $tontine_id)
                    ->first();

                if (!empty($resultat)) {

                    if(!empty($numero)){
                        $resultat_phone = \DB::table('users')
                            ->where('phone', '=', $numero->phone)
                            ->first();

                        $resultat_email = \DB::table('users')
                            ->where('email', '=', $numero->email)
                            ->first();


                        /*$resultat_username = \DB::table('users')
                        ->where('username', '=', $username)
                        ->first();*/

                        //ici je veux localiser les données de l'ancien user enregistré
                        $receiver = \DB::table('users')
                            ->where('id','=',$resultat->receiver_id)
                            ->first();
                        $statut_phone = 0;
                        if($index == "phone"){

                            if (!empty($resultat_phone)) {
                                if($resultat_phone->phone == $receiver->phone){
                                    //on ne fait rien
                                    //dd("phone");
                                }else{
                                    $phone_already_exist = true;
                                    $statut_phone = 0;

                                    $codecle = str_random(6);

                                    //if(!empty($user_new)){
                                    //j'update l'invitation en changeant le code
                                    \DB::table('invitations')
                                        ->where('id', '=', $invitation_id)
                                        ->where('etat', '=', 'en attente')
                                        ->where('tontine_id', '=', $tontine_id)
                                        ->update([
                                            'sender_id' => $sender_id,
                                            'receiver_id' => $resultat_phone->id/*$user_new->id*/,
                                            'codecle' => $codecle,
                                            'administrator' => $administrator,
                                            'statutvalidite' => 'valid',
                                            'updated_at' => Carbon::now()
                                        ]);

                                }
                            }

                        }

                        $statut_email = 0;
                        if($index == "email"){
                            //dd($receiver->email);


                            if (!empty($resultat_email)) {
                                if($resultat_email->email == $receiver->email){
                                    //on ne fait rien

                                }else{
                                    $email_already_exist = true;
                                    $statut_email = 0;

                                    $codecle = str_random(6);

                                    //dd($administrator);

                                    //if(!empty($user_new)){
                                    //j'update l'invitation en changeant le code
                                    \DB::table('invitations')
                                        ->where('id', '=', $invitation_id)
                                        ->where('etat', '=', 'en attente')
                                        ->where('tontine_id', '=', $tontine_id)
                                        ->update([
                                            'sender_id' => $sender_id,
                                            'receiver_id' => $resultat_email->id/*$user_new->id*/,
                                            'codecle' => $codecle,
                                            'administrator' => $administrator,
                                            'statutvalidite' => 'valid',
                                            'updated_at' => Carbon::now()
                                        ]);

                                }
                            }
                        }






                        /*if ((!empty($resultat_phone) AND $statut_phone == 1) || (!empty($resultat_email) AND $statut_email == 1)) {

                            return response()->json([
                                'message' => 'error',
                                'phone_already_exist' => $phone_already_exist,
                                'email_already_exist' => $email_already_exist,
                                'invitation_exist' => $invitation_already_send,
                                'tontine_not_found' => $tontine_not_found,
                                'user_exist_tontine' => $user_exist_tontine,
                                'user_unauthorized' => $user_unauthorized],400);
                        }*/

                        //je dois faire le travail pour le user du système en recréant un autre compte pour les nouvelles infos
                        if(!empty($receiver)){
                            //je teste si c'est un user pas temporaire = 0
                            if($receiver->temporaire == 0){
                                //je récréé un nouveau compte user_temporaire
                               /* \DB::table('users')
                                    ->insert([
                                        [
                                            //'lastname' => $username,
                                            'phone' => $numero->phone,
                                            'email' => $numero->email,
                                            'temporaire' => 1,
                                            'confirmed' => false,
                                            'role_id' => 3,
                                            'badge_id' => 1,
                                            'created_at' => Carbon::now(),
                                            'updated_at' => Carbon::now()]
                                    ]);

                                //puis je récupère le user
                                $user_new = \DB::table('users')
                                    ->where('phone','=',$numero->phone)
                                    ->where('email','=',$numero->email)
                                    ->where('temporaire','=',1)
                                    ->first();

                                */

                                $codecle = str_random(6);

                                //if(!empty($user_new)){
                                    //j'update l'invitation en changeant le code
                                    \DB::table('invitations')
                                        ->where('id', '=', $invitation_id)
                                        ->where('etat', '=', 'en attente')
                                        ->where('tontine_id', '=', $tontine_id)
                                        ->update([
                                            'sender_id' => $sender_id,
                                            'receiver_id' => $receiver->id/*$user_new->id*/,
                                            'codecle' => $codecle,
                                            'administrator' => $administrator,
                                            'statutvalidite' => 'valid',
                                            'updated_at' => Carbon::now()
                                        ]);
                                //}

                            }

                            if($receiver->temporaire = 1){
                                if($index == "phone"){
                                    //ici j'update les infos du user temporaire
                                    \DB::table('users')
                                        ->where('id', '=', $resultat_phone->id)
                                        ->where('temporaire', '=', 1)
                                        ->update([
                                            //'username' => $username,
                                            'phone' => $numero->phone,
                                            'email' => $numero->email,
                                            'updated_at' => Carbon::now()
                                        ]);

                                    $temporaire =  \DB::table('users')
                                        ->where('id', '=', $resultat_phone->id)
                                        ->where('temporaire', '=', 1)
                                        ->first();

                                }

                                if($index == "email"){
                                    //ici j'update les infos du user temporaire
                                    \DB::table('users')
                                        ->where('id', '=', $resultat_email->id)
                                        ->where('temporaire', '=', 1)
                                        ->update([
                                            //'username' => $username,
                                            'phone' => $numero->phone,
                                            'email' => $numero->email,
                                            'updated_at' => Carbon::now()
                                        ]);

                                    $temporaire =  \DB::table('users')
                                        ->where('id', '=', $resultat_email->id)
                                        ->where('temporaire', '=', 1)
                                        ->first();

                                }



                                $codecle = str_random(6);

                                //dd($temporaire);

                                if(!empty($temporaire)) {
                                    //j'update l'invitation en changeant le code
                                    \DB::table('invitations')
                                        ->where('id', '=', $invitation_id)
                                        ->where('etat', '=', 'en attente')
                                        ->where('tontine_id', '=', $tontine_id)
                                        ->update([
                                            'sender_id' => $sender_id,
                                            'receiver_id' => $temporaire->id/*$user_new->id*/,
                                            'codecle' => $codecle,
                                            'administrator' => $administrator,
                                            'statutvalidite' => 'valid',
                                            'updated_at' => Carbon::now()
                                        ]);
                                }


                            }




                        }






                        $invitation = \DB::table('invitations')
                            ->where('tontine_id', '=', $tontine_id)
                            ->where('id', '=', $invitation_id)
                            ->where('etat', '=', 'en attente')
                            ->first();

                        //puis je renvois les infos du user dont on a update ces infos
                        $listes = \DB::table('invitations')
                            ->join('users', 'users.id', '=', 'invitations.receiver_id')
                            ->where('invitations.tontine_id', '=', $tontine_id)
                            ->where('invitations.id', '=', $invitation_id)
                            ->where('invitations.etat', '=', 'en attente')
                            ->select('users.id','users.username','users.firstname','users.lastname','users.phone','users.email',
                                'users.sexe','users.pays','users.ville','users.address','users.picture','users.profession',
                                'users.experience','users.remember_token','users.temporaire','invitations.id as invitation_id','invitations.administrator')
                            ->get();

                        $liste = array();

                        if (!empty($listes)) {
                            foreach ($listes as $listUser) {
                                $id = $listUser->id;
                                $username = $listUser->username;
                                $firstname = $listUser->firstname;
                                $lastname = $listUser->lastname;
                                $phone = $listUser->phone;
                                $email = $listUser->email;
                                $sexe = $listUser->sexe;
                                $pays = $listUser->pays;
                                $ville = $listUser->ville;
                                $address = $listUser->address;
                                $picture = $listUser->picture;
                                $profession = $listUser->profession;
                                $experience = $listUser->experience;
                                $token = $listUser->remember_token;
                                $temporaire = $listUser->temporaire;
                                $administrator = $listUser->administrator;
                                $invitation_id = $listUser->invitation_id;

                                //$tmp ["id"] = $id;
                                $tmp ["username"] = $username;
                                $tmp ["firstname"] = $firstname;
                                $tmp ["lastname"] = $lastname;
                                $tmp ["phone"] = $phone;
                                $tmp ["email"] = $email;
                                $tmp ["sexe"] = $sexe;
                                $tmp ["pays"] = $pays;
                                $tmp ["ville"] = $ville;
                                $tmp ["address"] = $address;
                                $tmp ["picture"] = $picture;
                                $tmp ["profession"] = $profession;
                                $tmp ["experience"] = $experience;
                                $tmp ["remember_token"] = $token;
                                $tmp ["temporaire"] = $temporaire;
                                $tmp ["administrator"] = $administrator;
                                $tmp ["invitation_id"] = $invitation_id;

                                array_push($liste, $tmp);
                            }
                        }

                    }

                    if(empty($numero)){ //c'est pour dire que les infos entrées ne correspondent à aucun user du système et temporaire et donc on va créer un nouveau user temporaire
                        $recherche_user = \DB::table('invitations')
                            ->where('id', '=', $invitation_id)
                            ->where('etat', '=', 'en attente')
                            ->where('tontine_id', '=', $tontine_id)
                            ->first();


                        if($index == "phone"){
                            //ici j'update les infos du user temporaire
                            \DB::table('users')
                                ->where('id', '=', $recherche_user->receiver_id)
                                ->where('temporaire', '=', 1)
                                ->update([
                                    //'username' => $username,
                                    'phone' => $test->email_or_phone,
                                    'email' => NULL,
                                    'updated_at' => Carbon::now()
                                ]);

                            //on contrôle d'abord si le user existe
                            $test_user_existe = \DB::table('users')
                                ->where('id', '=', $recherche_user->receiver_id)
                                ->where('temporaire','=',1)
                                ->first();

                            if(empty($test_user_existe)){

                                //je dois créer le compte du user temporaire
                                \DB::table('users')
                                    ->insert([
                                        [
                                            //'lastname' => $username,
                                            'phone' => $test->email_or_phone,
                                            'email' => NULL,
                                            'temporaire' => 1,
                                            'confirmed' => false,
                                            'role_id' => 3,
                                            'badge_id' => 1,
                                            'created_at' => Carbon::now(),
                                            'updated_at' => Carbon::now()]
                                    ]);

                                //puis je récupère le user
                                $user_new = \DB::table('users')
                                    ->where('phone','=',$test->email_or_phone)
                                    //->where('email','=',$numero->email)
                                    ->where('temporaire','=',1)
                                    ->first();

                                $codecle = str_random(6);

                                if(!empty($user_new)){
                                    //j'update l'invitation en changeant le code
                                    \DB::table('invitations')
                                        ->where('id', '=', $invitation_id)
                                        ->where('etat', '=', 'en attente')
                                        ->where('tontine_id', '=', $tontine_id)
                                        ->update([
                                            'sender_id' => $sender_id,
                                            'receiver_id' => $user_new->id,
                                            'codecle' => $codecle,
                                            'administrator' => $administrator,
                                            'statutvalidite' => 'valid',
                                            'updated_at' => Carbon::now()
                                        ]);
                                }


                            }
                            else{
                                //j'update l'invitation en changeant le code
                                \DB::table('invitations')
                                    ->where('id', '=', $invitation_id)
                                    ->where('etat', '=', 'en attente')
                                    ->where('tontine_id', '=', $tontine_id)
                                    ->update([
                                        'sender_id' => $sender_id,
                                        'receiver_id' => $recherche_user->receiver_id,
                                        'codecle' => $codecle,
                                        'administrator' => $administrator,
                                        'statutvalidite' => 'valid',
                                        'updated_at' => Carbon::now()
                                    ]);
                            }



                        }

                        if($index == "email"){
                            //ici j'update les infos du user temporaire
                            \DB::table('users')
                                ->where('id', '=', $recherche_user->receiver_id)
                                ->where('temporaire', '=', 1)
                                ->update([
                                    //'username' => $username,
                                    'phone' => NULL,
                                    'email' => $test->email_or_phone,
                                    'updated_at' => Carbon::now()
                                ]);


                            //on contrôle d'abord si le user existe
                            $test_user_existe = \DB::table('users')
                                ->where('id', '=', $recherche_user->receiver_id)
                                ->where('temporaire','=',1)
                                ->first();

                            if(empty($test_user_existe)){

                                //je dois créer le compte du user temporaire
                                \DB::table('users')
                                    ->insert([
                                        [
                                            //'lastname' => $username,
                                            'phone' => NULL,
                                            'email' => $test->email_or_phone,
                                            'temporaire' => 1,
                                            'confirmed' => false,
                                            'role_id' => 3,
                                            'badge_id' => 1,
                                            'created_at' => Carbon::now(),
                                            'updated_at' => Carbon::now()]
                                    ]);

                                //puis je récupère le user
                                $user_new = \DB::table('users')
                                    //->where('phone','=',$numero->phone)
                                    ->where('email','=',$test->email_or_phone)
                                    ->where('temporaire','=',1)
                                    ->first();

                                $codecle = str_random(6);

                                if(!empty($user_new)){
                                    //j'update l'invitation en changeant le code
                                    \DB::table('invitations')
                                        ->where('id', '=', $invitation_id)
                                        ->where('etat', '=', 'en attente')
                                        ->where('tontine_id', '=', $tontine_id)
                                        ->update([
                                            'sender_id' => $sender_id,
                                            'receiver_id' => $user_new->id,
                                            'codecle' => $codecle,
                                            'administrator' => $administrator,
                                            'statutvalidite' => 'valid',
                                            'updated_at' => Carbon::now()
                                        ]);
                                }


                            }
                            else{
                                //j'update l'invitation en changeant le code
                                \DB::table('invitations')
                                    ->where('id', '=', $invitation_id)
                                    ->where('etat', '=', 'en attente')
                                    ->where('tontine_id', '=', $tontine_id)
                                    ->update([
                                        'sender_id' => $sender_id,
                                        'receiver_id' => $recherche_user->receiver_id,
                                        'codecle' => $codecle,
                                        'administrator' => $administrator,
                                        'statutvalidite' => 'valid',
                                        'updated_at' => Carbon::now()
                                    ]);
                            }



                        }

                        /*

                        //j'update aussi la table invitations
                        \DB::table('invitations')
                            ->where('id', '=', $invitation_id)
                            ->where('etat', '=', 'en attente')
                            ->where('tontine_id', '=', $tontine_id)
                            ->update([
                                'codecle' => $codecle,
                                'administrator' => $administrator,
                                'updated_at' => Carbon::now()
                            ]);

                        */

                        $invitation = \DB::table('invitations')
                            ->where('tontine_id', '=', $tontine_id)
                            ->where('id', '=', $invitation_id)
                            ->where('etat', '=', 'en attente')
                            ->first();

                        //puis je renvois les infos du user dont on a update ces infos
                        $listes = \DB::table('invitations')
                            ->join('users', 'users.id', '=', 'invitations.receiver_id')
                            ->where('invitations.tontine_id', '=', $tontine_id)
                            ->where('invitations.id', '=', $invitation_id)
                            ->where('invitations.etat', '=', 'en attente')
                            ->select('users.id','users.username','users.firstname','users.lastname','users.phone','users.email',
                                'users.sexe','users.pays','users.ville','users.address','users.picture','users.profession',
                                'users.experience','users.remember_token','users.temporaire','invitations.id as invitation_id','invitations.administrator')
                            ->get();

                        $liste = array();

                        if (!empty($listes)) {
                            foreach ($listes as $listUser) {
                                $id = $listUser->id;
                                $username = $listUser->username;
                                $firstname = $listUser->firstname;
                                $lastname = $listUser->lastname;
                                $phone = $listUser->phone;
                                $email = $listUser->email;
                                $sexe = $listUser->sexe;
                                $pays = $listUser->pays;
                                $ville = $listUser->ville;
                                $address = $listUser->address;
                                $picture = $listUser->picture;
                                $profession = $listUser->profession;
                                $experience = $listUser->experience;
                                $token = $listUser->remember_token;
                                $temporaire = $listUser->temporaire;
                                $administrator = $listUser->administrator;
                                $invitation_id = $listUser->invitation_id;

                                //$tmp ["id"] = $id;
                                $tmp ["username"] = $username;
                                $tmp ["firstname"] = $firstname;
                                $tmp ["lastname"] = $lastname;
                                $tmp ["phone"] = $phone;
                                $tmp ["email"] = $email;
                                $tmp ["sexe"] = $sexe;
                                $tmp ["pays"] = $pays;
                                $tmp ["ville"] = $ville;
                                $tmp ["address"] = $address;
                                $tmp ["picture"] = $picture;
                                $tmp ["profession"] = $profession;
                                $tmp ["experience"] = $experience;
                                $tmp ["remember_token"] = $token;
                                $tmp ["temporaire"] = $temporaire;
                                $tmp ["administrator"] = $administrator;
                                $tmp ["invitation_id"] = $invitation_id;

                                array_push($liste, $tmp);
                            }
                        }



                    }


                }
            }

            return response()->json(['message' => 'success', 'invitation' => $invitation, 'user_temporaire' => $liste]);
        }

        return response()->json(['message' => 'error'], 400);



    }


    //permet de renvoyer la liste des tontines auxquelles le user a été invité (invitations en attente)
    public function getAllTontineUserInvited($token){

        $user = \DB::table('users')
            ->where('remember_token','=',$token)
            ->first();

        if(!empty($user)){
            $user_id = $user->id;

            //je prends ds la table invitations les invitations du user en attente
            $liste_tontines = \DB::table('invitations')
                ->join('tontines', 'tontines.id', '=', 'invitations.tontine_id')
                ->where('invitations.etat','=','en attente')
                ->where('invitations.receiver_id','=',$user_id)
                ->where('invitations.statutvalidite','=','valid')
                ->select('invitations.id as invitation_id','invitations.administrator','invitations.codecle','invitations.statutvalidite','tontines.id as tontine_id','tontines.name','tontines.slogan','tontines.cercle','tontines.quality_id','tontines.country',
                    'tontines.confidentiality','tontines.drawingtype_id','tontines.periodicite','tontines.frequence','tontines.monnaie','tontines.statutinfogenerale','tontines.nombre_part_max_membre',
                    'tontines.nombre_part_max_tontine','tontines.coutshare','tontines.numberlot','tontines.miseaprixcaisse1','tontines.miseaprixcaisse2','tontines.typemiseaprixcaisse1','tontines.typemiseaprixcaisse2',
                    'tontines.ajout_part_membre_en_contribuant_seances_passees_et_restantes','tontines.ajout_part_membre_en_contribuant_seulement_seances_restantes',
                    'tontines.statutparametrecotisation','tontines.delairemboursementcaisse2','tontines.penalitesurleremboursement','tontines.penaliteretardsurlacontributionayantbouffe','tontines.penaliteretardsurlacontributionnayantpasbouffe',
                    'tontines.penaliteabsencesurlacontributionayantbouffe','tontines.penaliteabsencesurlacontributionnayantpasbouffe','tontines.dureesurleretard','tontines.typedelairemboursementcaisse2',
                    'tontines.typepenalitesurleremboursement','tontines.typepenaliteretardsurlacontributionayantbouffe','tontines.typepenaliteretardsurlacontributionnayantpasbouffe',
                    'tontines.typepenaliteabsencesurlacontributionayantbouffe','tontines.typepenaliteabsencesurlacontributionnayantpasbouffe','tontines.typedureesurleretard','tontines.statutpenalite',
                    'tontines.circle','tontines.date_debut','tontines.date_fin','tontines.time_debut','tontines.statutcycleetcotisation','tontines.upload','tontines.statutdocumentation','tontines.solde_en_caisse', 'tontines.statutgeneral',
                    'tontines.created_at','tontines.updated_at')
                ->get();





            $liste = array();

            if($liste_tontines != NULL){

                foreach ($liste_tontines as $listTontine){
                    $invitation_id = $listTontine->invitation_id;
                    $statutvalidite = $listTontine->statutvalidite;
                    $codecle = $listTontine->codecle;
                    $tontine_id = $listTontine->tontine_id;
                    $name = $listTontine->name;
                    $slogan = $listTontine->slogan;
                    $cercle = $listTontine->cercle;
                    $quality_id = $listTontine->quality_id;
                    $country = $listTontine->country;
                    $confidentiality = $listTontine->confidentiality;
                    $drawingtype_id = $listTontine->drawingtype_id;
                    $periodicite = $listTontine->periodicite;
                    $frequence = $listTontine->frequence;
                    $monnaie = $listTontine->monnaie;
                    $statutinfogenerale = $listTontine->statutinfogenerale;
                    $nombre_part_max_membre = $listTontine->nombre_part_max_membre;
                    $nombre_part_max_tontine = $listTontine->nombre_part_max_tontine;
                    $coutshare = $listTontine->coutshare;
                    $numberlot = $listTontine->numberlot;
                    $miseaprixcaisse1 = $listTontine->miseaprixcaisse1;
                    $miseaprixcaisse2 = $listTontine->miseaprixcaisse2;
                    $typemiseaprixcaisse1 = $listTontine->typemiseaprixcaisse1;
                    $typemiseaprixcaisse2 = $listTontine->typemiseaprixcaisse2;
                    $ajout_part_membre_en_contribuant_seances_passees_et_restantes = $listTontine->ajout_part_membre_en_contribuant_seances_passees_et_restantes;
                    $ajout_part_membre_en_contribuant_seulement_seances_restantes = $listTontine->ajout_part_membre_en_contribuant_seulement_seances_restantes;
                    $statutparametrecotisation = $listTontine->statutparametrecotisation;
                    $delairemboursementcaisse2 = $listTontine->delairemboursementcaisse2 ;
                    $penalitesurleremboursement = $listTontine->penalitesurleremboursement;
                    $penaliteretardsurlacontributionayantbouffe = $listTontine->penaliteretardsurlacontributionayantbouffe;
                    $penaliteretardsurlacontributionnayantpasbouffe = $listTontine->penaliteretardsurlacontributionnayantpasbouffe;
                    $penaliteabsencesurlacontributionayantbouffe = $listTontine->penaliteabsencesurlacontributionayantbouffe;
                    $penaliteabsencesurlacontributionnayantpasbouffe = $listTontine->penaliteabsencesurlacontributionnayantpasbouffe;
                    $dureesurleretard = $listTontine->dureesurleretard;
                    $typedelairemboursementcaisse2 = $listTontine->typedelairemboursementcaisse2;
                    $typepenalitesurleremboursement = $listTontine->typepenalitesurleremboursement;
                    $typepenaliteretardsurlacontributionayantbouffe = $listTontine->typepenaliteretardsurlacontributionayantbouffe;
                    $typepenaliteretardsurlacontributionnayantpasbouffe = $listTontine->typepenaliteretardsurlacontributionnayantpasbouffe;
                    $typepenaliteabsencesurlacontributionayantbouffe = $listTontine->typepenaliteabsencesurlacontributionayantbouffe;
                    $typepenaliteabsencesurlacontributionnayantpasbouffe = $listTontine->typepenaliteabsencesurlacontributionnayantpasbouffe;
                    $typedureesurleretard = $listTontine->typedureesurleretard;
                    $statutpenalite = $listTontine->statutpenalite;
                    $circle = $listTontine->circle;
                    $date_debut = $listTontine->date_debut;
                    $date_fin = $listTontine->date_fin;
                    $time_debut = $listTontine->time_debut;
                    $statutcycleetcotisation = $listTontine->statutcycleetcotisation;
                    $upload = $listTontine->upload;
                    $statutdocumentation = $listTontine->statutdocumentation;
                    $solde_en_caisse = $listTontine->solde_en_caisse;
                    $statutgeneral = $listTontine->statutgeneral;
                    $administrator = $listTontine->administrator;
                    $created_at = $listTontine->created_at;
                    $updated_at = $listTontine->updated_at;

                    $quality = \DB::table('qualities')
                        ->where('id','=',$quality_id)
                        ->first();

                    $drawingtype = \DB::table('drawingtypes')
                        ->where('id','=',$drawingtype_id)
                        ->first();

                    $tmp ["invitation_id"] = $invitation_id;
                    $tmp ["statutvalidite"] = $statutvalidite;
                    $tmp ["codecle"] = $codecle;
                    $tmp ["tontine_id"] = $tontine_id;
                    $tmp ["administrator"] = $administrator;
                    $tmp ["name"] = $name;
                    $tmp ["slogan"] = $slogan;
                    $tmp ["cercle"] = $cercle;
                    $tmp ["quality_id"] = $quality_id;
                    $tmp ["quality_name"] = $quality->name;
                    $tmp ["country"] = $country;
                    $tmp ["confidentiality"] = $confidentiality;
                    $tmp ["drawingtype_id"] = $drawingtype_id;
                    $tmp ["drawingtype_name"] = $drawingtype->name;
                    $tmp ["periodicite"] = $periodicite;
                    $tmp ["frequence"] = $frequence;
                    $tmp ["monnaie"] = $monnaie;
                    $tmp ["statutinfogenerale"] = $statutinfogenerale;
                    $tmp ["nombre_part_max_membre"] = $nombre_part_max_membre;
                    $tmp ["nombre_part_max_tontine"] = $nombre_part_max_tontine;
                    $tmp ["coutshare"] = $coutshare;
                    $tmp ["numberlot"] = $numberlot;
                    $tmp ["miseaprixcaisse1"] = $miseaprixcaisse1;
                    $tmp ["miseaprixcaisse2"] = $miseaprixcaisse2;
                    $tmp ["typemiseaprixcaisse1"] = $typemiseaprixcaisse1;
                    $tmp ["typemiseaprixcaisse2"] = $typemiseaprixcaisse2;
                    $tmp ["ajout_part_membre_en_contribuant_seances_passees_et_restantes"] = $ajout_part_membre_en_contribuant_seances_passees_et_restantes;
                    $tmp ["ajout_part_membre_en_contribuant_seulement_seances_restantes"] = $ajout_part_membre_en_contribuant_seulement_seances_restantes;
                    $tmp ["statutparametrecotisation"] = $statutparametrecotisation;
                    $tmp ["delairemboursementcaisse2"] = $delairemboursementcaisse2;
                    $tmp ["penalitesurleremboursement"] = $penalitesurleremboursement;
                    $tmp ["penaliteretardsurlacontributionayantbouffe"] = $penaliteretardsurlacontributionayantbouffe;
                    $tmp ["penaliteretardsurlacontributionnayantpasbouffe"] = $penaliteretardsurlacontributionnayantpasbouffe;
                    $tmp ["penaliteabsencesurlacontributionayantbouffe"] = $penaliteabsencesurlacontributionayantbouffe;
                    $tmp ["penaliteabsencesurlacontributionnayantpasbouffe"] = $penaliteabsencesurlacontributionnayantpasbouffe;
                    $tmp ["dureesurleretard"] = $dureesurleretard;
                    $tmp ["typedelairemboursementcaisse2"] = $typedelairemboursementcaisse2;
                    $tmp ["typedelairemboursementcaisse2"] = $typedelairemboursementcaisse2;
                    $tmp ["typepenalitesurleremboursement"] = $typepenalitesurleremboursement;
                    $tmp ["typepenaliteretardsurlacontributionayantbouffe"] = $typepenaliteretardsurlacontributionayantbouffe;
                    $tmp ["typepenaliteretardsurlacontributionnayantpasbouffe"] = $typepenaliteretardsurlacontributionnayantpasbouffe;
                    $tmp ["typepenaliteabsencesurlacontributionayantbouffe"] = $typepenaliteabsencesurlacontributionayantbouffe;
                    $tmp ["typepenaliteabsencesurlacontributionnayantpasbouffe"] = $typepenaliteabsencesurlacontributionnayantpasbouffe;
                    $tmp ["typedureesurleretard"] = $typedureesurleretard;
                    $tmp ["statutpenalite"] = $statutpenalite;
                    $tmp ["circle"] = $circle;
                    $tmp ["date_debut"] = $date_debut;
                    $tmp ["date_fin"] = $date_fin;
                    $tmp ["time_debut"] = $time_debut;
                    $tmp ["statutcycleetcotisation"] = $statutcycleetcotisation;
                    $tmp ["upload"] = $upload;
                    $tmp ["statutdocumentation"] = $statutdocumentation;
                    $tmp ["solde_en_caisse"] = $solde_en_caisse;
                    $tmp ["statutgeneral"] = $statutgeneral;
                    $tmp ["created_at"] = $created_at;
                    $tmp ["updated_at"] = $updated_at;

                    array_push($liste,$tmp ) ;
                }

            }

            return response()->json(['liste_tontines' => $liste]);

        }
        else{
            return response()->json(['message' => 'error','user_not_found' => true], 400);
        }

    }



    /******************************** START fonctions réutilisables Christopher *******************************************************************/


    //permet de renvoyer la séance courante d'une tontinte
    public function getSeanceCouranteId($tontine_id){

        $seance = \DB::table('seances')
            ->where('tontine_id','=',$tontine_id)
            ->where('archived','=',0)
            ->first();

        if(!empty($seance)){
            return $seance->id;
        }
        else{
            return 0;
        }
    }

    //permet de renvoyer le cycle courant d'une tontinte
    public function getCycleCourantId($tontine_id){

        $cycle = \DB::table('cycles')
            ->where('tontine_id','=',$tontine_id)
            ->where('archived','=',0)
            ->first();

        if(!empty($cycle)){
            return $cycle->id;
        }
        else{
            return 0;
        }
    }


    /******************************** END fonctions réutilisables Christopher *******************************************************************/







}