<?php

namespace App\Http\Controllers;

//use Illuminate\Http\Request;

use GuzzleHttp\Client;
use Dompdf\FrameDecorator\NullFrameDecorator;
use Input;
use Response;
use Request;
use Illuminate\Support\Facades\Auth;
use JWTAuth;
use Tymon\JWTAuth\Exceptions\JWTException;
use DB;
use Carbon\Carbon;
use Mail;
use PushNotification;
use Facebook;
use Facebook\Helpers\FacebookRedirectLoginHelper;
use Facebook\FacebookSDKException;
use Facebook\Authentication\OAuth2Client;
use Snowfire\Beautymail\Beautymail;


use Codebird\Codebird;


//use Illuminate\Http\Request;

use App\Http\Requests;


use Session;


use JWTAuthException;

use Illuminate\Support\Facades\Redis;
use DateTime;

use Notifiable;

use Berkayk\OneSignal\OneSignalFacade;

use Spatie\PdfToText\Pdf;



class ONGAssociationController extends Controller
{

    //permet de save une ONG ou une association
    public function postONGAssociation($token){
        $request = Request::instance();
        $data = json_decode($request->getContent());

        //je vérifie le token
        $check = \DB::table('users')
            ->where('remember_token','=',$token)
            ->first();

            //dd($check);

        if(empty($check)){
            return response()->json(['user_not_found' => true], 401);
        }    

        $user_id = $check->id;



        $liste_files = $data->liste_files;        //contient le tableau JSON des documents du cabinet. Format liste_files = [{"file":"string"},{"file":"string"},{...}]
        $statut_id = $data->statut_id;
        $disponibilite_id = $data->disponibilite_id;
        $recommandation_id = $data->recommandation_id;
        $recommandation_name = $data->recommandation_name;
        $nom = $data->nom;
        $sigle = $data->sigle;
        $forme_juridique_id = $data->forme_juridique_id;
        $annee_creation = $data->annee_creation;        //format aaaa
        $registre_commerce = $data->registre_commerce;
        $siege_social = $data->siege_social;
        $liste_profil = $data->liste_profil;        //contient le tableau JSON des profils du cabinet. Format liste_profile = [{"profil_id":value},{"profil_id":value},{...}]
        $date1ereAnneeExperienceEnTantQueONG = $data->date1ereAnneeExperienceEnTantONG;      //format aaaa-mm-jj
        $liste_experience_geographique = $data->liste_experience_geographique;      //contient le tableau JSON d'expériences géographique du cabinet. Format liste_experience_geographique = [{"experience_geographique_id":value},{"experience_geographique_id":value},{...}]
        $experienceAvecCooperationAllemande = $data->experienceAvecCooperationAllemande;    // 0 pour non et 1 pour oui
        $experienceAvecLesNationsUnies = $data->experienceAvecLesNationsUnies;          //0 pour non et 1 pour oui
        $experienceAvecLesAutresPartenaires = $data->experienceAvecLesAutresPartenaires;          //0 pour non et 1 pour oui
        $liste_domaine_expertise = $data->liste_domaine_expertise;      //contient le tableau JSON des domaines d'expertise du cabinet. Format liste_domaine_expertise = [{"domaine_id":value, "nbre_consultation":value},{"domaine_id":value, "nbre_consultation":value},{...}]
        $adresse = $data->adresse;
        $liste_telephone = $data->liste_telephone;      //contient le tableau JSON des téléphones du cabinet. Format liste_telephone = [{"telephone":value},{"telephone":value},{...}]
        $liste_courriel = $data->liste_courriel;        //contient le tableau JSON des emails du cabinet. Format liste_courriel = [{"email":value},{"email":value},{...}]
        $nom_principal_dirigeant = $data->nom_principal_dirigeant;
        $prenom_principal_dirigeant = $data->prenom_principal_dirigeant;
        $telephone_principal_dirigeant = $data->telephone_principal_dirigeant;
        $courriel_principal_dirigeant = $data->courriel_principal_dirigeant;

        $type = "ong_association";    //type = consultant ou cabinet_bureau_etude ou ong_association

        $created_at = Carbon::now();
        $updated_at = Carbon::now();

        //if((sizeof($liste_files) == 0) || $statut_id == NULL || $disponibilite_id == NULL || $recommandation_id == NULL || $nom == NULL
        //    || $sigle == NULL || $forme_juridique_id == NULL || $annee_creation == NULL || $registre_commerce == NULL || $siege_social == NULL
        //    || (sizeof($liste_profil) == 0) /*|| $date1ereAnneeExperienceEnTantQueONG == NULL*/ || (sizeof($liste_experience_geographique) == 0)
        //    || /*(sizeof($liste_domaine_expertise) == 0) ||*/ $adresse == NULL || (sizeof($liste_telephone) == 0) || (sizeof($liste_courriel) == 0)
        //    || $nom_principal_dirigeant == NULL || $prenom_principal_dirigeant == NULL || $telephone_principal_dirigeant == NULL
        //    || $courriel_principal_dirigeant == NULL){

        //    return response()->json(['message' => 'error', 'remplir_tous_les_champs' => true, 'statut_id_not_exist' => false, 'disponibilite_id_not_exist' => false,
        //        'recommandation_id_not_exist' => false, 'forme_juridique_id_not_exist' => false, 'profil_id_not_exist' => false,
        //        'experience_geographique_id_not_exist' => false, 'domaine_id_not_exist' => false], 400);

        //}

        //on vérifie si le statut_id existe dans la table statut
        if($statut_id != NULL){
            $check = \DB::table('statut')
                ->where('id','=',$statut_id)
                ->first();

            if(empty($check)){
                return response()->json(['message' => 'error', 'remplir_tous_les_champs' => false, 'statut_id_not_exist' => true, 'disponibilite_id_not_exist' => false,
                    'recommandation_id_not_exist' => false, 'forme_juridique_id_not_exist' => false, 'profil_id_not_exist' => false,
                    'experience_geographique_id_not_exist' => false, 'domaine_id_not_exist' => false], 400);
            }
        }

        //on vérifie si disponibilite_id existe dans la table disponibilite
        if($disponibilite_id != NULL){
            $check = \DB::table('disponibilite')
                ->where('id','=',$disponibilite_id)
                ->first();

            if(empty($check)){
                return response()->json(['message' => 'error', 'remplir_tous_les_champs' => false, 'statut_id_not_exist' => false, 'disponibilite_id_not_exist' => true,
                    'recommandation_id_not_exist' => false, 'forme_juridique_id_not_exist' => false, 'profil_id_not_exist' => false,
                    'experience_geographique_id_not_exist' => false, 'domaine_id_not_exist' => false], 400);
            }
        }

        
        //on vérifie si recommandation_id existe dans la table recommandation
        $check = \DB::table('recommandation')
            ->where('id','=',$recommandation_id)
            ->first();

        if(empty($check)){
            /*return response()->json(['message' => 'error', 'remplir_tous_les_champs' => false, 'statut_id_not_exist' => false, 'disponibilite_id_not_exist' => false,
                                       'recommandation_id_not_exist' => true, 'forme_juridique_id_not_exist' => false, 'profil_id_not_exist' => false,
                                       'experience_geographique_id_not_exist' => false, 'domaine_id_not_exist' => false], 400);*/
            
            //I check if recommandation_name already exist
            $check_recommandation = \DB::table('recommandation')
                ->where('intitule','=',$recommandation_name)
                ->first();

            if(empty($check_recommandation)){
                \DB::table('recommandation')
                    ->insert([
                        [
                            'intitule' => $recommandation_name,
                            'description' => $recommandation_name,
                            'created_at' => Carbon::now(),
                            'updated_at' => Carbon::now()
                        ]
                    ]);

                $recommandation_id = DB::getPdo()->lastInsertId();
                
            }
            else{
                $recommandation_id = $check_recommandation->id;
            }

        }

        //on vérifie si forme_juridique_id existe dans la table forme_juridique
        if($forme_juridique_id != NULL){
            $check = \DB::table('forme_juridique')
                ->where('id','=',$forme_juridique_id)
                ->first();

            if(empty($check)){
                return response()->json(['message' => 'error', 'remplir_tous_les_champs' => false, 'statut_id_not_exist' => false, 'disponibilite_id_not_exist' => false,
                    'recommandation_id_not_exist' => false, 'forme_juridique_id_not_exist' => true, 'profil_id_not_exist' => false,
                    'experience_geographique_id_not_exist' => false, 'domaine_id_not_exist' => false], 400);
            }
        }
        

        //on vérifie si profil_id existe dans la table profil
        if(sizeof($liste_profil) != 0){
            for($i=0; $i<sizeof($liste_profil); $i++){
                $profil_id = $liste_profil[$i]->profil_id;

                $check = \DB::table('profil')
                    ->where('id','=',$profil_id)
                    ->first();
                if(empty($check)){
                    return response()->json(['message' => 'error', 'remplir_tous_les_champs' => false, 'statut_id_not_exist' => false, 'disponibilite_id_not_exist' => false,
                        'recommandation_id_not_exist' => false, 'forme_juridique_id_not_exist' => false, 'profil_id_not_exist' => true,
                        'experience_geographique_id_not_exist' => false, 'domaine_id_not_exist' => false], 400);
                }
            }
        }

        //on vérifie si experience_geographique_id existe dans la table experience_geographique
        if(sizeof($liste_experience_geographique) != 0){
            for($i=0; $i<sizeof($liste_experience_geographique); $i++){
                $experience_geographique_id = $liste_experience_geographique[$i]->experience_geographique_id;

                $check = \DB::table('experience_geographique')
                    ->where('id','=',$experience_geographique_id)
                    ->first();
                if(empty($check)){
                    return response()->json(['message' => 'error', 'remplir_tous_les_champs' => false, 'statut_id_not_exist' => false, 'disponibilite_id_not_exist' => false,
                        'recommandation_id_not_exist' => false, 'forme_juridique_id_not_exist' => false, 'profil_id_not_exist' => false,
                        'experience_geographique_id_not_exist' => true, 'domaine_id_not_exist' => false], 400);
                }
            }
        }

        //on vérifie si domaine_id existe dans la table domaines
        if(sizeof($liste_domaine_expertise) != 0){
            for($i=0; $i<sizeof($liste_domaine_expertise); $i++){
                $domaine_id = $liste_domaine_expertise[$i]->domaine_id;

                $check = \DB::table('domaines')
                    ->where('id','=',$domaine_id)
                    ->first();
                if(empty($check)){
                    return response()->json(['message' => 'error', 'remplir_tous_les_champs' => false, 'statut_id_not_exist' => false, 'disponibilite_id_not_exist' => false,
                        'recommandation_id_not_exist' => false, 'forme_juridique_id_not_exist' => false, 'profil_id_not_exist' => false,
                        'experience_geographique_id_not_exist' => false, 'domaine_id_not_exist' => true], 400);
                }
            }
        }


        //je remplis le nbre_annee_creation
        $annee_tableau = explode("-", $annee_creation);
        $annee_annee_creation = (int) $annee_tableau[0];

        $annee_courante = date('Y');
        $annee_courante = (int) $annee_courante;

        $age = $annee_courante - $annee_annee_creation;


        //je prends le nbre_annee_experience
        $annee_tableau = explode("-", $date1ereAnneeExperienceEnTantQueONG);
        $annee_experience = (int) $annee_tableau[0];

        $annee_courante = date('Y');
        $annee_courante = (int) $annee_courante;

        $nbre_annee_experience = $annee_courante - $annee_experience;

        //j'enregistre d'abord les infos principales de la table ong_association
        \DB::table('ong_association')
            ->insert([
                [
                    'user_id' => $user_id,
                    'statut_id' => $statut_id,
                    'disponibilite_id' => $disponibilite_id,
                    'recommandation_id' => $recommandation_id,
                    'nom' => $nom,
                    'sigle' => $sigle,
                    'forme_juridique_id' => $forme_juridique_id,
                    'annee_creation' => $annee_creation,
                    'nbre_annee_creation' => $age,
                    'registre_commerce' => $registre_commerce,
                    'siege_social' => $siege_social,
                    'date1ereAnneeExperienceEnTantQueONG' => $date1ereAnneeExperienceEnTantQueONG,
                    'nbre_annee_experience' => $nbre_annee_experience,
                    'experienceAvecCooperationAllemande' => $experienceAvecCooperationAllemande,
                    'experienceAvecLesNationsUnies' => $experienceAvecLesNationsUnies,
                    'experienceAvecLesAutresPartenaires' => $experienceAvecLesAutresPartenaires,
                    'adresse' => $adresse,
                    'nom_principal_dirigeant' => $nom_principal_dirigeant,
                    'prenom_principal_dirigeant' => $prenom_principal_dirigeant,
                    'telephone_principal_dirigeant' => $telephone_principal_dirigeant,
                    'courriel_principal_dirigeant' => $courriel_principal_dirigeant,
                    'created_at' => Carbon::now(),
                    'updated_at' => Carbon::now()
                ]
            ]);

        //maintenant je récupère le user_id pour pouvoir save les autres infos file_cabinet_bureau_etude, profils, experience_geographique, domaines, contacts et courriels
        $user = \DB::table('ong_association')
            ->where('user_id','=',$user_id)
            ->where('statut_id','=',$statut_id)
            ->where('disponibilite_id','=',$disponibilite_id)
            ->where('recommandation_id','=',$recommandation_id)
            ->where('nom','=',$nom)
            ->where('sigle','=',$sigle)
            ->where('forme_juridique_id','=',$forme_juridique_id)
            ->where('annee_creation','=',$annee_creation)
            //->where('nbre_annee_creation','=',$nbre_annee_creation)
            ->where('registre_commerce','=',$registre_commerce)
            ->where('siege_social','=',$siege_social)
            ->where('date1ereAnneeExperienceEnTantQueONG','=',$date1ereAnneeExperienceEnTantQueONG)
            ->where('nbre_annee_experience','=',$nbre_annee_experience)
            ->where('experienceAvecCooperationAllemande','=',$experienceAvecCooperationAllemande)
            ->where('experienceAvecLesNationsUnies','=',$experienceAvecLesNationsUnies)
            ->where('experienceAvecLesAutresPartenaires','=',$experienceAvecLesAutresPartenaires)
            ->where('adresse','=',$adresse)
            ->where('nom_principal_dirigeant','=',$nom_principal_dirigeant)
            ->where('prenom_principal_dirigeant','=',$prenom_principal_dirigeant)
            ->where('telephone_principal_dirigeant','=',$telephone_principal_dirigeant)
            ->where('courriel_principal_dirigeant','=',$courriel_principal_dirigeant)
            ->first();

        if(!empty($user)){
            $user_id = $user->id;
            $ref_user = 'ONGASSOC_'.str_random(10).$user_id;     //ONGASSOC = ONG / Association

            //j'update ref_user dans la table cabinet_bureau_etude
            \DB::table('ong_association')
                ->where('id','=',$user_id)
                ->update([
                    'ref_user' => $ref_user
                ]);

            //j'enregistre d'abord les CVs du consultant
            //define('UPLOAD_DIR','/home/mooevents/public_html/img/uploads/');
            //define('UPLOAD_DIR','/Applications/MAMP/htdocs/giz_frontend/public/img/uploads/Files_cabinet_bureau_etude/');
            //define('UPLOAD_DIR','/home/apivisavis/public_html/giz/img/uploads/Files_ong_association/');
            define('UPLOAD_DIR','/usr/www/users/amberm/public/img/uploads/Files_ong_association/');

            if($liste_files != ""){
                if(sizeof($liste_files) != 0){
                    for($i=0; $i<sizeof($liste_files); $i++){
    
                        $ref_file = str_random(4);
    
                        $pdf = $liste_files[$i]->file;
                        $data = base64_decode($pdf);
                        //$nom = uniqid() . '.pdf';
                        $name = 'ONGAssoc_'.$nom.'_'.$sigle.'_'.'Ref_'.$ref_file. '.pdf';        //ONGAssoc = ONG / Association
                        $file = UPLOAD_DIR . $name;
                        $chemin='img/uploads/Files_ong_association/'.$name ;
                        file_put_contents($file, $data);        //pour upload le fichier dans le dossier du chemin UPLOAD_DIR
    
                        //extraction du contenu du fichier concernant le cabinet d'études et stockage
                        $text = (new Pdf())
                            ->setPdf($file)
                            ->text();
    
                        \DB::table('file_ong_association')
                            ->insert([
                                [
                                    'file' => $chemin,
                                    'file_en_base_64' => $pdf,
                                    'ref_user' => $ref_user,
                                    'ref_file' => $ref_file,
                                    'contenu_file' => $text,
                                    'created_at' => Carbon::now(),
                                    'updated_at' => Carbon::now()
                                ]
                            ]);
                    }
                }
            }
            

            //j'enregistre les profils du consultant
            if(sizeof($liste_profil) != 0){
                for($i=0; $i<sizeof($liste_profil); $i++){
                    $profil_id = $liste_profil[$i]->profil_id;

                    \DB::table('profil_users')
                        ->insert([
                            [
                                'profil_id' => $profil_id,
                                'ref_user' => $ref_user,
                                'type' => $type,
                                'created_at' => Carbon::now(),
                                'updated_at' => Carbon::now()
                            ]
                        ]);
                }
            }

            //j'enregistre les expériences géographiques du consultant
            if(sizeof($liste_experience_geographique) != 0){
                for($i=0; $i<sizeof($liste_experience_geographique); $i++){
                    $experience_geographique_id = $liste_experience_geographique[$i]->experience_geographique_id;

                    \DB::table('experience_geographique_users')
                        ->insert([
                            [
                                'experience_geographique_id' => $experience_geographique_id,
                                'ref_user' => $ref_user,
                                'type' => $type,
                                'created_at' => Carbon::now(),
                                'updated_at' => Carbon::now()
                            ]
                        ]);
                }
            }

            //j'enregistre les domaines d'expertise et professionnels du consultant
            if(sizeof($liste_domaine_expertise) != 0){
                for($i=0; $i<sizeof($liste_domaine_expertise); $i++){
                    $domaine_id = $liste_domaine_expertise[$i]->domaine_id;
                    $nbre_consultation = $liste_domaine_expertise[$i]->nbre_consultation;

                    \DB::table('domaine_expertise_users')
                        ->insert([
                            [
                                'domaine_id' => $domaine_id,
                                'nbre_consultation' => $nbre_consultation,
                                'ref_user' => $ref_user,
                                'type' => $type,
                                'created_at' => Carbon::now(),
                                'updated_at' => Carbon::now()
                            ]
                        ]);
                }
            }

            //j'enregistre les téléphones du consultant
            if(sizeof($liste_telephone) != 0){
                for($i=0; $i<sizeof($liste_telephone); $i++){
                    $telephone = $liste_telephone[$i]->telephone;

                    \DB::table('contact_users')
                        ->insert([
                            [
                                'telephone' => $telephone,
                                'ref_user' => $ref_user,
                                'type' => $type,
                                'created_at' => Carbon::now(),
                                'updated_at' => Carbon::now()
                            ]
                        ]);
                }
            }

            //j'enregistre les courriels (emails) du consultant
            if(sizeof($liste_courriel) != 0){
                for($i=0; $i<sizeof($liste_courriel); $i++){
                    $email = $liste_courriel[$i]->email;

                    \DB::table('courriel_users')
                        ->insert([
                            [
                                'email' => $email,
                                'ref_user' => $ref_user,
                                'type' => $type,
                                'created_at' => Carbon::now(),
                                'updated_at' => Carbon::now()
                            ]
                        ]);
                }
            }

        }

        return response()->json(['message' => 'success']);
    }


    //permet de renvoyer tous les ONGs ou Association
 public function getONGAssociation(){
        //je select les données à partir de l'offset $num_id
        $ong_association = \DB::table('ong_association')
            ->join('users','users.id','=','ong_association.user_id')
            ->select('ong_association.id','ong_association.ref_user','ong_association.statut_id',
                 'ong_association.disponibilite_id','ong_association.recommandation_id',
                 'ong_association.nom','ong_association.sigle','ong_association.forme_juridique_id',
                 'ong_association.annee_creation','ong_association.registre_commerce',
                 'ong_association.siege_social','ong_association.date1ereAnneeExperienceEnTantQueONG',
                 'ong_association.experienceAvecCooperationAllemande','ong_association.experienceAvecLesNationsUnies','ong_association.experienceAvecLesAutresPartenaires','ong_association.adresse',
                 'ong_association.nom_principal_dirigeant','ong_association.prenom_principal_dirigeant',
                 'ong_association.telephone_principal_dirigeant','ong_association.courriel_principal_dirigeant','ong_association.created_at',
                 'ong_association.updated_at','users.id as user_id_ajouter_par','users.username','users.phone','users.email')
            ->orderBy('created_at','asc')
            ->get();


        $liste = array();

        if(!empty($ong_association)){
            foreach($ong_association as $data){
                $ajouter_par = \DB::table('users')
                    ->join('roles','roles.id','=','users.role_id')
                    ->where('users.id','=',$data->user_id_ajouter_par)
                    ->first();

                $ref_user = $data->ref_user;
                $ong_association_id = $data->id;
                $statut_id = $data->statut_id; 
                $disponibilite_id = $data->disponibilite_id; 
                $recommandation_id = $data->recommandation_id; 
                $nom = $data->nom; 
                $sigle = $data->sigle; 
                $forme_juridique_id = $data->forme_juridique_id; 
                $annee_creation = $data->annee_creation; 

                $registre_commerce = $data->registre_commerce; 
                $siege_social = $data->siege_social;

                $date1ereAnneeExperienceEnTantONG = $data->date1ereAnneeExperienceEnTantQueONG; 

                $experienceAvecCooperationAllemande = $data->experienceAvecCooperationAllemande; 

                $experienceAvecLesNationsUnies = $data->experienceAvecLesNationsUnies;

                $experienceAvecLesAutresPartenaires = $data->experienceAvecLesAutresPartenaires; 


                $adresse = $data->adresse;

                $nom_principal_dirigeant = $data->nom_principal_dirigeant; 
                $prenom_principal_dirigeant = $data->prenom_principal_dirigeant;
                $telephone_principal_dirigeant = $data->telephone_principal_dirigeant;
                $courriel_principal_dirigeant = $data->courriel_principal_dirigeant;

                $created_at = $data->created_at; 
                $updated_at = $data->updated_at; 

                $statut = \DB::table('statut')
                    ->where('id','=',$statut_id)
                    ->first();

                $disponibilite = \DB::table('disponibilite')
                    ->where('id','=',$disponibilite_id)
                    ->first();

                $recommandation = \DB::table('recommandation')
                    ->where('id','=',$recommandation_id)
                    ->first();

                $forme_juridique = \DB::table('forme_juridique')
                    ->where('id','=',$forme_juridique_id)
                    ->first();    

                $file_ong_association = \DB::table('file_ong_association')
                    ->where('ref_user','=',$ref_user)
                    ->get();

                $profil_users = \DB::table('profil_users')
                    ->join('profil','profil.id','=','profil_users.profil_id')
                    ->where('profil_users.ref_user','=',$ref_user)
                    ->get();

                $experience_geographique_users = \DB::table('experience_geographique_users')
                    ->join('experience_geographique','experience_geographique.id','=','experience_geographique_users.experience_geographique_id')
                    ->where('experience_geographique_users.ref_user','=',$ref_user)
                    ->get();

                $domaine_expertise_users = \DB::table('domaine_expertise_users')
                    ->join('domaines','domaines.id','=','domaine_expertise_users.domaine_id')
                    ->where('domaine_expertise_users.ref_user','=',$ref_user)
                    ->get();

                $contact_users = \DB::table('contact_users')
                    ->where('ref_user','=',$ref_user)
                    ->get();

                $courriel_users = \DB::table('courriel_users')
                    ->where('ref_user','=',$ref_user)
                    ->get();

                $tmp ["ajouter_par"] = $ajouter_par;
                $tmp ["ong_association_id"] = $ong_association_id;
                $tmp ["statut"] = $statut;
                $tmp ["disponibilite"] = $disponibilite;
                $tmp ["recommandation"] = $recommandation;
                $tmp ["nom"] = $nom;
                $tmp ["sigle"] = $sigle;
                $tmp ["forme_juridique"] = $forme_juridique;
                $tmp ["annee_creation"] = $annee_creation;
                $tmp ["registre_commerce"] = $registre_commerce;
                $tmp ["siege_social"] = $siege_social;
                $tmp ["date1ereAnneeExperienceEnTantONG"] = $date1ereAnneeExperienceEnTantONG;
                $tmp ["experienceAvecCooperationAllemande"] = $experienceAvecCooperationAllemande;
                $tmp ["experienceAvecLesNationsUnies"] = $experienceAvecLesNationsUnies;
                $tmp ["experienceAvecLesAutresPartenaires"] = $experienceAvecLesAutresPartenaires;
                $tmp ["adresse"] = $adresse;
                $tmp ["nom_principal_dirigeant"] = $nom_principal_dirigeant;
                $tmp ["prenom_principal_dirigeant"] = $prenom_principal_dirigeant;
                $tmp ["telephone_principal_dirigeant"] = $telephone_principal_dirigeant;
                $tmp ["courriel_principal_dirigeant"] = $courriel_principal_dirigeant;
                $tmp ["file_ong_association"] = $file_ong_association;
                $tmp ["profil_users"] = $profil_users;
                $tmp ["experience_geographique_users"] = $experience_geographique_users;
                $tmp ["domaine_expertise_users"] = $domaine_expertise_users;
                $tmp ["contact_users"] = $contact_users;
                $tmp ["courriel_users"] = $courriel_users;
                $tmp ["created_at"] = $created_at;
                $tmp ["updated_at"] = $updated_at;

                array_push($liste,$tmp ) ;

            }
        }
                return response()->json(['message' => 'success', 'liste_ong_association' => $liste]);

    }
    


    //permet de renvoyer la liste des ONG et Associations sans filtre à partir d'un numéro de page
    public function getONGAssociationByPage($num_page,$nbre_donnees_par_page){
        $donnees_par_page = $nbre_donnees_par_page;

        $entrees = \DB::table('ong_association')
            ->orderBy('created_at','asc')
            ->count();

        $nbre_pages = ceil($entrees/$donnees_par_page);     //total_page

        //je contrôle si le numéro de la page est compris dans l'intervalle 1 <= $page_num <= $nbre_pages
        if($num_page >= 1 AND $num_page <= $nbre_pages){
            for($i = 1; $i<=$nbre_pages; $i++){
                if($num_page == $i){ //alors on calcule à partir de l'id que ça doit renvoyer
                    if($num_page == 1){
                        $num_id = 0;
                    }
                    else{
                        $num_id = ($num_page - 1) * $donnees_par_page;
                    }

                    //je select les données à partir de l'offset $num_id
                    /*$cabinet_bureaux_etude = \DB::table('ong_association')
                            ->orderBy('created_at','asc')
                            ->offset($num_id)    //numéro de la ligne en BD à partir duquel la selection va se faire
                            ->limit($donnees_par_page)
                            ->get();
                            */

                    $ong_association = \DB::table('ong_association')
                        ->join('users','users.id','=','ong_association.user_id')
                        ->select('ong_association.id','ong_association.ref_user','ong_association.statut_id',
                             'ong_association.disponibilite_id','ong_association.recommandation_id',
                             'ong_association.nom','ong_association.sigle','ong_association.forme_juridique_id',
                             'ong_association.annee_creation','ong_association.registre_commerce',
                             'ong_association.siege_social','ong_association.date1ereAnneeExperienceEnTantQueONG',
                             'ong_association.experienceAvecCooperationAllemande','ong_association.experienceAvecLesNationsUnies','ong_association.experienceAvecLesAutresPartenaires','ong_association.adresse',
                             'ong_association.nom_principal_dirigeant','ong_association.prenom_principal_dirigeant',
                             'ong_association.telephone_principal_dirigeant','ong_association.courriel_principal_dirigeant','ong_association.created_at',
                             'ong_association.updated_at','users.id as user_id_ajouter_par','users.username','users.phone','users.email')
                        ->orderBy('created_at','asc')
                        ->offset($num_id)    //numéro de la ligne en BD à partir duquel la selection va se faire
                        ->limit($donnees_par_page)
                        ->get();        


                    $liste = array();

                    if(!empty($cabinet_bureaux_etude)){
                        foreach($cabinet_bureaux_etude as $data){
                            $ajouter_par = \DB::table('users')
                                ->join('roles','roles.id','=','users.role_id')
                                ->where('users.id','=',$data->user_id_ajouter_par)
                                ->first();

                            $ref_user = $data->ref_user;
                            $statut_id = $data->statut_id; 
                            $disponibilite_id = $data->disponibilite_id; 
                            $recommandation_id = $data->recommandation_id; 
                            $nom = $data->nom; 
                            $sigle = $data->sigle; 
                            $forme_juridique_id = $data->forme_juridique_id; 
                            $annee_creation = $data->annee_creation; 

                            $registre_commerce = $data->registre_commerce; 
                            $siege_social = $data->siege_social;

                            $date1ereAnneeExperienceEnTantONG = $data->date1ereAnneeExperienceEnTantONG; 

                            $experienceAvecCooperationAllemande = $data->experienceAvecCooperationAllemande; 

                            $experienceAvecLesNationsUnies = $data->experienceAvecLesNationsUnies; 

                            $experienceAvecLesAutresPartenaires = $date->experienceAvecLesAutresPartenaires;


                            $adresse = $data->adresse;

                            $nom_principal_dirigeant = $data->nom_principal_dirigeant; 
                            $prenom_principal_dirigeant = $data->prenom_principal_dirigeant;
                            $telephone_principal_dirigeant = $data->telephone_principal_dirigeant;
                            $courriel_principal_dirigeant = $data->courriel_principal_dirigeant;

                            $created_at = $data->created_at; 
                            $updated_at = $data->updated_at; 

                            $statut = \DB::table('statut')
                                ->where('id','=',$statut_id)
                                ->first();

                            $disponibilite = \DB::table('disponibilite')
                                ->where('id','=',$disponibilite_id)
                                ->first();

                            $recommandation = \DB::table('recommandation')
                                ->where('id','=',$recommandation_id)
                                ->first();

                            $forme_juridique = \DB::table('forme_juridique')
                                ->where('id','=',$forme_juridique_id)
                                ->first();    

                            $file_cabinet_bureau_etude = \DB::table('file_ong_association')
                                ->where('ref_user','=',$ref_user)
                                ->get();

                            $profil_users = \DB::table('profil_users')
                                ->join('profil','profil.id','=','profil_users.profil_id')
                                ->where('profil_users.ref_user','=',$ref_user)
                                ->get();

                            $experience_geographique_users = \DB::table('experience_geographique_users')
                                ->join('experience_geographique','experience_geographique.id','=','experience_geographique_users.experience_geographique_id')
                                ->where('experience_geographique_users.ref_user','=',$ref_user)
                                ->get();

                            $domaine_expertise_users = \DB::table('domaine_expertise_users')
                                ->join('domaines','domaines.id','=','domaine_expertise_users.domaine_id')
                                ->where('domaine_expertise_users.ref_user','=',$ref_user)
                                ->get();

                            $contact_users = \DB::table('contact_users')
                                ->where('ref_user','=',$ref_user)
                                ->get();

                            $courriel_users = \DB::table('courriel_users')
                                ->where('ref_user','=',$ref_user)
                                ->get();

                            $tmp ["ajouter_par"] = $ajouter_par;
                            $tmp ["statut"] = $statut;
                            $tmp ["disponibilite"] = $disponibilite;
                            $tmp ["recommandation"] = $recommandation;
                            $tmp ["nom"] = $nom;
                            $tmp ["sigle"] = $sigle;
                            $tmp ["forme_juridique"] = $forme_juridique;
                            $tmp ["annee_creation"] = $annee_creation;
                            $tmp ["registre_commerce"] = $registre_commerce;
                            $tmp ["siege_social"] = $siege_social;
                            $tmp ["date1ereAnneeExperienceEnTantONG"] = $date1ereAnneeExperienceEnTantONG;
                            $tmp ["experienceAvecCooperationAllemande"] = $experienceAvecCooperationAllemande;
                            $tmp ["experienceAvecLesNationsUnies"] = $experienceAvecLesNationsUnies;
                            $tmp ["experienceAvecLesAutresPartenaires"] = $experienceAvecLesAutresPartenaires;
                            $tmp ["adresse"] = $adresse;
                            $tmp ["nom_principal_dirigeant"] = $nom_principal_dirigeant;
                            $tmp ["prenom_principal_dirigeant"] = $prenom_principal_dirigeant;
                            $tmp ["telephone_principal_dirigeant"] = $telephone_principal_dirigeant;
                            $tmp ["courriel_principal_dirigeant"] = $courriel_principal_dirigeant;
                            $tmp ["file_ong_association"] = $file_cabinet_bureau_etude;
                            $tmp ["profil_users"] = $profil_users;
                            $tmp ["experience_geographique_users"] = $experience_geographique_users;
                            $tmp ["domaine_expertise_users"] = $domaine_expertise_users;
                            $tmp ["contact_users"] = $contact_users;
                            $tmp ["courriel_users"] = $courriel_users;
                            $tmp ["created_at"] = $created_at;
                            $tmp ["updated_at"] = $updated_at;

                            array_push($liste,$tmp ) ;

                        }
                    }

                }
            }

            return response()->json(['message' => 'success', 'current_page' => $num_page, 'nbre_ong_association' => $entrees, 'total_page' => $nbre_pages, 'ong_associations' => $liste]);
        }
        else{
            return response()->json(['message' => 'error', 'page_not_exist' => true], 400);
        }

    }


    //permet de get les domaines d'intervention et les profils en comptant les cabinets ou bureaux d'étude dans chaque domaine et dans chaque profil
    public function getInfoSidebar(){
        //domaines d'expertise et professionnel
        $domaine_interventions = \DB::table('domaines')
            ->get();

         $liste_domaine_expertise = array();   

        if(!empty($domaine_interventions)){
            foreach($domaine_interventions as $domaine){
                $domaine_id = $domaine->id;

                //pour chaque domaine, je compte les cabinets ou bureaux d'étude du domaine
                $nbre_cabinet_bureau_etude = \DB::table('domaine_expertise_users')
                        ->where('domaine_id','=',$domaine_id)
                        ->where('type','=','ong_association')
                        ->count();

                $tmp ["domaine"] = $domaine;
                $tmp ["nbre_ong_association"] = $nbre_cabinet_bureau_etude;

                array_push($liste_domaine_expertise,$tmp ) ;       
            }

        }

        //profil
        $profils = \DB::table('profil')
            ->get();

        $liste_profil = array();

        if(!empty($profils)){
            foreach($profils as $profil){
                $profil_id = $profil->id;

                //pour chaque profil, je compte les cabinets ou bureaux d'étude ayant ce profil
                $nbre_consultant = \DB::table('profil_users')
                        ->where('profil_id','=',$profil_id)
                        ->where('type','=','ong_association')
                        ->count();

                $tmp1 ["profil"] = $profil;
                $tmp1 ["nbre_ong_association"] = $nbre_consultant;

                array_push($liste_profil,$tmp1 ) ;       
            }

        } 


        //je prends tous les nbres d'année de création sans doublon
        $ong_associations =  \DB::table('ong_association')
            ->select('nbre_annee_creation')
            ->distinct()
            ->get();

        $liste_age_ong_association = array();
        if(!empty($ong_associations)){
            foreach($ong_associations as $ong){
                $age = $ong->nbre_annee_creation;

                //pour chaque age sans doublon, je compte les ONG ayant cet âge
                $nbre_ong_association = \DB::table('ong_association')
                        ->where('nbre_annee_creation','=',$age)
                        ->count();    

                $tmp2 ["nbre_annee_creation"] = $age;
                $tmp2 ["nbre_ong_association"] = $nbre_ong_association;

                array_push($liste_age_ong_association ,$tmp2 ) ;       
            }

        }


        //expérience géographique
        $experiences_geographiques = \DB::table('experience_geographique')
            ->get();

        $liste_experience_geographique = array();
        
        if(!empty($experiences_geographiques)){
            foreach($experiences_geographiques as $exp){
                $experience_geographique_id = $exp->id;

                //pour chaque niveau de formation, je compte les consultants ayant ce niveau de formation
                $nbre_cabinet_bureau_etude = \DB::table('experience_geographique_users')
                        ->where('experience_geographique_id','=',$experience_geographique_id)
                        ->where('type','=','ong_association')
                        ->count();

                $tmp3 ["experience_geographique"] = $exp;
                $tmp3 ["nbre_ong_association"] = $nbre_cabinet_bureau_etude;

                array_push($liste_experience_geographique,$tmp3 ) ;       
            }

        }


        //je prends tous les nbre_annee_experience_pro sans doublon
        $ong_associations =  \DB::table('ong_association')
            ->select('nbre_annee_experience')
            ->distinct()
            ->get();

        $liste_annee_experience_ong_association = array();
        if(!empty($ong_associations)){
            foreach($ong_associations as $c){
                $nbre_annee_experience = $c->nbre_annee_experience;

                //pour chaque nbre_annee_experience_pro sans doublon, je compte les cabinets ayant ce nbre_annee_experience_pro
                $nbre_ong_association = \DB::table('ong_association')
                        ->where('nbre_annee_experience','=',$nbre_annee_experience)
                        ->count();    

                $tmp4 ["nbre_annee_d_experience"] = $nbre_annee_experience;
                $tmp4 ["nbre_ong_association"] = $nbre_ong_association;

                array_push($liste_annee_experience_ong_association ,$tmp4 ) ;       
            }

        }
        
        
        //statut
        $statuts = \DB::table('statut')
            ->get();

        $liste_statut = array();
        
        if(!empty($statuts)){
            foreach($statuts as $statut){
                $statut_id = $statut->id;

                //pour chaque statut, je compte les ONG ou association ayant ce statut
                $nbre_ong_association = \DB::table('ong_association')
                        ->where('statut_id','=',$statut_id)
                        ->count();

                $tmp5 ["statut"] = $statut;
                $tmp5 ["nbre_ong_association"] = $nbre_ong_association;

                array_push($liste_statut,$tmp5 ) ;       
            }

        }


        return response()->json(['message' => 'success', 'liste_domaine_expertise' => $liste_domaine_expertise,
                                 'liste_profil' => $liste_profil, 'liste_age_ong_association' => $liste_age_ong_association, 
                                 'liste_experience_geographique' => $liste_experience_geographique, 
                                 'liste_annee_experience_ong_association' => $liste_annee_experience_ong_association,
                                 'liste_statut' => $liste_statut]);

    }


    //permet d'exporter dans un dossier zip tous les fichiers des cabinets ou bureaux d'étude d'une page
    public function exportZipFile(){
        $request = Request::instance();
        $data = json_decode($request->getContent());

        $liste_files = $data->liste_files;        //contient le tableau JSON des chemins des fichiers des cabinets ou bureaux d'étude de la page. Format liste_files = [{"file":"string"},{"file":"string"},{...}]

        $files = array();

        if(sizeof($liste_files) != 0){
            for($i=0; $i<sizeof($liste_files); $i++){
                $files[$i] = public_path($liste_files[$i]->file);
            }

                  //  dd($files);

            \Zipper::make('/home/montaxi/Bureau/Cabinets_Bureaux_Etude_'.Carbon::now().'.zip'/*public_path('test.zip')*/)->add($files)->close();
            return response()->download('/home/montaxi/Bureau/Cabinets_Bureaux_Etude_'.Carbon::now().'.zip'/*public_path('test.zip')*/);
        }
        
        return response()->json(['message' => 'error', 'liste_files_is_empty' => true], 400);

    }



        //permet de renvoyer les statistiques des consultants en genre sur les CVs et par domaine d'intervention
    public function getStatistique(){
        $total_cabinet_bureau_etude = \DB::table('ong_association')
            ->count();

        $total_cabinet_bureau_etude_pour_tous_les_domaines = 0;

        //domaines d'expertise et professionnel
        $domaine_interventions = \DB::table('domaines')
            ->get();

        if(!empty($domaine_interventions)){
            foreach($domaine_interventions as $domaine){
                $domaine_id = $domaine->id;

                //pour chaque domaine, je compte les cabinet_bureau_etude du domaine
                $nbre_cabinet_bureau_etude = \DB::table('domaine_expertise_users')
                        ->where('domaine_id','=',$domaine_id)
                        ->where('type','=','ong_association')
                        ->count();

                $total_cabinet_bureau_etude_pour_tous_les_domaines += $nbre_cabinet_bureau_etude;

                }
        }

         $liste_domaine_expertise = array();
         $total_cabinet_bureau_etude_par_domaines_expertise = 0;   

        if(!empty($domaine_interventions)){
            foreach($domaine_interventions as $domaine){
                $domaine_id = $domaine->id;

                //pour chaque domaine, je compte les cabinet_bureau_etude du domaine
                $nbre_cabinet_bureau_etude = \DB::table('domaine_expertise_users')
                        ->where('domaine_id','=',$domaine_id)
                        ->where('type','=','ong_association')
                        ->count();               

                $tmp ["domaine"] = $domaine;
                $tmp ["nbre_ong_association"] = $nbre_cabinet_bureau_etude;

                if($total_cabinet_bureau_etude_pour_tous_les_domaines){
                    $tmp ["pourcentage"] = ($nbre_cabinet_bureau_etude / $total_cabinet_bureau_etude_pour_tous_les_domaines) * 100;
                }
                else{
                    $tmp ["pourcentage"] = 0;
                }

                array_push($liste_domaine_expertise,$tmp ) ;

            }

        }


        return response()->json(['message' => 'success', 'total_ong_association' => $total_cabinet_bureau_etude, 
                                 'liste_domaine_expertise' => $liste_domaine_expertise,
                                 'total_ong_association_pour_tous_les_domaines' => $total_cabinet_bureau_etude_pour_tous_les_domaines]);

    }



    //permet d'update une ONG ou une association
    public function updateONGAssociation($ong_association_id,$token){
        $request = Request::instance();
        $data = json_decode($request->getContent());

        //je vérifie si ong_association_id existe bien en BD
        $check_ong_association_id = \DB::table('ong_association')
            ->where('id','=',$ong_association_id)
            ->first();

        if(empty($check_ong_association_id)){
            return response()->json(['user_not_found' => false, 'ong_association_id_not_exist' => true], 401);
        } 

        //je vérifie le token
        $check = \DB::table('users')
            ->where('remember_token','=',$token)
            ->first();

            //dd($check);

        if(empty($check)){
            return response()->json(['user_not_found' => true, 'ong_association_id_not_exist' => false], 401);
        }    

        $user_id = $check->id;



        $liste_files = $data->liste_files;        //contient le tableau JSON des documents du cabinet. Format liste_files = [{"file":"string"},{"file":"string"},{...}]
        $statut_id = $data->statut_id;
        $disponibilite_id = $data->disponibilite_id;
        $recommandation_id = $data->recommandation_id;
        $recommandation_name = $data->recommandation_name;
        $nom = $data->nom;
        $sigle = $data->sigle;
        $forme_juridique_id = $data->forme_juridique_id;
        $annee_creation = $data->annee_creation;        //format aaaa
        $registre_commerce = $data->registre_commerce;
        $siege_social = $data->siege_social;
        $liste_profil = $data->liste_profil;        //contient le tableau JSON des profils du cabinet. Format liste_profile = [{"profil_id":value},{"profil_id":value},{...}]
        $date1ereAnneeExperienceEnTantQueONG = $data->date1ereAnneeExperienceEnTantQueCabinet;      //format aaaa-mm-jj
        $liste_experience_geographique = $data->liste_experience_geographique;      //contient le tableau JSON d'expériences géographique du cabinet. Format liste_experience_geographique = [{"experience_geographique_id":value},{"experience_geographique_id":value},{...}]
        $experienceAvecCooperationAllemande = $data->experienceAvecCooperationAllemande;    // 0 pour non et 1 pour oui
        $experienceAvecLesNationsUnies = $data->experienceAvecLesNationsUnies;          //0 pour non et 1 pour oui
        $experienceAvecLesAutresPartenaires = $data->experienceAvecLesAutresPartenaires;          //0 pour non et 1 pour oui
        $liste_domaine_expertise = $data->liste_domaine_expertise;      //contient le tableau JSON des domaines d'expertise du cabinet. Format liste_domaine_expertise = [{"domaine_id":value, "nbre_consultation":value},{"domaine_id":value, "nbre_consultation":value},{...}]
        $adresse = $data->adresse;
        $liste_telephone = $data->liste_telephone;      //contient le tableau JSON des téléphones du cabinet. Format liste_telephone = [{"telephone":value},{"telephone":value},{...}]
        $liste_courriel = $data->liste_courriel;        //contient le tableau JSON des emails du cabinet. Format liste_courriel = [{"email":value},{"email":value},{...}]
        $nom_principal_dirigeant = $data->nom_principal_dirigeant;
        $prenom_principal_dirigeant = $data->prenom_principal_dirigeant;
        $telephone_principal_dirigeant = $data->telephone_principal_dirigeant;
        $courriel_principal_dirigeant = $data->courriel_principal_dirigeant;

        $type = "ong_association";    //type = consultant ou cabinet_bureau_etude ou ong_association

        $created_at = Carbon::now();
        $updated_at = Carbon::now();

        //if((sizeof($liste_files) == 0) || $statut_id == NULL || $disponibilite_id == NULL || $recommandation_id == NULL || $nom == NULL
        //    || $sigle == NULL || $forme_juridique_id == NULL || $annee_creation == NULL || $registre_commerce == NULL || $siege_social == NULL
        //    || (sizeof($liste_profil) == 0) || $date1ereAnneeExperienceEnTantQueONG == NULL || (sizeof($liste_experience_geographique) == 0)
        //    || (sizeof($liste_domaine_expertise) == 0) || $adresse == NULL || (sizeof($liste_telephone) == 0) || (sizeof($liste_courriel) == 0)
        //    || $nom_principal_dirigeant == NULL || $prenom_principal_dirigeant == NULL || $telephone_principal_dirigeant == NULL
        //    || $courriel_principal_dirigeant == NULL){

        //    return response()->json(['message' => 'error', 'remplir_tous_les_champs' => true, 'statut_id_not_exist' => false, 'disponibilite_id_not_exist' => false,
        //        'recommandation_id_not_exist' => false, 'forme_juridique_id_not_exist' => false, 'profil_id_not_exist' => false,
        //        'experience_geographique_id_not_exist' => false, 'domaine_id_not_exist' => false], 400);

        //}

        //on vérifie si le statut_id existe dans la table statut
        if($statut_id != NULL){
            $check = \DB::table('statut')
                ->where('id','=',$statut_id)
                ->first();

            if(empty($check)){
                return response()->json(['message' => 'error', 'remplir_tous_les_champs' => false, 'statut_id_not_exist' => true, 'disponibilite_id_not_exist' => false,
                    'recommandation_id_not_exist' => false, 'forme_juridique_id_not_exist' => false, 'profil_id_not_exist' => false,
                    'experience_geographique_id_not_exist' => false, 'domaine_id_not_exist' => false], 400);
            }
        }
        
        //on vérifie si disponibilite_id existe dans la table disponibilite
        if($disponibilite_id != NULL){
            $check = \DB::table('disponibilite')
                ->where('id','=',$disponibilite_id)
                ->first();

            if(empty($check)){
                return response()->json(['message' => 'error', 'remplir_tous_les_champs' => false, 'statut_id_not_exist' => false, 'disponibilite_id_not_exist' => true,
                    'recommandation_id_not_exist' => false, 'forme_juridique_id_not_exist' => false, 'profil_id_not_exist' => false,
                    'experience_geographique_id_not_exist' => false, 'domaine_id_not_exist' => false], 400);
            }
        }

        //on vérifie si recommandation_id existe dans la table recommandation
        $check = \DB::table('recommandation')
            ->where('id','=',$recommandation_id)
            ->first();

        if(empty($check)){
            /*return response()->json(['message' => 'error', 'remplir_tous_les_champs' => false, 'statut_id_not_exist' => false, 'disponibilite_id_not_exist' => false,
                                       'recommandation_id_not_exist' => true, 'forme_juridique_id_not_exist' => false, 'profil_id_not_exist' => false,
                                       'experience_geographique_id_not_exist' => false, 'domaine_id_not_exist' => false], 400);*/
            
            //I check if recommandation_name already exist
            $check_recommandation = \DB::table('recommandation')
                ->where('intitule','=',$recommandation_name)
                ->first();

            if(empty($check_recommandation)){
                \DB::table('recommandation')
                    ->insert([
                        [
                            'intitule' => $recommandation_name,
                            'description' => $recommandation_name,
                            'created_at' => Carbon::now(),
                            'updated_at' => Carbon::now()
                        ]
                    ]);

                $recommandation_id = DB::getPdo()->lastInsertId();
                
            }
            else{
                $recommandation_id = $check_recommandation->id;
            }

        }

        //on vérifie si forme_juridique_id existe dans la table forme_juridique
        if($forme_juridique_id != NULL){
            $check = \DB::table('forme_juridique')
                ->where('id','=',$forme_juridique_id)
                ->first();

            if(empty($check)){
                return response()->json(['message' => 'error', 'remplir_tous_les_champs' => false, 'statut_id_not_exist' => false, 'disponibilite_id_not_exist' => false,
                    'recommandation_id_not_exist' => false, 'forme_juridique_id_not_exist' => true, 'profil_id_not_exist' => false,
                    'experience_geographique_id_not_exist' => false, 'domaine_id_not_exist' => false], 400);
            }
        }  

        //on vérifie si profil_id existe dans la table profil
        if(sizeof($liste_profil) != 0){
            for($i=0; $i<sizeof($liste_profil); $i++){
                $profil_id = $liste_profil[$i]->profil_id;

                $check = \DB::table('profil')
                    ->where('id','=',$profil_id)
                    ->first();
                if(empty($check)){
                    return response()->json(['message' => 'error', 'remplir_tous_les_champs' => false, 'statut_id_not_exist' => false, 'disponibilite_id_not_exist' => false,
                        'recommandation_id_not_exist' => false, 'forme_juridique_id_not_exist' => false, 'profil_id_not_exist' => true,
                        'experience_geographique_id_not_exist' => false, 'domaine_id_not_exist' => false], 400);
                }
            }
        }

        //on vérifie si experience_geographique_id existe dans la table experience_geographique
        if(sizeof($liste_experience_geographique) != 0){
            for($i=0; $i<sizeof($liste_experience_geographique); $i++){
                $experience_geographique_id = $liste_experience_geographique[$i]->experience_geographique_id;

                $check = \DB::table('experience_geographique')
                    ->where('id','=',$experience_geographique_id)
                    ->first();
                if(empty($check)){
                    return response()->json(['message' => 'error', 'remplir_tous_les_champs' => false, 'statut_id_not_exist' => false, 'disponibilite_id_not_exist' => false,
                        'recommandation_id_not_exist' => false, 'forme_juridique_id_not_exist' => false, 'profil_id_not_exist' => false,
                        'experience_geographique_id_not_exist' => true, 'domaine_id_not_exist' => false], 400);
                }
            }
        }

        //on vérifie si domaine_id existe dans la table domaines
        if(sizeof($liste_domaine_expertise) != 0){
            for($i=0; $i<sizeof($liste_domaine_expertise); $i++){
                $domaine_id = $liste_domaine_expertise[$i]->domaine_id;

                $check = \DB::table('domaines')
                    ->where('id','=',$domaine_id)
                    ->first();
                if(empty($check)){
                    return response()->json(['message' => 'error', 'remplir_tous_les_champs' => false, 'statut_id_not_exist' => false, 'disponibilite_id_not_exist' => false,
                        'recommandation_id_not_exist' => false, 'forme_juridique_id_not_exist' => false, 'profil_id_not_exist' => false,
                        'experience_geographique_id_not_exist' => false, 'domaine_id_not_exist' => true], 400);
                }
            }
        }


        //je remplis le nbre_annee_creation
        $annee_tableau = explode("-", $annee_creation);
        $annee_annee_creation = (int) $annee_tableau[0];

        $annee_courante = date('Y');
        $annee_courante = (int) $annee_courante;

        $age = $annee_courante - $annee_annee_creation;


        //je prends le nbre_annee_experience
        $annee_tableau = explode("-", $date1ereAnneeExperienceEnTantQueONG);
        $annee_experience = (int) $annee_tableau[0];

        $annee_courante = date('Y');
        $annee_courante = (int) $annee_courante;

        $nbre_annee_experience = $annee_courante - $annee_experience;

        //j'enregistre d'abord les infos principales de la table ong_association
        
        /*
        \DB::table('ong_association')
            ->insert([
                [
                    'user_id' => $user_id,
                    'statut_id' => $statut_id,
                    'disponibilite_id' => $disponibilite_id,
                    'recommandation_id' => $recommandation_id,
                    'nom' => $nom,
                    'sigle' => $sigle,
                    'forme_juridique_id' => $forme_juridique_id,
                    'annee_creation' => $annee_creation,
                    'nbre_annee_creation' => $age,
                    'registre_commerce' => $registre_commerce,
                    'siege_social' => $siege_social,
                    'date1ereAnneeExperienceEnTantQueONG' => $date1ereAnneeExperienceEnTantQueONG,
                    'nbre_annee_experience' => $nbre_annee_experience,
                    'experienceAvecCooperationAllemande' => $experienceAvecCooperationAllemande,
                    'experienceAvecLesNationsUnies' => $experienceAvecLesNationsUnies,
                    'experienceAvecLesAutresPartenaires' => $experienceAvecLesAutresPartenaires,
                    'adresse' => $adresse,
                    'nom_principal_dirigeant' => $nom_principal_dirigeant,
                    'prenom_principal_dirigeant' => $prenom_principal_dirigeant,
                    'telephone_principal_dirigeant' => $telephone_principal_dirigeant,
                    'courriel_principal_dirigeant' => $courriel_principal_dirigeant,
                    'created_at' => Carbon::now(),
                    'updated_at' => Carbon::now()
                ]
            ]);
            */

         \DB::table('ong_association')
                    ->where('id','=',$ong_association_id)
                    ->update([
                        'user_id' => $user_id,
                        'statut_id' => $statut_id,
                        'disponibilite_id' => $disponibilite_id,
                        'recommandation_id' => $recommandation_id,
                        'nom' => $nom,
                        'sigle' => $sigle,
                        'forme_juridique_id' => $forme_juridique_id,
                        'annee_creation' => $annee_creation,
                        'nbre_annee_creation' => $age,
                        'registre_commerce' => $registre_commerce,
                        'siege_social' => $siege_social,
                        'date1ereAnneeExperienceEnTantQueONG' => $date1ereAnneeExperienceEnTantQueONG,
                        'nbre_annee_experience' => $nbre_annee_experience,
                        'experienceAvecCooperationAllemande' => $experienceAvecCooperationAllemande,
                        'experienceAvecLesNationsUnies' => $experienceAvecLesNationsUnies,
                        'experienceAvecLesAutresPartenaires' => $experienceAvecLesAutresPartenaires,
                        'adresse' => $adresse,
                        'nom_principal_dirigeant' => $nom_principal_dirigeant,
                        'prenom_principal_dirigeant' => $prenom_principal_dirigeant,
                        'telephone_principal_dirigeant' => $telephone_principal_dirigeant,
                        'courriel_principal_dirigeant' => $courriel_principal_dirigeant,
                        'updated_at' => Carbon::now()
                    ]);     

        //maintenant je récupère le user_id pour pouvoir save les autres infos file_cabinet_bureau_etude, profils, experience_geographique, domaines, contacts et courriels
        $user = \DB::table('ong_association')
            ->where('id','=',$ong_association_id)
            ->first();

        define('CHEMIN_CV','/usr/www/users/amberm/public/'); 

        if(!empty($user)){
            $user_id = $user->id;
            $ref_user = $user->ref_user;     //ONGASSOC = ONG / Association

             //je supprime tous les files de ONG ou Association avec ref_user avec les fichiers files stockés
            $files_ong_association = \DB::table('file_ong_association')
                ->where('ref_user','=',$ref_user)
                ->get();


            if(!empty($files_ong_association)){
                foreach ($files_ong_association as $file) {
                    $chemin = $file->file;
                    unlink(CHEMIN_CV . $chemin);    //qui va delete le fichier dans le dossier /img/uploads
                }
            }    


            \DB::table('file_ong_association')
                ->where('ref_user','=',$ref_user)
                ->delete();

            //je supprime tous les profils de l'ONG ou association avec ref_user
            \DB::table('profil_users')
                ->where('ref_user','=',$ref_user)
                ->delete();

            //je supprime toutes les expériences géographiques de l'ONG ou association avec ref_user
            \DB::table('experience_geographique_users')
                ->where('ref_user','=',$ref_user)
                ->delete();

            //je supprime tous les domaines d'expertises et professionnels de l'ONG ou association avec ref_user
            \DB::table('domaine_expertise_users')
                ->where('ref_user','=',$ref_user)
                ->delete();

            //je supprime tous les téléphones de l'ONG ou association avec ref_user
            \DB::table('contact_users')
                ->where('ref_user','=',$ref_user)
                ->delete();

            //je supprime tous les courriels (emails) de l'ONG ou association avec ref_user
            \DB::table('courriel_users')
                ->where('ref_user','=',$ref_user)
                ->delete();

            //j'enregistre d'abord les CVs du consultant
            //define('UPLOAD_DIR','/home/mooevents/public_html/img/uploads/');
            //define('UPLOAD_DIR','/Applications/MAMP/htdocs/giz_frontend/public/img/uploads/Files_cabinet_bureau_etude/');
            //define('UPLOAD_DIR','/home/apivisavis/public_html/giz/img/uploads/Files_ong_association/');
            define('UPLOAD_DIR','/usr/www/users/amberm/public/img/uploads/Files_ong_association/');

            if($liste_files != ""){
                if(sizeof($liste_files) != 0){
                    for($i=0; $i<sizeof($liste_files); $i++){
    
                        $ref_file = str_random(4);
    
                        $pdf = $liste_files[$i]->file;
                        $data = base64_decode($pdf);
                        //$nom = uniqid() . '.pdf';
                        $name = 'ONGAssoc_'.$nom.'_'.$sigle.'_'.'Ref_'.$ref_file. '.pdf';        //ONGAssoc = ONG / Association
                        $file = UPLOAD_DIR . $name;
                        $chemin='img/uploads/Files_ong_association/'.$name ;
                        file_put_contents($file, $data);        //pour upload le fichier dans le dossier du chemin UPLOAD_DIR
    
                        //extraction du contenu du fichier concernant le cabinet d'études et stockage
                        $text = (new Pdf())
                            ->setPdf($file)
                            ->text();
    
                        \DB::table('file_ong_association')
                            ->insert([
                                [
                                    'file' => $chemin,
                                    'file_en_base_64' => $pdf,
                                    'ref_user' => $ref_user,
                                    'ref_file' => $ref_file,
                                    'contenu_file' => $text,
                                    'created_at' => Carbon::now(),
                                    'updated_at' => Carbon::now()
                                ]
                            ]);
                    }
                }
            }
            

            //j'enregistre les profils du consultant
            if(sizeof($liste_profil) != 0){
                for($i=0; $i<sizeof($liste_profil); $i++){
                    $profil_id = $liste_profil[$i]->profil_id;

                    \DB::table('profil_users')
                        ->insert([
                            [
                                'profil_id' => $profil_id,
                                'ref_user' => $ref_user,
                                'type' => $type,
                                'created_at' => Carbon::now(),
                                'updated_at' => Carbon::now()
                            ]
                        ]);
                }
            }

            //j'enregistre les expériences géographiques du consultant
            if(sizeof($liste_experience_geographique) != 0){
                for($i=0; $i<sizeof($liste_experience_geographique); $i++){
                    $experience_geographique_id = $liste_experience_geographique[$i]->experience_geographique_id;

                    \DB::table('experience_geographique_users')
                        ->insert([
                            [
                                'experience_geographique_id' => $experience_geographique_id,
                                'ref_user' => $ref_user,
                                'type' => $type,
                                'created_at' => Carbon::now(),
                                'updated_at' => Carbon::now()
                            ]
                        ]);
                }
            }

            //j'enregistre les domaines d'expertise et professionnels du consultant
            if(sizeof($liste_domaine_expertise) != 0){
                for($i=0; $i<sizeof($liste_domaine_expertise); $i++){
                    $domaine_id = $liste_domaine_expertise[$i]->domaine_id;
                    $nbre_consultation = $liste_domaine_expertise[$i]->nbre_consultation;

                    \DB::table('domaine_expertise_users')
                        ->insert([
                            [
                                'domaine_id' => $domaine_id,
                                'nbre_consultation' => $nbre_consultation,
                                'ref_user' => $ref_user,
                                'type' => $type,
                                'created_at' => Carbon::now(),
                                'updated_at' => Carbon::now()
                            ]
                        ]);
                }
            }

            //j'enregistre les téléphones du consultant
            if(sizeof($liste_telephone) != 0){
                for($i=0; $i<sizeof($liste_telephone); $i++){
                    $telephone = $liste_telephone[$i]->telephone;

                    \DB::table('contact_users')
                        ->insert([
                            [
                                'telephone' => $telephone,
                                'ref_user' => $ref_user,
                                'type' => $type,
                                'created_at' => Carbon::now(),
                                'updated_at' => Carbon::now()
                            ]
                        ]);
                }
            }

            //j'enregistre les courriels (emails) du consultant
            if(sizeof($liste_courriel) != 0){
                for($i=0; $i<sizeof($liste_courriel); $i++){
                    $email = $liste_courriel[$i]->email;

                    \DB::table('courriel_users')
                        ->insert([
                            [
                                'email' => $email,
                                'ref_user' => $ref_user,
                                'type' => $type,
                                'created_at' => Carbon::now(),
                                'updated_at' => Carbon::now()
                            ]
                        ]);
                }
            }

        }

        return response()->json(['message' => 'success']);
    }



    //permet de supprimer les infos d'une ONG ou Association
        public function deleteONGAssociation($ong_association_id,$token){
        $request = Request::instance();
        $data = json_decode($request->getContent());

        //je vérifie si ong_association_id existe bien en BD
        $check_ong_association_id = \DB::table('ong_association')
            ->where('id','=',$ong_association_id)
            ->first();

        if(empty($check_ong_association_id)){
            return response()->json(['user_not_found' => false, 'ong_association_id_not_exist' => true], 401);
        } 

        //je vérifie le token
        $check = \DB::table('users')
            ->where('remember_token','=',$token)
            ->first();

            //dd($check);

        if(empty($check)){
            return response()->json(['user_not_found' => true, 'ong_association_id_not_exist' => false], 401);
        }    

        
        //maintenant je récupère le user_id pour pouvoir save les autres infos file_cabinet_bureau_etude, profils, experience_geographique, domaines, contacts et courriels
        $user = \DB::table('ong_association')
            ->where('id','=',$ong_association_id)
            ->first();

        define('CHEMIN_CV','/usr/www/users/amberm/public/'); 
        
        if(!empty($user)){
            $user_id = $user->id;
            $ref_user = $user->ref_user;     //ONGASSOC = ONG / Association

             //je supprime tous les files de ONG ou Association avec ref_user avec les fichiers files stockés
            $files_ong_association = \DB::table('file_ong_association')
                ->where('ref_user','=',$ref_user)
                ->get();


            if(!empty($files_ong_association)){
                foreach ($files_ong_association as $file) {
                    $chemin = $file->file;
                    unlink(CHEMIN_CV . $chemin);    //qui va delete le fichier dans le dossier /img/uploads
                }
            }    


            \DB::table('file_ong_association')
                ->where('ref_user','=',$ref_user)
                ->delete();

            //je supprime tous les profils de l'ONG ou association avec ref_user
            \DB::table('profil_users')
                ->where('ref_user','=',$ref_user)
                ->delete();

            //je supprime toutes les expériences géographiques de l'ONG ou association avec ref_user
            \DB::table('experience_geographique_users')
                ->where('ref_user','=',$ref_user)
                ->delete();

            //je supprime tous les domaines d'expertises et professionnels de l'ONG ou association avec ref_user
            \DB::table('domaine_expertise_users')
                ->where('ref_user','=',$ref_user)
                ->delete();

            //je supprime tous les téléphones de l'ONG ou association avec ref_user
            \DB::table('contact_users')
                ->where('ref_user','=',$ref_user)
                ->delete();

            //je supprime tous les courriels (emails) de l'ONG ou association avec ref_user
            \DB::table('courriel_users')
                ->where('ref_user','=',$ref_user)
                ->delete();


            //je finis par la suppression de l'ONG ou association    
            \DB::table('ong_association')
                ->where('id','=',$ong_association_id)
                ->delete();      


        }

        return response()->json(['message' => 'success']);
    }  





}
