<?php namespace App\Models;

use Illuminate\Auth\Authenticatable;
use Illuminate\Database\Eloquent\Model;
use Illuminate\Auth\Passwords\CanResetPassword;
use Illuminate\Contracts\Auth\Authenticatable as AuthenticatableContract;
use Illuminate\Contracts\Auth\CanResetPassword as CanResetPasswordContract;

class NiveauScolaire extends Model implements AuthenticatableContract, CanResetPasswordContract {

    use Authenticatable, CanResetPassword;

    /**
     * The database table used by the model.
     *
     * @var string
     */
    protected $table = 'niveauscolaires';

    protected $fillable = [
        'original_id',
        'user_id',
        'nom_diplome',
        'date_obtention',
        'ecole',
        'filiere',
        'statut_update'
    ];

    public function users(){
        return $this->belongsTo('App\Models\User');
    }



}