<?php namespace App\Models;

use Illuminate\Auth\Authenticatable;
use Illuminate\Database\Eloquent\Model;
use Illuminate\Auth\Passwords\CanResetPassword;
use Illuminate\Contracts\Auth\Authenticatable as AuthenticatableContract;
use Illuminate\Contracts\Auth\CanResetPassword as CanResetPasswordContract;

class Voyage extends Model implements AuthenticatableContract, CanResetPasswordContract {

    use Authenticatable, CanResetPassword;

    /**
     * The database table used by the model.
     *
     * @var string
     */
    protected $table = 'voyages';

    protected $fillable = [
        'original_id',
        'user_id',
        'pays',
        'ville',
        'motif',
        'date_debut',
        'date_fin',
        'occurence',
        'statut_update'
    ];

    public function users(){
        return $this->belongsTo('App\Models\User');
    }



}