@extends('public.template1')

@section('head')

  {!! HTML::style('ckeditor/plugins/codesnippet/lib/highlight/styles/default.css') !!}

@stop

@section('main')

  <!-- Entête de page -->
  @include('back.partials.entete', ['title' => trans('back/countries.dashboard'), 'icone' => 'pencil', 'fil' => link_to('blog', 'Countries') . ' / ' . trans('back/countries.update')])

  <div class="col-sm-12">
    @yield('form')

    {!! Form::model($country, ['route' => ['countries.update', $country->id], 'method' => 'put', 'class' => 'form-horizontal panel']) !!}
    {!! Form::control('text', 0, 'name', $errors, trans('back/countries.name')) !!}
    {!! Form::submit(trans('front/form.send')) !!}

    {!! Form::close() !!}
  </div>

@stop

@section('scripts')

  {!! HTML::script('ckeditor/ckeditor.js') !!}
  
  <script>

  var config = {
    codeSnippet_theme: 'Monokai',
    language: '{{ config('app.locale') }}',
    height: 100,
    toolbarGroups: [
      { name: 'clipboard',   groups: [ 'clipboard', 'undo' ] },
      { name: 'editing',     groups: [ 'find', 'selection', 'spellchecker' ] },
      { name: 'links' },
      { name: 'insert' },
      { name: 'forms' },
      { name: 'tools' },
      { name: 'document',    groups: [ 'mode', 'document', 'doctools' ] },
      { name: 'others' },
      //'/',
      { name: 'basicstyles', groups: [ 'basicstyles', 'cleanup' ] },
      { name: 'paragraph',   groups: [ 'list', 'indent', 'blocks', 'align', 'bidi' ] },
      { name: 'styles' },
      { name: 'colors' }
    ]
  };

  CKEDITOR.replace( 'summary', config);

  config['height'] = 400;   

  CKEDITOR.replace( 'content', config);

  $("#title").keyup(function(){
      var str = sansAccent($(this).val());
      str = str.replace(/[^a-zA-Z0-9\s]/g,"");
      str = str.toLowerCase();
      str = str.replace(/\s/g,'-');
      $("#permalien").val(str);        
    });

  </script>

@stop