@extends('meeting.template')






@section('head')

    {!! HTML::style('ckeditor/plugins/codesnippet/lib/highlight/styles/default.css') !!}



@section('main')

    <div class="col-sm-9 col-sm-offset-3 col-lg-10 col-lg-offset-2 main">
        <div class="row">
            <ol class="breadcrumb">
                <li><a href="#"><svg class="glyph stroked home"><use xlink:href="#stroked-home"></use></svg></a></li>
                <li class="active">Accueil</li>
            </ol>
        </div><!--/.row-->




        <!-- Entête de page -->
        @include('back.partials.entete', ['title' => trans('Dashboard Promoteur'), 'icone' => 'pencil', 'fil' => link_to('blog', 'Promoteurs') . ' / ' . trans('promoteurs.update')])

        <div class="row">
            <div class="col-lg-12">
                <div class="panel panel-default">
                    <div class="panel-heading">Formulaire Promoteur</div>
                    <div class="panel-body">
                        <div class="col-md-6">

                            <div class="col-sm-12">
                                @yield('form')

                                {!! Form::model($promoteur, ['route' => ['promoteurs.update', $promoteur->id], 'method' => 'put', 'class' => 'form-horizontal panel']) !!}
                                {!! Form::control('text', 0, 'name', $errors, trans('Name')) !!}
                                {!! Form::control('email', 0, 'email', $errors, trans('Email')) !!}
                                {!! Form::control('number', 0, 'phone', $errors, trans('Phone')) !!}

                                @for ($i = 0; $i < count($promoteur->evenements); $i++)
                                    {!! Form::bootselectbutton('evenements', 1, 'Evenement :', $evenements, $promoteur->evenements[$i]->id) !!}
                                @endfor

                                <!--
                                <div class="row">
                                    <button id="add" type="button" class="btn btn-primary pull-right">Add an evenement</button>
                                </div>

                                -->

                                {!! Form::submit(trans('Envoyer')) !!}

                                {!! Form::close() !!}
                            </div>
                        </div>
                    </div>
                </div>




                @section('scripts')

                    {!! HTML::script('ckeditor/ckeditor.js') !!}


                    <script>

                        $(function(){

                            // Delete an author line
                            $(".btn-danger").click(function() {
                                // Delete if at least 2
                                if($('.line').length > 1) $(this).parents('.row .line').remove();
                            });


                            // Add an author line
                            $("#add").click(function()
                            {

                                // Check for last id
                                var max = id = 0;
                                $('.line').each(function()
                                {
                                    id = parseInt(($(this).attr('id')).slice(-1));
                                    if(id > max) max = id;
                                });

                                // First line
                                var clone = $('#lineevenements' + max).clone(true);
                                // Change id
                                clone.attr('id', 'lineevenements' + ++max);
                                // Change label for
                                clone.find('label').attr('for', 'evenement' + max);
                                // Change select id
                                clone.find('select').attr('id', 'evenement' + max);
                                // Add line
                                $('#lineevenements' + id).after(clone);
                            });

                            )}

                    </script>

            </div>
        </div>
    </div>
    </div><!-- /.col-->
    </div><!-- /.row -->

    </div>
    </div><!--/.main-->
    
    
