@extends('meeting.template')

@section('main')
    <link href="{{asset('css/bootstrap-table.css')}}" rel="stylesheet">
    <div class="col-sm-9 col-sm-offset-3 col-lg-10 col-lg-offset-2 main">
        <div class="row">
            <ol class="breadcrumb">
                <li><a href="{{url('/')}}"><svg class="glyph stroked home"><use xlink:href="#stroked-home"></use></svg></a></li>
                <!--<li class="active">Icons</li>-->
            </ol>
        </div><!--/.row-->
        <div class="row">
            <div class="col-lg-12">
                <h1 class="page-header">List of users</h1>
            </div>
        </div><!--/.row-->
        @if(session()->has('ok'))
            @include('partials/error', ['type' => 'success', 'message' => session('ok')])
        @endif

        <a href="{{ route('pdfview',['download'=>'pdf']) }}">Download PDF</a>
        <br/>
        <br/>

        <div class="row">

            <table data-toggle="table"  data-show-toggle="true" data-show-columns="true" data-search="true" data-select-item-name="toolbar1" data-pagination="true" data-sort-name="name" data-sort-order="desc">
                <thead>
                <tr>
                    <th data-field="name" data-sortable="true">No</th>
                    <th data-field="name" data-sortable="true">Username</th>
                    <th data-field="email"  data-sortable="true">Email</th>
                    <th data-field="role" data-sortable="true">Role</th>

                </tr>
                </thead>
                <tbody>

                @foreach($items as $key => $item)
                    <tr>
                        <td> {{ ++$key }}</td>
                        <td> {{$item->username}}</td>
                        <td> {{$item->email}}</td>
                        <td>@if($item->role_id == 1) Administrator @elseif($list->role_id == 2) Redactor @elseif($list->role_id == 3) User @endif</td>

                    </tr>
                @endforeach
                </tbody>
            </table>
        </div>
    </div>


@endsection

@section('footerscripts')
    <script src="{{asset('/js/jquery-1.11.1.min.js')}}"></script>
    <script src="{{asset('/js/bootstrap-table.js')}}"></script>

    <script type="text/javascript">
        function action(data){
            var id = $(data).attr('data-content');
            var action = $(data).attr('data-action');
            var element = $(data);
            $.ajax({
                url:'/moomeetings/invitation/update_inv',
                type:'POST',
                data:{'id':id,'action':action},
                success:function(data1){
                    //console.log(data1);
                    if(data1["status"] == true){
                        $(element).fadeOut(function(){
                            $(element).parents('tr').remove();
                        })
                    }
                },
                error:function(){
                }
            });
        }
    </script>
@stop